BubblePopup = class( Turbine.UI.Window );

function createBubblePopup(arg)
	if(BubblePopupInstance ~=nil) then
		BubblePopupInstance:Close();
	end
	if(type(arg) == "string") then
		BubblePopupInstance = BubblePopup(arg);
		BubblePopupInstance:UpdateBroadcast(nil);
	end
	return BubblePopupInstance;
end

function createBubblePopupForSharing(libelle, shareMsg, broadCanal, buttonMsg)
	if(BubblePopupInstance ~=nil) then
		BubblePopupInstance:Close();
	end	
	if(libelle~=nil and shareMsg~=nil) then
		BubblePopupInstance = BubblePopup(libelle);
		BubblePopupInstance:UpdateBroadcast(shareMsg, broadCanal, buttonMsg);		
	end
	return BubblePopupInstance;
end	

function BubblePopup:Constructor(text)
	Turbine.UI.Window.Constructor( self );
	local width, height = Turbine.UI.Display.GetSize();
	--self:SetSize( 290, 161 );
	self:SetSize( 250, 90 );
	local midwidth = math.floor(width/2);
	local midheight = math.floor(height/2);
	local defaultleft = tonumber(Preferences.quicklaunch_x);
	local defaulheight = tonumber(Preferences.quicklaunch_y);
	local index = "";
	if(midwidth < defaultleft) then
		self:SetLeft(defaultleft - self:GetWidth()+35);
		index = "r";
	else
		self:SetLeft(defaultleft);
		index = "l";
	end
	if(midheight < defaulheight) then
		self:SetTop(defaulheight - self:GetHeight() - 5);
		index = "d"..index;
	else
		self:SetTop(defaulheight + 40);
		index = "u"..index;
	end	
	if(Preferences.blablaTime == nil) then Preferences.blablaTime=15; end
	
	local background = Turbine.UI.Label();
	background:SetParent( self );
	background:SetBackground( "WalmPlugins/WarbandsSlayer/resources/bubble/tooltip2_"..index..".tga" );
	--background:SetBackColor( Turbine.UI.Color( 0.3, 0.3, 0.3 ) );
	background:SetPosition( 0, 0 );
	background:SetSize(self:GetWidth(), self:GetHeight() );
	background:SetMouseVisible( false );

	local closeBtn = Turbine.UI.Label();
	closeBtn:SetParent( self );
	closeBtn:SetBackground( "WalmPlugins/WarbandsSlayer/resources/bubble/close.jpg" );
	closeBtn:SetPosition( self:GetWidth()-23, 18);
	closeBtn:SetSize(16, 16);
	closeBtn.MouseClick = function( sender, args )
		self:Close();
	end
	closeBtn.MouseEnter = function( sender, args )
		closeBtn:SetBackground( "WalmPlugins/WarbandsSlayer/resources/bubble/close_roll.jpg" );
	end
	closeBtn.MouseLeave = function( sender, args )
		closeBtn:SetBackground( "WalmPlugins/WarbandsSlayer/resources/bubble/close.jpg" );
	end	
	
	local mainTextLabel = Turbine.UI.Label();
	mainTextLabel:SetParent( self );
	--mainTextLabel:SetFont(Turbine.UI.Lotro.Font.Verdana16);	
	mainTextLabel:SetText(text);
	--mainTextLabel:SetFontStyle( Turbine.UI.FontStyle.Outline );
	mainTextLabel:SetTextAlignment( Turbine.UI.ContentAlignment.TopCenter );
	mainTextLabel:SetPosition( 3, 28);
	mainTextLabel:SetSize(self:GetWidth()-6, 50);
    mainTextLabel:SetForeColor( Turbine.UI.Color( 0, 0, 0) );
	mainTextLabel:SetMouseVisible( false );	

	self.qsBroadcast = Turbine.UI.Lotro.Quickslot();
	self.qsBroadcast:SetParent(self);
	self.qsBroadcast:SetSize(120, 18);
	self.qsBroadcast:SetPosition((self:GetWidth()-self.qsBroadcast:GetWidth())/2, self:GetHeight()-22);
	self.qsBroadcast:SetVisible(true);	
	self.qsBroadcast:SetBackColor( Turbine.UI.Color( 0.6, 0, 0, 0 ) );
	self.qsBroadcast:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, "/dire walm <rgb=#FF5CCD>SCORE: 69</rgb>"));		
	self.qsBroadcast:SetAllowDrop(false);
	self.qsBroadcast:SetEnabled(false);
	self.qsBroadcast.MouseClick = function()
		
		self:Close();		
	end
	
	local c= Turbine.UI.Control();
	c:SetParent(self);
	c:SetSize(self.qsBroadcast:GetSize());
	c:SetPosition(self.qsBroadcast:GetLeft(),self.qsBroadcast:GetTop());
	c:SetMouseVisible(false);
	c:SetZOrder(10000);
	c:SetBackColor(Turbine.UI.Color( .7, .7, .7 ));
	self.qsLbl = c;
	
	self.c= Turbine.UI.Label()
	self.c:SetParent(self.qsLbl);
	self.c:SetPosition(1,1);
	self.c:SetBackColor(Turbine.UI.Color( 0, 0, 0 ));
	self.c:SetSize(self.qsLbl:GetWidth()-2,self.qsLbl:GetHeight()-2);
	self.c:SetFontStyle(Turbine.UI.FontStyle.Outline);
	self.c:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.c:SetMouseVisible(false);
	self.c:SetZOrder(10001);
	self.c:SetText(TRAD("Partager l'info", "Share the info"));
	
	self:SetVisible(true);
	self:SetWantsUpdates(true);
	self.counter = 0;
end

function BubblePopup:UpdateBroadcast( text , broadCanal, buttonMsg)
	if(text==nil) then
		self.qsBroadcast:SetVisible(false);
		self.qsLbl:SetVisible(false);
	else
		local canal = "/k";
		if(broadCanal~=nil) then
			canal = broadCanal;
		end
		self.qsBroadcast:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, canal.. " "..text));	
		self.qsBroadcast:SetVisible(true);
		self.qsLbl:SetVisible(true);
	end
	self.c:SetText(buttonMsg or TRAD("Partager l'info", "Share the info"));
end

function BubblePopup:Update( args )
	local delta = 0;
	local currentTime = Turbine.Engine.GetGameTime();
	if ( self.lastUpdate~=nil and self.lastUpdate > 0 ) then
		delta = currentTime - self.lastUpdate;
	end
	--Turbine.Shell.WriteLine("<rgb=#FF5CCD>UPDATE  - delta=".. delta .." - value="..  math.floor(self.blinker:GetValue()) .."/".. 

	self.lastUpdate = currentTime;
	self.counter = self.counter + delta;
	local timer = math.floor(self.counter);
	if(timer ~= self.lasttimer) then
		--self.bindCancelButton:SetText("Fermer (".. (30-timer) ..")");
		self.lasttimer = timer;
		if(timer>=(Preferences.blablaTime or 15)) then
			self:SetWantsUpdates(false);
			self:Close();
		end
	end
end