
import "WalmPlugins.WarbandsSlayer.src.DropDown";

ConfigurationDialog = class( Turbine.UI.Lotro.Window );

configurationDialogInstance = nil;
function GetConfigurationDialogInstance()
	if(configurationDialogInstance==nil) then
		configurationDialogInstance = ConfigurationDialog();
	end
	return configurationDialogInstance;
end

function ConfigurationDialog:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );

	local width, height = Turbine.UI.Display.GetSize();		
	self:SetSize( 400, 530 );
	self:SetPosition( width/2-self:GetWidth()/2, height/3-self:GetHeight()/2 );
	self:SetText( "Configuration" );
	
	self.container = Turbine.UI.Control();
	self.container:SetParent(self);
	self.container:SetPosition(3, 30);
	self.container:SetSize(self:GetWidth()-6, self:GetHeight()-40);
	self:BuildOpt1Frame();
	self:BuildOpt2Frame(); 
	self:BuildOpt3Frame();
	self:BuildOpt4Frame();
	self:BuildOpt5Frame();
	self:BuildOptVariousFrame();
	
	local buttonsTop = 465;
	local reinitButton = Turbine.UI.Lotro.Button();
	reinitButton:SetParent(self.container);
	reinitButton:SetPosition(30, buttonsTop);
	reinitButton:SetSize(100, 22);
	reinitButton:SetText(TRAD(ToUTF8("Rinitialiser"), "Reinitiate"));
	reinitButton.Click = function(sender, args)
		ReinitPreferences();
		Preferences.OnUpdate = function()
			self:UpdatePreferenceFields();
		end
		if(warbandsDialog~=nil) then
			warbandsDialog:ApplyPreferences();
		end
		if(quickLauncher~=nil) then
			quickLauncher:ApplyPreferences();
		end
		self:SetVisible(false);
		SavePreferences();
		self:Close();
	end

	self.validateButton = Turbine.UI.Lotro.Button();
	self.validateButton:SetParent(self.container);
	self.validateButton:SetPosition(150, buttonsTop);
	self.validateButton:SetSize(100, 20);
	self.validateButton:SetText(TRAD("Valider", "Validate"));
	self.validateButton:SetEnabled(false);
	self.validateButton.Click = function(sender, args)
		Preferences.canMoveQuickLauncher = self.opt2Checkbox:IsChecked();
		local pos = string.match(self.xTextArea:GetText(), '%d+');
		if(pos == nil) then pos = self.xTextArea.previousvalue; end
		Preferences.quicklaunch_x = pos;
		local pos = string.match(self.yTextArea:GetText(), '%d+');
		if(pos == nil) then pos = self.yTextArea.previousvalue; end
		Preferences.quicklaunch_y = pos;		
		
		local pos = string.match(self.xMiniTextArea:GetText(), '%d+');
		if(pos == nil) then pos = self.xMiniTextArea.previousvalue; end
		Preferences.minimap_x = pos;
		local pos = string.match(self.yMiniTextArea:GetText(), '%d+');
		if(pos == nil) then pos = self.yMiniTextArea.previousvalue; end
		Preferences.minimap_y = pos;		
		
		local selectedReset = self.opt1DropDown:GetText();	
		local hour = string.match(selectedReset, '%d+');	
		if(hour ~= nil) then Preferences.utcResetHour = tonumber(hour); end
		
		local selectedOpacity = self.opt3DropDown:GetText();	
		local opacity = string.match(selectedOpacity, '%d+');	
		if(opacity ~= nil) then Preferences.defaultOpacity = tonumber(opacity); end
		
		Preferences.debug = self.optDebugCheckbox:IsChecked();
		Preferences.autoUpdate = self.optAutoUpdateCheckbox:IsChecked();
		
		if(warbandsDialog~=nil) then
			warbandsDialog:ApplyPreferences();
		end
		if(quickLauncher~=nil) then
			quickLauncher:ApplyPreferences();
		end
		Preferences.chatCanal = self.opt4DropDown:GetText();
		self:SetVisible(false);
		SavePreferences();
		self:Close();
	end
	
	local cancelButton = Turbine.UI.Lotro.Button();
	cancelButton:SetParent(self.container);
	cancelButton:SetPosition(270, buttonsTop);
	cancelButton:SetSize(100, 20);
	cancelButton:SetText(TRAD("Annuler", "Cancel"));
	cancelButton.Click = function(sender, args)
		self:SetVisible(false);
		self:Close();
	end
	
	Preferences.OnUpdate = function()
		self:UpdatePreferenceFields();
	end
	
	-- Hide UI when F12 is pressed, code copied from Chiran sources
	local hideUI = false;
	local wasVisible;
	self:SetWantsKeyEvents(true);
	self.KeyDown = function(sender, args)
		if (args.Action == 268435635) then
			if not hideUI then
				hideUI = true;
				if self:IsVisible() then
					wasVisible = true;
					self:SetVisible(false);					
				else
					wasVisible = false;
				end
				-- settingsWindow:SetVisible(false);
				-- toggleWindow:SetVisible(false);
			else
				hideUI = false;
				if wasVisible then
					self:SetVisible(true);
					-- settingsWindow:SetVisible(false);					
				end
				-- if (Settings.ToggleVisible == "yes") then
					-- toggleWindow:SetVisible(true);
				-- end
			end
		end
	end		
end

function ConfigurationDialog:GetContainer()
	return self.container;
end

function ConfigurationDialog:UpdatePreferenceFields()
	self.xTextArea:SetText(Preferences.quicklaunch_x);
	self.yTextArea:SetText(Preferences.quicklaunch_y);
	self.xMiniTextArea:SetText(Preferences.minimap_x);
	self.yMiniTextArea:SetText(Preferences.minimap_x);
end

function ConfigurationDialog:CreateBlocFrame(x, y, width, height)
	-- local gabari = Turbine.UI.Label();
	-- gabari:SetParent( self.container );
	-- gabari:SetPosition(x, y);
	-- gabari:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	-- gabari:SetSize(width, height);
	-- gabari:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 1 ) );
	local borderTopLeft = Turbine.UI.Label();
	borderTopLeft:SetParent( self.container );
	borderTopLeft:SetPosition(x, y);
	borderTopLeft:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderTopLeft:SetSize(12, 12);
	borderTopLeft:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/corner_top_left.tga");	
	local borderBotLeft = Turbine.UI.Label();
	borderBotLeft:SetParent( self.container );
	borderBotLeft:SetPosition(x, y+height-12);
	borderBotLeft:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderBotLeft:SetSize(12, 12);
	borderBotLeft:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/corner_bot_left.tga");
	local borderTopRight = Turbine.UI.Label();
	borderTopRight:SetParent( self.container );
	borderTopRight:SetPosition(x+width-12, y);
	borderTopRight:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderTopRight:SetSize(12, 12);
	borderTopRight:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/corner_top_right.tga");	
	local borderBotRight = Turbine.UI.Label();
	borderBotRight:SetParent( self.container );
	borderBotRight:SetPosition(x+width-12, y+height-12);
	borderBotRight:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderBotRight:SetSize(12, 12);
	borderBotRight:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/corner_bot_right.tga");
	
	local borderTop = Turbine.UI.Label();
	borderTop:SetParent( self.container );
	borderTop:SetPosition(x+12, y);
	borderTop:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderTop:SetSize(width-24, 3);
	borderTop:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_top.tga");	
	local borderBot = Turbine.UI.Label();
	borderBot:SetParent( self.container );
	borderBot:SetPosition(x+12, y+height-3);
	borderBot:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderBot:SetSize(width-24, 3);
	borderBot:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_bot.tga");
	local borderLeft = Turbine.UI.Label();
	borderLeft:SetParent( self.container );
	borderLeft:SetPosition(x, y+12);
	borderLeft:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderLeft:SetSize(3, height-24);
	borderLeft:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_left.tga");		
	local borderRight = Turbine.UI.Label();
	borderRight:SetParent( self.container );
	borderRight:SetPosition(x+width-3, y+12);
	borderRight:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderRight:SetSize(3, height-24);
	borderRight:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_right.tga");		
end

function ConfigurationDialog:BuildOptVariousFrame()
	local bloctop = 400;
	local optDiversTitleLabel = Turbine.UI.Label();
	optDiversTitleLabel:SetParent( self.container );
	optDiversTitleLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);	
	optDiversTitleLabel:SetText(TRAD("Divers", "Diverse"));
	optDiversTitleLabel:SetPosition( 15, bloctop );
	optDiversTitleLabel:SetSize(300, 20);
	optDiversTitleLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	optDiversTitleLabel:SetMouseVisible( false );

	self.optDebugCheckbox = Turbine.UI.Lotro.CheckBox();
	self.optDebugCheckbox:SetParent( self.container );
	self.optDebugCheckbox:SetMultiline( false );
	self.optDebugCheckbox:SetPosition( 25, bloctop+30 );
	self.optDebugCheckbox:SetSize( 360, 20 );
	--opt3Checkbox:SetBackColor( Turbine.UI.Color( 1, 0.2, 0.2, 0.5 ) );
	self.optDebugCheckbox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	self.optDebugCheckbox:SetText( TRAD(ToUTF8(" Debug ?! (appliqu qu'au relancement)" ), "Debug ?! (applied at relaunch)"));
	self.optDebugCheckbox:SetChecked(Preferences.debug);
	self.optDebugCheckbox:SetMouseVisible( false );
	self.optDebugCheckbox.CheckedChanged = function(sender, args)
		self.validateButton:SetEnabled(true);
	end
	
	self:CreateBlocFrame(10, bloctop+20, 375, 40 );
end

function ConfigurationDialog:BuildOpt1Frame()
	local bloctop = 5;
	local opt1TitleLabel = Turbine.UI.Label();
	opt1TitleLabel:SetParent( self.container );
	opt1TitleLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);	
	opt1TitleLabel:SetText( ToUTF8(TRAD("Heure de rinitialisation:", "Time of quest reset:") ));
	opt1TitleLabel:SetPosition( 15, bloctop );
	opt1TitleLabel:SetSize(300, 20);
	opt1TitleLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	opt1TitleLabel:SetMouseVisible( false );
	
	local opt1TitleHelp = Turbine.UI.Label();
	opt1TitleHelp:SetParent( self.container );
	opt1TitleHelp:SetPosition( 210, bloctop-3 );
	opt1TitleHelp:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	opt1TitleHelp:SetSize(20, 20);
	opt1TitleHelp:SetBackground("WalmPlugins/WarbandsSlayer/resources/help20.tga");
	--opt1TitleHelp:SetMouseVisible( false );
	GenericTooltip(opt1TitleHelp, opt1TitleLabel:GetText(), TRAD(ToUTF8("Chaque qute de Troupe de Guerre est rinitialise  la mme heure.\nEn fonction des fuseaux horaires, il se peut que l'heure de rinitialisation change.\n\nLa premire option permet de changer vous mme cette heure, sans attendre un ventual patch.\n\nLa seconde option permet de couper la mise  jour de l'affichage des objectifs si vous tes connect  l'heure de rinitialisation (cela libre un peu de ressources du jeu)." ), "Quests reset at the same time.\nDepending on time zones, the reset time may change.\nThe first option allows you to change this time yourself, without waiting for a possible patch .\nThe second option turns off updating the objective display if you are logged in at reset time (this frees up some game resources)."));
	
	self.optAutoUpdateCheckbox = Turbine.UI.Lotro.CheckBox();
	self.optAutoUpdateCheckbox:SetParent( self.container );
	self.optAutoUpdateCheckbox:SetMultiline( false );
	self.optAutoUpdateCheckbox:SetPosition( 25, bloctop+55 );
	self.optAutoUpdateCheckbox:SetSize( 360, 20 );
	self.optAutoUpdateCheckbox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	self.optAutoUpdateCheckbox:SetText( TRAD(ToUTF8(" Mise  jour auto. de l'affichage  ".. Preferences.utcResetHour.."h" ), "Auto update at ".. Preferences.utcResetHour.."h"));
	self.optAutoUpdateCheckbox:SetChecked(Preferences.autoUpdate);
	self.optAutoUpdateCheckbox:SetMouseVisible( false );
	self.optAutoUpdateCheckbox.CheckedChanged = function(sender, args)
		self.validateButton:SetEnabled(true);
	end		
	
	local opt1HeaderLabel = Turbine.UI.Label();
	opt1HeaderLabel:SetParent( self.container );
	opt1HeaderLabel:SetText( TRAD(ToUTF8("Rinitialisation  " ), "Reset at "));
	opt1HeaderLabel:SetPosition( 25, bloctop+35 );
	opt1HeaderLabel:SetSize(350, 20);
	opt1HeaderLabel:SetMouseVisible( false );
	
	local elementList = {};
	local selectedElement = nil;
	for i = 1, 24 do
		local value = "";
		if(i<10)then value = "0"; end
		value = value..i.."h00 "..TRAD("(heure locale)", "(local hour)");
		table.insert(elementList, value);
		if(i==Preferences.utcResetHour)then
			selectedElement = value;
		end
	end	
	self.opt1DropDown = DropDown.Create(elementList, selectedElement); -- table that contains the list, default selected value for the list
	self.opt1DropDown:SetParent(self.container);
	self.opt1DropDown:SetPosition( 175, bloctop+30 );
	self.opt1DropDown.myElementList = elementList;
	--opt1DropDown:SetSize(300, 20);
	self.opt1DropDown:ApplyWidth(175); -- set the width of the menu, this is not essential to include as the default is a good size.
	self.opt1DropDown:SetMaxItems(8); -- Number of items to display in the drop down before a scrollbar is needed.. default value is 7 where this is excluded.
	--opt1DropDown:SetPosition(x,y);
	self.opt1DropDown:SetVisible(true);
	self.opt1DropDown.ItemChanged = function ()
		local hourReset = string.match(self.opt1DropDown:GetText(), '%d+');	
		self.optAutoUpdateCheckbox:SetText( TRAD(ToUTF8(" Mise  jour auto. de l'affichage  "..hourReset.."h" ), "Auto update at ".. Preferences.utcResetHour.."h"));
		self.validateButton:SetEnabled(true);
	end
	
	self:CreateBlocFrame(10, bloctop+20, 375, 65 );

end

function ConfigurationDialog:BuildOpt2Frame()
	local bloctop = 100;
	local opt2TitleLabel = Turbine.UI.Label();
	opt2TitleLabel:SetParent( self.container );
	opt2TitleLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);	
	opt2TitleLabel:SetText( TRAD(ToUTF8("Position du lanceur:" ), "Launcher position:"));
	opt2TitleLabel:SetPosition( 15, bloctop );
	opt2TitleLabel:SetSize(300, 20);
	opt2TitleLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	opt2TitleLabel:SetMouseVisible( false );
	
	local opt2TitleHelp = Turbine.UI.Label();
	opt2TitleHelp:SetParent( self.container );
	opt2TitleHelp:SetPosition( 175, bloctop-3 );
	opt2TitleHelp:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	opt2TitleHelp:SetSize(20, 20);
	opt2TitleHelp:SetBackground("WalmPlugins/WarbandsSlayer/resources/help20.tga");
	--opt1TitleHelp:SetMouseVisible( false );
	GenericTooltip(opt2TitleHelp, opt2TitleLabel:GetText(), TRAD(ToUTF8("Il se peut que le racourcis de lancement de l'interface soit masqu sous d'autre lments d'interface. Ainsi, si il vous est impossible de le dplacer  la souris, vous pouvez le faire ici." ), "The Quicklauncher may be hidden under other interface elements. So if you can't move it with the mouse, you can do so here."));
	
	local opt3HeaderLabel = Turbine.UI.Label();
	opt3HeaderLabel:SetParent( self.container );
	opt3HeaderLabel:SetText( TRAD("Position en pixels x=            y=","Position in pixels x=            y=") );
	opt3HeaderLabel:SetPosition( 25, bloctop+35 );
	opt3HeaderLabel:SetSize(350, 20);
	opt3HeaderLabel:SetMouseVisible( false );
	
	local xTextAreaBackground = Turbine.UI.Window();
	xTextAreaBackground:SetParent( self.container );	
	xTextAreaBackground:SetSize(55, 18);
	xTextAreaBackground:SetBackColor(Turbine.UI.Color(0.63,0.63,0.63));
	xTextAreaBackground:SetPosition( 185, bloctop+30 );
	xTextAreaBackground:SetVisible(true);
	xTextAreaBackground:SetMouseVisible(false);	
	self.xTextArea =  Turbine.UI.TextBox();
	self.xTextArea:SetParent( xTextAreaBackground );
	self.xTextArea:SetText(Preferences.quicklaunch_x);
	self.xTextArea:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	self.xTextArea:SetPosition( 2, 2 );
	self.xTextArea:SetForeColor(Turbine.UI.Color((229/255),(209/255),(136/255)));
	self.xTextArea:SetBackColor(Turbine.UI.Color( 0, 0, 0 ));
	self.xTextArea:SetSize(xTextAreaBackground:GetWidth()-4, xTextAreaBackground:GetHeight()-4);
	self.xTextArea:SetMultiline(false);
	self.xTextArea.previousvalue = Preferences.quicklaunch_x;
	self.xTextArea.FocusGained = function(sender, args)
		self.xTextArea.previousvalue = self.xTextArea:GetText();
	end	
	self.xTextArea.FocusLost = function(sender, args)
		local value = self.xTextArea:GetText();
		local pos = string.match(value, '%d+');
		if(pos == nil) then pos = self.xTextArea.previousvalue; else self.validateButton:SetEnabled(true); end
		self.xTextArea:SetText(pos);
	end
	
	local yTextAreaBackground = Turbine.UI.Window();
	yTextAreaBackground:SetParent( self.container );	
	yTextAreaBackground:SetSize(55, 18);
	yTextAreaBackground:SetBackColor(Turbine.UI.Color(0.63,0.63,0.63));
	yTextAreaBackground:SetPosition( 293, bloctop+30 );
	yTextAreaBackground:SetVisible(true);
	yTextAreaBackground:SetMouseVisible(false);	
	self.yTextArea =  Turbine.UI.TextBox();
	self.yTextArea:SetParent( yTextAreaBackground );
	self.yTextArea:SetText(Preferences.quicklaunch_y);
	self.yTextArea:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	self.yTextArea:SetPosition( 2, 2 );
	self.yTextArea:SetForeColor(Turbine.UI.Color((229/255),(209/255),(136/255)));
	self.yTextArea:SetBackColor(Turbine.UI.Color( 0, 0, 0 ));
	self.yTextArea:SetSize(yTextAreaBackground:GetWidth()-4, yTextAreaBackground:GetHeight()-4);
	self.yTextArea:SetMultiline(false);
	self.yTextArea.previousvalue = Preferences.quicklaunch_y;
	self.yTextArea.FocusGained = function(sender, args)
		self.yTextArea.previousvalue = self.yTextArea:GetText();
	end	
	self.yTextArea.FocusLost = function(sender, args)
		local value = self.yTextArea:GetText();
		local pos = string.match(value, '%d+');
		if(pos == nil) then pos = self.yTextArea.previousvalue; else self.validateButton:SetEnabled(true); end
		self.yTextArea:SetText(pos);
	end	
	
	self.opt2Checkbox = Turbine.UI.Lotro.CheckBox();
	self.opt2Checkbox:SetParent( self.container );
	self.opt2Checkbox:SetMultiline( false );
	self.opt2Checkbox:SetPosition( 25, bloctop+55 );
	self.opt2Checkbox:SetSize( 360, 20 );
	--opt3Checkbox:SetBackColor( Turbine.UI.Color( 1, 0.2, 0.2, 0.5 ) );
	self.opt2Checkbox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	self.opt2Checkbox:SetText( TRAD(ToUTF8(" Permettre le dplacement  la souris" )," Allow Quicklauncher movements with the mouse"));
	self.opt2Checkbox:SetChecked(Preferences.canMoveQuickLauncher);
	self.opt2Checkbox:SetMouseVisible( false );
	self.opt2Checkbox.CheckedChanged = function(sender, args)
		self.validateButton:SetEnabled(true);
	end
	
	self:CreateBlocFrame(10, bloctop+20, 375, 65 );
end

function ConfigurationDialog:BuildOpt5Frame()
	local bloctop = 330;
	local opt2TitleLabel = Turbine.UI.Label();
	opt2TitleLabel:SetParent( self.container );
	opt2TitleLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);	
	opt2TitleLabel:SetText( TRAD("Position de la Minimap:", "Minimap position:" ));
	opt2TitleLabel:SetPosition( 15, bloctop );
	opt2TitleLabel:SetSize(300, 20);
	opt2TitleLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	opt2TitleLabel:SetMouseVisible( false );
	
	local opt2TitleHelp = Turbine.UI.Label();
	opt2TitleHelp:SetParent( self.container );
	opt2TitleHelp:SetPosition( 175, bloctop-3 );
	opt2TitleHelp:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	opt2TitleHelp:SetSize(20, 20);
	opt2TitleHelp:SetBackground("WalmPlugins/WarbandsSlayer/resources/help20.tga");
	--opt1TitleHelp:SetMouseVisible( false );
	GenericTooltip(opt2TitleHelp, opt2TitleLabel:GetText(), TRAD(ToUTF8("La position de la minimap est sauvegarde. Vous pouvez rinitialiser la position." ), "The position of the minimap is saved. You can reset the position."));
	
	local opt3HeaderLabel = Turbine.UI.Label();
	opt3HeaderLabel:SetParent( self.container );
	opt3HeaderLabel:SetText( TRAD("Position en pixels x=            y=","Position in pixels x=            y=") );
	opt3HeaderLabel:SetPosition( 25, bloctop+35 );
	opt3HeaderLabel:SetSize(350, 20);
	opt3HeaderLabel:SetMouseVisible( false );
	
	local xTextAreaBackground = Turbine.UI.Window();
	xTextAreaBackground:SetParent( self.container );	
	xTextAreaBackground:SetSize(55, 18);
	xTextAreaBackground:SetBackColor(Turbine.UI.Color(0.63,0.63,0.63));
	xTextAreaBackground:SetPosition( 185, bloctop+30 );
	xTextAreaBackground:SetVisible(true);
	xTextAreaBackground:SetMouseVisible(false);	
	self.xMiniTextArea =  Turbine.UI.TextBox();
	self.xMiniTextArea:SetParent( xTextAreaBackground );
	self.xMiniTextArea:SetText(Preferences.minimap_x);
	self.xMiniTextArea:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	self.xMiniTextArea:SetPosition( 2, 2 );
	self.xMiniTextArea:SetForeColor(Turbine.UI.Color((229/255),(209/255),(136/255)));
	self.xMiniTextArea:SetBackColor(Turbine.UI.Color( 0, 0, 0 ));
	self.xMiniTextArea:SetSize(xTextAreaBackground:GetWidth()-4, xTextAreaBackground:GetHeight()-4);
	self.xMiniTextArea:SetMultiline(false);
	self.xMiniTextArea.previousvalue = Preferences.minimap_x;
	self.xMiniTextArea.FocusGained = function(sender, args)
		self.xMiniTextArea.previousvalue = self.xMiniTextArea:GetText();
	end	
	self.xMiniTextArea.FocusLost = function(sender, args)
		local value = self.xMiniTextArea:GetText();
		local pos = string.match(value, '%d+');
		if(pos == nil) then pos = self.xMiniTextArea.previousvalue; else self.validateButton:SetEnabled(true); end
		self.xMiniTextArea:SetText(pos);
	end
	
	local yTextAreaBackground = Turbine.UI.Window();
	yTextAreaBackground:SetParent( self.container );	
	yTextAreaBackground:SetSize(55, 18);
	yTextAreaBackground:SetBackColor(Turbine.UI.Color(0.63,0.63,0.63));
	yTextAreaBackground:SetPosition( 293, bloctop+30 );
	yTextAreaBackground:SetVisible(true);
	yTextAreaBackground:SetMouseVisible(false);	
	self.yMiniTextArea =  Turbine.UI.TextBox();
	self.yMiniTextArea:SetParent( yTextAreaBackground );
	self.yMiniTextArea:SetText(Preferences.minimap_y);
	self.yMiniTextArea:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	self.yMiniTextArea:SetPosition( 2, 2 );
	self.yMiniTextArea:SetForeColor(Turbine.UI.Color((229/255),(209/255),(136/255)));
	self.yMiniTextArea:SetBackColor(Turbine.UI.Color( 0, 0, 0 ));
	self.yMiniTextArea:SetSize(yTextAreaBackground:GetWidth()-4, yTextAreaBackground:GetHeight()-4);
	self.yMiniTextArea:SetMultiline(false);
	self.yMiniTextArea.previousvalue = Preferences.minimap_y;
	self.yMiniTextArea.FocusGained = function(sender, args)
		self.yMiniTextArea.previousvalue = self.yMiniTextArea:GetText();
	end	
	self.yMiniTextArea.FocusLost = function(sender, args)
		local value = self.yMiniTextArea:GetText();
		local pos = string.match(value, '%d+');
		if(pos == nil) then pos = self.yMiniTextArea.previousvalue; else self.validateButton:SetEnabled(true); end
		self.yMiniTextArea:SetText(pos);
	end	
	
	self:CreateBlocFrame(10, bloctop+20, 375, 40);
end

function ConfigurationDialog:BuildOpt3Frame()
	local bloctop = 195;
	local opt3TitleLabel = Turbine.UI.Label();
	opt3TitleLabel:SetParent( self.container );
	opt3TitleLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);	
	opt3TitleLabel:SetText( TRAD(ToUTF8("Opacit du lanceur:" ), "Launcher opacity:"));
	opt3TitleLabel:SetPosition( 15, bloctop );
	opt3TitleLabel:SetSize(300, 20);
	opt3TitleLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	opt3TitleLabel:SetMouseVisible( false );
	
	local opt3TitleHelp = Turbine.UI.Label();
	opt3TitleHelp:SetParent( self.container );
	opt3TitleHelp:SetPosition( 170, bloctop-3 );
	opt3TitleHelp:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	opt3TitleHelp:SetSize(20, 20);
	opt3TitleHelp:SetBackground("WalmPlugins/WarbandsSlayer/resources/help20.tga");
	GenericTooltip(opt3TitleHelp, opt3TitleLabel:GetText(), TRAD(ToUTF8("Le lanceur est automatiquement masqu lorsque vous n'avez pas le curseur dessus. Vous pouvez dfinir ici l'opacit (degr de transparence)." ), "The launcher is automatically hidden when you don't have the cursor over it. You can define the opacity (degree of transparency) here."));

	self.opt3Checkbox = Turbine.UI.Label();
	self.opt3Checkbox:SetParent( self.container );
	self.opt3Checkbox:SetMultiline( false );
	self.opt3Checkbox:SetPosition( 25, bloctop+35 );
	self.opt3Checkbox:SetSize( 360, 20 );
	self.opt3Checkbox:SetText( TRAD("Opacit\195\169 du lanceur :", "Launcher opacity :") );
	
	local elementList = {};
	local selectedElement = nil;
	for i = 20, 90, 10 do
		local value = i.." %";
		table.insert(elementList, value);
		if(i==Preferences.defaultOpacity)then
			selectedElement = value;
		end
	end		
	self.opt3DropDown = DropDown.Create(elementList, selectedElement); -- table that contains the list, default selected value for the list
	self.opt3DropDown:SetParent(self.container);
	self.opt3DropDown:SetPosition( 195, bloctop+30 );
	self.opt3DropDown.myElementList = elementList;
	--opt3DropDown:SetSize(300, 20);
	self.opt3DropDown:ApplyWidth(70); -- set the width of the menu, this is not essential to include as the default is a good size.
	self.opt3DropDown:SetMaxItems(8); -- Number of items to display in the drop down before a scrollbar is needed.. default value is 7 where this is excluded.
	--opt3DropDown:SetPosition(x,y);
	self.opt3DropDown:SetVisible(true);
	self.opt3DropDown.ItemChanged = function ()
		self.validateButton:SetEnabled(true);
	end	
	
	self:CreateBlocFrame(10, bloctop+20, 375, 40 );
end

function ConfigurationDialog:BuildOpt4Frame()
	local bloctop = 265;
	local opt4TitleLabel = Turbine.UI.Label();
	opt4TitleLabel:SetParent( self.container );
	opt4TitleLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);	
	opt4TitleLabel:SetText( TRAD("Bulle de communication:", "Communication bubble:" ));
	opt4TitleLabel:SetPosition( 15, bloctop );
	opt4TitleLabel:SetSize(300, 20);
	opt4TitleLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	opt4TitleLabel:SetMouseVisible( false );
	
	local opt4TitleHelp = Turbine.UI.Label();
	opt4TitleHelp:SetParent( self.container );
	opt4TitleHelp:SetPosition( 210, bloctop-3 );
	opt4TitleHelp:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	opt4TitleHelp:SetSize(20, 20);
	opt4TitleHelp:SetBackground("WalmPlugins/WarbandsSlayer/resources/help20.tga");
	GenericTooltip(opt4TitleHelp, opt4TitleLabel:GetText(), TRAD(ToUTF8("Quand vous ciblez une Troupe de Guerre ou une Menace Itinrante, une bulle apparait sur le lanceur. Un clic dessus permet de communiquer sa position. Vous pouvez choisir le canal o le message est envoy." ), "When you target a Warband or a Roving Threat, a bubble appears on the launcher. Clicking on it allows you to communicate your position. You can choose the channel where the message is sent."));

	self.opt4Checkbox = Turbine.UI.Label();
	self.opt4Checkbox:SetParent( self.container );
	self.opt4Checkbox:SetMultiline( false );
	self.opt4Checkbox:SetPosition( 25, bloctop+35 );
	self.opt4Checkbox:SetSize( 360, 20 );
	self.opt4Checkbox:SetText( TRAD("Canal d'envoi :", "Send channel :") );
	
	local elementList = {TRAD("Canal Monde", "Worldwide channel"), TRAD("Canal R\195\169gional", "Regional channel"), TRAD("Canal de Confr\195\169rie", "Kinship channel"), TRAD("Canal de Communaut\195\169", "Fellowship channel"), TRAD("Canal du Raid", "Raid channel")};
	local selectedElement = nil;
	if(Preferences.chatCanal==nil) then
		selectedElement = elementList[1];
	else
		selectedElement = Preferences.chatCanal;
	end
	-- for i = 20, 90, 10 do
		-- local value = i.." %";
		-- table.insert(elementList, value);
		-- if(i==Preferences.defaultOpacity)then
			-- selectedElement = value;
		-- end
	-- end		
	self.opt4DropDown = DropDown.Create(elementList, selectedElement); -- table that contains the list, default selected value for the list
	self.opt4DropDown:SetParent(self.container);
	self.opt4DropDown:SetPosition( 165, bloctop+30 );
	self.opt4DropDown.myElementList = elementList;
	--opt3DropDown:SetSize(300, 20);
	self.opt4DropDown:ApplyWidth(180); -- set the width of the menu, this is not essential to include as the default is a good size.
	self.opt4DropDown:SetMaxItems(5); -- Number of items to display in the drop down before a scrollbar is needed.. default value is 7 where this is excluded.
	--opt3DropDown:SetPosition(x,y);
	self.opt4DropDown:SetVisible(true);
	self.opt4DropDown.ItemChanged = function ()
		self.validateButton:SetEnabled(true);
	end	
	
	self:CreateBlocFrame(10, bloctop+20, 375, 40 );
end

function ConfigurationDialog:GetName()
	return "WarbandsOptions";
end

function ConfigurationDialog:IsRunning()
	return ( self ~= nil );
end

function ConfigurationDialog:Stop()
	self = nil;
end