CustomDialog = class( Turbine.UI.Lotro.Window );

function CustomDialog:Constructor(title, contentText, validationButtonText, fct, showMe, neveraskAgainCode)
	Turbine.UI.Lotro.Window.Constructor( self );
	
	if(neveraskAgainCode~=nil and Preferences[neveraskAgainCode]==true) then
		if(fct~=nil) then fct(); end
		self:CloseMe();
		return;
	end	
	
	self:SetSize( 300, 200 );
	self:SetText( title );
	self:SetMouseVisible(true);
	
	local width, height = Turbine.UI.Display.GetSize();	
	self:SetPosition((width-300)/2, (height-200)/2);
	
	-- Hide UI when F12 is pressed, code copied from Chiran sources
	local hideUI = false;
	local wasVisible;
	self:SetWantsKeyEvents(true);
	self.KeyDown = function(sender, args)
		if (args.Action == 268435635) then
			if not hideUI then
				hideUI = true;
				if self:IsVisible() then
					wasVisible = true;
					self:SetVisible(false);					
				else
					wasVisible = false;
				end
			else
				hideUI = false;
				if wasVisible then
					self:SetVisible(true);				
				end
			end
		end
	end
	local contentLabel = Turbine.UI.Label();
	contentLabel:SetParent( self );
	contentLabel:SetFont(Turbine.UI.Lotro.Font.Verdana14);	
	contentLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);
	contentLabel:SetPosition( 10, 40 );
	contentLabel:SetSize(280, 2);
	local labelValuecrollBar = Turbine.UI.Lotro.ScrollBar();
    labelValuecrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
    labelValuecrollBar:SetParent( self );
    labelValuecrollBar:SetPosition( contentLabel:GetLeft()+contentLabel:GetWidth(), contentLabel:GetTop() );
    labelValuecrollBar:SetSize( 10, contentLabel:GetHeight() );
	contentLabel:SetVerticalScrollBar( labelValuecrollBar );
	contentLabel:SetText( contentText );
	while labelValuecrollBar:IsVisible() do
		contentLabel:SetHeight(contentLabel:GetHeight()+2);
    end

	local nevergainCheckbox = Turbine.UI.Lotro.CheckBox();
	nevergainCheckbox:SetParent( self);
	nevergainCheckbox:SetMultiline( false );
	nevergainCheckbox:SetPosition( 33, contentLabel:GetTop()+ contentLabel:GetHeight()+24 );
	nevergainCheckbox:SetSize( 360, 20 );
	nevergainCheckbox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	nevergainCheckbox:SetText( TRAD("Ne plus demander à l'avenir", "Never ask me again"));
	nevergainCheckbox:SetVisible(neveraskAgainCode~=nil);
	nevergainCheckbox:SetMouseVisible(true);
	
	local validatebtn = Turbine.UI.Lotro.Button();
    validatebtn:SetParent( self );
    validatebtn:SetPosition( (300-90)/2, contentLabel:GetTop()+ contentLabel:GetHeight()+5);
    validatebtn:SetSize( 90, 18 );
    validatebtn:SetText(validationButtonText);
	validatebtn:SetMouseVisible(true);
	validatebtn.Click = function( sender, args )
		if(neveraskAgainCode~=nil) then
			Preferences[neveraskAgainCode]=nevergainCheckbox:IsChecked();
			SavePreferences();
		end
		if(fct~=nil) then fct(); end
		self:CloseMe();	
	end	
	self:SetHeight(contentLabel:GetTop()+ contentLabel:GetHeight()+50);
	self:SetVisible(showMe==true);
end

function CustomDialog:CloseMe()
	self:SetVisible(false);
	self = nil;
end