CustomRepetableWindow = class( Turbine.UI.Lotro.Window );

function CustomRepetableWindow:Constructor()
	Turbine.UI.Lotro.Window.Constructor( self );
	
	self:SetSize( 560, 450 );
	self:SetVisible(false);
	self:SetText( TRAD("Ajouter une répétable", "Add a repetable") );
	
	local width, height = Turbine.UI.Display.GetSize();	
	self:SetPosition((width-400)/2, (height-500)/2);
	
	-- Hide UI when F12 is pressed, code copied from Chiran sources
	local hideUI = false;
	local wasVisible;
	self:SetWantsKeyEvents(true);
	self.KeyDown = function(sender, args)
		if (args.Action == 268435635) then
			if not hideUI then
				hideUI = true;
				if self:IsVisible() then
					wasVisible = true;
					self:SetVisible(false);					
				else
					wasVisible = false;
				end
				-- settingsWindow:SetVisible(false);
				-- toggleWindow:SetVisible(false);
			else
				hideUI = false;
				if wasVisible then
					self:SetVisible(true);
					-- settingsWindow:SetVisible(false);					
				end
				-- if (Settings.ToggleVisible == "yes") then
					-- toggleWindow:SetVisible(true);
				-- end
			end
		end
	end
	local contentLabel = Turbine.UI.Label();
	contentLabel:SetParent( self );
	contentLabel:SetFont(Turbine.UI.Lotro.Font.Verdana14);	
	contentLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);
	contentLabel:SetPosition( 5, 40 );
	contentLabel:SetSize(550, 44);
	contentLabel:SetText( TRAD("Vous pouvez ajouter ici une répétable dans l'onglet Farming. En indiquant le bon nom de quête, sa complétion sera détectée automatiquement. Les répétables que vous créerez seront aussi envoyées dans le plugin Band of Farmers.", "You can add here a repeatable in the Farming tab. By entering the correct name of quest, its completion will be detected automatically. The repeatables you create will also be sent to the plugin Band of Farmers."));
	local borderBot = Turbine.UI.Label();
	borderBot:SetParent( self );
	borderBot:SetPosition(2, 88);
	borderBot:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderBot:SetSize(self:GetWidth()-4, 3);
	borderBot:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_bot.tga");	
	local libelleLabel = Turbine.UI.Label();
	libelleLabel:SetParent( self );
	libelleLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	libelleLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	libelleLabel:SetPosition( 10, 110 );
	libelleLabel:SetSize(550, 44);
	libelleLabel:SetText( TRAD("Libellé de la répétable :", "Label:"));
	self.libelleTextBox = self:BuildTextBoxArea(20, 130, 520, 24);
	self.libelleTextBox.TextChanged = function(sender, args)
		self:ValidateForm();
	end
	
	local questLabel = Turbine.UI.Label();
	questLabel:SetParent( self );
	questLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	questLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	questLabel:SetPosition( 10, 170 );
	questLabel:SetSize(550, 44);
	questLabel:SetText( TRAD("Nom de la quête :", "Name of the quest:"));
	self.questTextBox = self:BuildTextBoxArea(20, 190, 520, 24);
	self.questTextBox.TextChanged = function(sender, args)
		self:ValidateForm();
	end	
	
	local levelLabel = Turbine.UI.Label();
	levelLabel:SetParent( self );
	levelLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	levelLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	levelLabel:SetPosition( 10, 245 );
	levelLabel:SetSize(550, 44);
	levelLabel:SetText( TRAD("Niveau : (optionnel)", "Level: (optional)"));	
	self.lvlTextBox = self:BuildTextBoxArea(175, 240, 75, 24);
	self.lvlTextBox:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	self.lvlTextBox.FocusLost = function(sender, args)
		local value = self.lvlTextBox:GetText();
		local pos = string.match(value, '%d+');
		if(pos == nil) then pos = self.lvlTextBox.previousvalue; end
		self.lvlTextBox:SetText(pos);
		self:ValidateForm();
	end
	
	local resetLabel = Turbine.UI.Label();
	resetLabel:SetParent( self );
	resetLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	resetLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	resetLabel:SetPosition( 10, 290 );
	resetLabel:SetSize(550, 44);
	resetLabel:SetText( TRAD("Réinitialisation :", "Cooldown:"));
	local elementList = {TRAD("tous les dimanches","every sunday"), TRAD("tous les lundis","every monday"), TRAD("tous les mardis","every tuesday"), TRAD("tous les mercredi","every wednesday"), TRAD("tous les jeudis","every thursday"), TRAD("tous les vendredis","every friday"), TRAD("tous les samedis","every saturday"), TRAD("tous les jours","every day"), TRAD("tous les jeudis et dimanches","every thursday and sundays"), TRAD("Aucun (non répétable)", "None (not a repetable)")};
	self.resetDropDown = DropDown.Create(elementList, elementList[5]); -- table that contains the list, default selected value for the list
	self.resetDropDown:SetParent(self);
	self.resetDropDown:SetPosition( 175, 290);
	self.resetDropDown.myElementList = elementList;
	self.resetDropDown:ApplyWidth(250);
	self.resetDropDown:SetMaxItems(10);
	self.resetDropDown:SetVisible(true);
	
	local descriptionLabel = Turbine.UI.Label();
	descriptionLabel:SetParent( self );
	descriptionLabel:SetFont(Turbine.UI.Lotro.Font.TrajanPro15);
	descriptionLabel:SetForeColor(Turbine.UI.Color( 1, 1, 0.5 ));
	descriptionLabel:SetPosition( 10, 335 );
	descriptionLabel:SetSize(550, 44);
	descriptionLabel:SetText( TRAD("Description : (optionnelle)", "Description: (optional)"));	
	self.descriptionTextBox = self:BuildTextBoxArea(20, 355, 520, 48);
	self.descriptionTextBox:SetMultiline(true);
	self.descriptionTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.TopLeft);
	local descricrollBar = Turbine.UI.Lotro.ScrollBar();
    descricrollBar:SetOrientation( Turbine.UI.Orientation.Vertical );
    descricrollBar:SetParent( self );
    descricrollBar:SetPosition( self.descriptionTextBox:GetLeft()+self.descriptionTextBox:GetWidth()+2, self.descriptionTextBox:GetTop() );
    descricrollBar:SetSize( 10, self.descriptionTextBox:GetHeight() );
	self.descriptionTextBox:SetVerticalScrollBar( descricrollBar );	
	self.descriptionTextBox:SetText(nil);
	
	self.validatebtn = Turbine.UI.Lotro.Button();
    self.validatebtn:SetParent( self );
    self.validatebtn:SetPosition( (self:GetWidth()-90)/2, self:GetHeight()-35);
    self.validatebtn:SetSize( 120, 18 );
    self.validatebtn:SetText(TRAD("Sauvegarder", "Save"));
	self.validatebtn:SetMouseVisible(true);
	self.validatebtn.Click = function( sender, args )
		if(neveraskAgainCode~=nil) then
			Preferences[neveraskAgainCode]=nevergainCheckbox:IsChecked();
			SavePreferences();
		end
		-- {id=5009, name="Craft for Embers", enemyType=5, size=1, level=120, questname="craftforembers", subname="craftforembers", rewards={{Rewards.BRAISES, 1000}},quest={pnj="Mozhek", loc="Skarald (34.7N, 45.4W)"}, how="Craft 7 [Ember-worthy crafts]", repeatable=1, tag="tag_braises.tga"},
		Preferences.custWadCnt = (Preferences.custWadCnt or 0) + 1 ;
		local newWad = {
			id="CUSTOM_"..Preferences.custWadCnt;
			name=self.libelleTextBox:GetText();
			custom=true;
			enemyType=5;
			questFull=self.questTextBox:GetText();
			subname=StringCleaner(self.questTextBox:GetText());
			questname=StringCleaner(self.questTextBox:GetText());
			repeatable=IndexOf(self.resetDropDown.myElementList ,self.resetDropDown:GetText());
			description=self.descriptionTextBox:GetText();
			updateMsg="DO";
			tag="tag_custrep.tga";
		};
		if(self.lvlTextBox:GetText()~=nil and self.lvlTextBox:GetText()~="") then
			newWad.level = tonumber(self.lvlTextBox:GetText());
		end
		for i, reg in ipairs(wadData) do
			if(reg.insertCustoms==true and reg.areas~=nil) then
				for j, area in ipairs(reg.areas) do
					if(area.insertCustoms==true and area.wads~=nil) then
						table.insert(area.wads, newWad);
					end
				end
			end
		end
		warbandsDialog:PopupateTreeView();
		warbandsDialog:ShowAllWarbands();
		warbandsDialog:LoadCooldowns(); 
		warbandsDialog:ShowEnemyTab(5);
		warbandsDialog:UpdateBOF();
		if(Preferences.custWad==nil) then Preferences.custWad={}; end
		table.insert(Preferences.custWad, newWad);
		SavePreferences();
		if(fct~=nil) then fct(); end
		self:SetVisible(false);
	end	
	
	self.errorLabel = Turbine.UI.Label();
	self.errorLabel:SetParent( self );
	self.errorLabel:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	self.errorLabel:SetForeColor(Turbine.UI.Color( 1, 0, 0));	
	self.errorLabel:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter);
	self.errorLabel:SetPosition( 0, self:GetHeight()-35 );
	self.errorLabel:SetSize(self:GetWidth(), 28);
	
	self:ValidateForm();
end

function CustomRepetableWindow:ValidateForm()
	local validation = true;
	if(self.questTextBox:GetText()==nil or string.len(self.questTextBox:GetText())<3) then
		validation = false;
		self.errorLabel:SetText(TRAD("Le nom de quête doit avoir au moins 3 caractères !", "The quest name must have at least 3 characters!"));
	end
	if(self.libelleTextBox:GetText()==nil or string.len(self.libelleTextBox:GetText())<3) then
		validation = false;
		self.errorLabel:SetText(TRAD("Le libellé doit avoir au moins 3 caractères !", "The label must have at least 3 characters!"));
	end
	self.errorLabel:SetVisible(not validation);
	self.validatebtn:SetVisible(validation);
end

function CustomRepetableWindow:BuildTextBoxArea(x, y, weidth, height)
	local background = Turbine.UI.Label();
	background:SetParent( self );	
	background:SetSize(weidth, height);
	background:SetBackColor(Turbine.UI.Color(0.63,0.63,0.63));
	background:SetPosition( x, y );
	background:SetMouseVisible(false);	
	local textArea =  Turbine.UI.TextBox();
	textArea:SetParent( self );
	textArea:SetPosition( x+2, y+2 );
	textArea:SetFont(Turbine.UI.Lotro.Font.Verdana14);
	textArea:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	textArea:SetForeColor(Turbine.UI.Color((229/255),(209/255),(136/255)));
	textArea:SetBackColor(Turbine.UI.Color( 0, 0, 0 ));
	textArea:SetSize(weidth-4, height-4);
	textArea:SetMultiline(false);
	textArea:SetZOrder(background:GetZOrder()+1);
	return textArea;
end