
import "WalmPlugins.WarbandsSlayer.src.CustomDialog";

MiniMapViewer = class( Turbine.UI.Label );

function MiniMapViewer:Constructor(parent, canBeFocused, pos, dec)
	self.nativeW = 304;
	self.nativeH = 228;
	Turbine.UI.Label.Constructor( self );
	pos = pos or 1;
	dec = dec or 0;
	self:SetParent( parent );
	self.parent = parent;
	self:SetSize( self.nativeW, self.nativeH );
	self:SetPosition( 0, (self:GetHeight()+5)*(pos-1)+dec );
	self:SetZOrder(-99);
	self:SetMouseVisible( false );
	
	self.map = Turbine.UI.Label(); 
	self.map:SetParent( self );
	self.map:SetSize(300, 200);
	self.map:SetPosition(2, self.nativeH-200-2);
	self.localisationArray = {};

	self:BuildGUI(self.nativeW, self.nativeH);

	self.switchPointsVisibility = SwitchLabel(16, 16, "WalmPlugins/WarbandsSlayer/resources/minimap/filterButton.tga", "WalmPlugins/WarbandsSlayer/resources/minimap/filterButton2.tga");
	self.switchPointsVisibility:SetParent( self );
	self.switchPointsVisibility:SetPosition(45, 5);
	self.switchPointsVisibility:SetMouseVisible( true );
	self.switchPointsVisibility.tooltip = GenericTooltip(self.switchPointsVisibility, TRAD("Filtrer les Repères découvertes", "Filter the discovered landmarks"), TRAD("Permet d'afficher ou de masquer toutes les repères ou seulement ceux pas découvertes.", "Allows you to display or hide all landmarks or only those not discovered."));
	self.switchPointsVisibility.backLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.switchPointsVisibility.Toggled = function(parent, pushed)
		self:UpdateMarksVisibility();
	end

	self.validateAllPoints = Turbine.UI.Label();
	self.validateAllPoints:SetParent( self );
	self.validateAllPoints:SetPosition(10, 5);
	self.validateAllPoints:SetSize(16, 16);
	self.validateAllPoints:SetMouseVisible( true );
	self.validateAllPoints:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/validatepoi.jpg");
	self.validateAllPoints.tooltip = GenericTooltip(self.validateAllPoints, TRAD("Valider tous les repères", "Validate all landmarks"), TRAD("Permet de valider d'un coup tous les repères de la carte.", "Allows you to validate all the landmarks on the map at once."));
	self.validateAllPoints:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.validateAllPoints.MouseClick = function(sender, args)
		validateFunction = function(sender, args)
			if(PoiProgress==nil) then PoiProgress = {}; end;
			--if(PoiProgress[self.warband.id]==nil) then PoiProgress[self.warband.id]={}; end;
			local wbList = {};
			for i=1, table.getn(self.localisationArray), 1 do			
				local array = self.localisationArray[i];
				if(array.wbid~=nil and array.mData~=nil and array.mData.id~=nil) then
					if(PoiProgress[array.wbid]==nil) then PoiProgress[array.wbid]={}; end;
					PoiProgress[array.wbid][array.mData.id] = true;
					array:SetPushed(true);
					if(not ListContainsString(wbList, array.warband)) then
						table.insert(wbList, array.warband);
					end
				end
			end	
			for i,v in ipairs(wbList) do 
				warbandsDialog:AddCooldown(v, v.name, true, true); 
			end
			SavePOI(false);			
		end
		self.diag = CustomDialog("Confirmation", TRAD("Cette action va valider automatiquement tous les repères de la carte.\nEtes-vous certain de vouloir indiquer que tous les repères ont été accomplis ?", "This action will automatically validate all the landmarks on the map.\nAre you sure you want to indicate that all landmarks have been accomplished?"), TRAD("Oui", "Yes"), validateFunction, true, "CONFIRM_MAP_VALID");

	end

	self.validateQuest = Turbine.UI.Label();
	self.validateQuest:SetParent( self );
	self.validateQuest:SetPosition(10, 5);
	self.validateQuest:SetSize(16, 16);
	self.validateQuest:SetMouseVisible( true );
	self.validateQuest:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/validatepoi.jpg");
	self.validateQuest.tooltip = GenericTooltip(self.validateQuest, TRAD("Indiquer la qu\195\170te comme faite", "Set the quest as done"), TRAD("Permet d'enregistrer la qu\195\170te comme faite, sans utiliser le detecteur auto.", "Allows you to set the quest as done, without using the auto detector."));
	self.validateQuest:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.validateQuest.MouseClick = function(sender, args)
		warbandsDialog:AddCooldown(nil, self.warband.name, true, true);
	end

	self.locatePlayerQs = Turbine.UI.Lotro.Quickslot();
	self.locatePlayerQs:SetParent(self);
	self.locatePlayerQs:SetSize(16, 16);
	self.locatePlayerQs:SetPosition(110, 5);
	self.locatePlayerQs:SetZOrder(9999);
	self.locatePlayerQs:SetBackColor(Turbine.UI.Color( 1, 223/255, 0 ));
	self.locatePlayerQs:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, TRAD("/e essaye de se localiser autour de ;loc", "/e tries to locate himself around ;loc")));
	self.locatePlayerQs:SetAllowDrop(false);
	--self.locatePlayerQs:SetEnabled(true);
	self.locatePlayerQs.tooltip = GenericTooltip(self.locatePlayerQs, TRAD("Voir la position du joueur", "See player position"), TRAD("Permet d'ajouter une marque sur la position du joueur.", "Add a mark on the position of the player."));
	self.locatePlayerQs.ShortcutChanged = function()
		if(self.locatePlayerQs:GetShortcut()==nil or self.locatePlayerQs:GetShortcut():GetData()=="") then
			self.locatePlayerQs:SetShortcut(Turbine.UI.Lotro.Shortcut( Turbine.UI.Lotro.ShortcutType.Alias, TRAD("/e essaye de se localiser autour de ;loc", "/e tries to locate himself around ;loc")));
		end
	end
	self.locatePlayerQs2 = Turbine.UI.Control();
	self.locatePlayerQs2:SetParent(self);
	self.locatePlayerQs2:SetSize(self.locatePlayerQs:GetSize());
	self.locatePlayerQs2:SetPosition(self.locatePlayerQs:GetLeft(),self.locatePlayerQs:GetTop());
	self.locatePlayerQs2:SetBackColor(Turbine.UI.Color( 0, 0, 0));
	self.locatePlayerQs2:SetMouseVisible(false);
	self.locatePlayerQs2:SetZOrder(10000);
	local cosmeticLbl= Turbine.UI.Label()
	cosmeticLbl:SetParent(self.locatePlayerQs2);
	cosmeticLbl:SetPosition(1,1);
	cosmeticLbl:SetSize(self.locatePlayerQs2:GetWidth()-2, self.locatePlayerQs2:GetHeight()-2);
	cosmeticLbl:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold19);
	cosmeticLbl:SetFontStyle(Turbine.UI.FontStyle.Outline);
	cosmeticLbl:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter);
	cosmeticLbl:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	cosmeticLbl:SetBackground( "WalmPlugins/WarbandsSlayer/resources/minimap/playerpos.tga");
	cosmeticLbl:SetMouseVisible(false);
	cosmeticLbl:SetZOrder(10001);
	cosmeticLbl:SetText("?");	
	self.playerMark = Turbine.UI.Label(); 
	self.playerMark:SetParent( self.map );
	self.playerMark:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.playerMark:SetSize(16, 16);
	self.playerMark:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/playerpos.tga");	
	self.playerMark:SetPosition(150, 100);
	self.playerMark.tooltip = GenericTooltip(self.playerMark, TRAD("Votre position", "Your position"));
	self.playerMark:SetZOrder(10000);
	self.playerMark:SetVisible(false);
	
	if(canBeFocused) then
		local selfView = Turbine.UI.Label();
		selfView:SetParent( self );
		selfView:SetPosition( self:GetWidth()-28, 5 );
		selfView:SetSize(16, 16);	
		selfView:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/enlarge.jpg");
		selfView:SetMouseVisible( true );
		selfView.tooltip = GenericTooltip(selfView, TRAD("Isoler la mini-map", "Isolate the minimap"), TRAD("Permet de n'afficher que la mini-map.", "Show the minimap on the seperate window."));
		selfView.MouseClick = function(sender, args)
			if(minimap:UpdateMap(self.warband, self.pos)~=nil) then
				warbandsDialog:SetVisible(false);
				minimap:SetVisible(true);
			end
		end
		self.allMarks = Turbine.UI.Label();
		self.allMarks:SetParent( self );
		self.allMarks:SetPosition( self:GetWidth()-48, 5 );
		self.allMarks:SetSize(16, 16);	
		self.allMarks:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/layers.jpg");
		self.allMarks:SetMouseVisible( true );
		self.allMarks.tooltip = GenericTooltip(self.allMarks, TRAD("Montrer toutes les marques", "Show all landmarks"), TRAD("Permet d'afficher l'intégralité des marques de cette carte.", "Allows you to display all the landmarks of this map."));
		self.allMarks.MouseClick = function(sender, args)
			minimap:UpdateMap(self.warband, self.pos);	
			minimap:ShowAllMarks(self.warband, self.pos);
			warbandsDialog:SetVisible(false);
			minimap:SetVisible(true);		
		end
	else
		self.allMarks = SwitchLabel(16, 16, "WalmPlugins/WarbandsSlayer/resources/minimap/layers.jpg", "WalmPlugins/WarbandsSlayer/resources/minimap/back.jpg");
		self.allMarks:SetParent( self );
		self.allMarks:SetPosition(self:GetWidth()-48, 5 );
		self.allMarks:SetMouseVisible( true );
		self.allMarks.tooltip = GenericTooltip(self.allMarks, TRAD("Montrer toutes les marques", "Show all landmarks"), TRAD("Permet d'afficher l'intégralité des marques de cette carte.", "Allows you to display all the landmarks of this map."));
		self.allMarks.backLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
		self.allMarks.Toggled = function(parent, pushed)
			if(pushed) then
				--local pos = self.pos;
				self.allMarks.wData = self.warband;
				self.allMarks.l = self.pos;
				self.allMarks.areaData = self.areaData;
				local map = self:ShowAllMarks(self.warband, self.pos);
				--if(map~=nil) then
					if(self.parent.nameLabel~=nil) then
						local areaData = GetMapData(self.warband.map, self.pos);
						if(self.warband.multipoi~=nil and self.pos~=nil) then
							areaData = GetMapData(self.warband.multipoi[self.pos].map, self.pos);
						end
						if(areaData~=nil) then
							self.parent.nameLabel:SetText(areaData.name );
						else
							self.parent.nameLabel:SetText(TRAD("Carte globale", "Global Map"));
						end
					end
					--self.pos = pos;
					self.allMarks:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/back.jpg");
				--end
			else
				self:UpdateMap(self.allMarks.wData, self.allMarks.l, nil, true);
				self.allMarks.wData = nil;
				self.allMarks.l = nil;			
			end
		end		
		self.filterChest = SwitchLabel(16, 16, "WalmPlugins/WarbandsSlayer/resources/minimap/chest.jpg", "WalmPlugins/WarbandsSlayer/resources/minimap/chestX.jpg");
		self.filterChest:SetParent( self );
		self.filterChest:SetPosition(65, 5);
		self.filterChest:SetMouseVisible( true );
		self.filterChest.tooltip = GenericTooltip(self.filterChest, TRAD("Filtrer les points d'Intérêt", "Filter points of interest"), TRAD("Permet d'afficher ou de masquer les repères des Points d'Intérêt.", "Allows you to display or hide the Points of Interest landmarks."));
		self.filterChest.backLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
		self.filterChest.Toggled = function(parent, pushed)
			self:UpdateMarksVisibility();
		end		
		self.filterMob = SwitchLabel(13, 16, "WalmPlugins/WarbandsSlayer/resources/minimap/tdg_flag2.tga", "WalmPlugins/WarbandsSlayer/resources/minimap/tdg_flagX.tga");
		self.filterMob:SetParent( self );
		self.filterMob:SetPosition(85, 5);
		self.filterMob:SetMouseVisible( true );
		self.filterMob.tooltip = GenericTooltip(self.filterMob, TRAD("Filtrer les Ennemis", "Filter Enemies"), TRAD("Permet d'afficher ou de masquer les marques des Menaces itinérantes et des Troupes de guerre.", "Allows you to show or hide the landmarks of Roving Threats and Warbands."));
		self.filterMob.backLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
		self.filterMob.Toggled = function(parent, pushed)
			self:UpdateMarksVisibility();
		end				
	end
end

function MiniMapViewer:UpdateMarksVisibility()
	for i=1, table.getn(self.localisationArray), 1 do
		local array = self.localisationArray[i];
		--array:SetVisible(pushed==false or array.IsPushed==nil or not array:IsPushed());
		local showme = self.switchPointsVisibility:IsPushed()==false or array.IsPushed==nil or not array:IsPushed();
		if((array.enemyType==1 or array.enemyType==2) and self.filterMob~=nil and self.filterMob:IsPushed()) then 
			showme = false;
		end
		if(array.enemyType==3 and self.filterChest~=nil and self.filterChest:IsPushed()) then 
			showme = false;
		end
		array:SetVisible(showme);
	end	
end

function MiniMapViewer:BuildGUI(width, height)
	local headerBack = Turbine.UI.Label();
	headerBack:SetParent( self );
	headerBack:SetPosition(2, 2);
	--headerBack:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	headerBack:SetSize(width-4, self.nativeH-200-2-2-2);
	headerBack:SetBackColor( Turbine.UI.Color( 0, 0, 0 ) );
	--headerBack:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/header.jpg");
	local borderTopLeft = Turbine.UI.Label();
	borderTopLeft:SetParent( self );
	borderTopLeft:SetPosition(0, 0);
	borderTopLeft:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderTopLeft:SetSize(12, 12);
	borderTopLeft:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/corner_top_left.tga");	
	local borderBotLeft = Turbine.UI.Label();
	borderBotLeft:SetParent( self );
	borderBotLeft:SetPosition(0, height-12);
	borderBotLeft:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderBotLeft:SetSize(12, 12);
	borderBotLeft:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/corner_bot_left.tga");
	local borderTopRight = Turbine.UI.Label();
	borderTopRight:SetParent( self );
	borderTopRight:SetPosition(width-12, 0);
	borderTopRight:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderTopRight:SetSize(12, 12);
	borderTopRight:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/corner_top_right.tga");	
	local borderBotRight = Turbine.UI.Label();
	borderBotRight:SetParent( self );
	borderBotRight:SetPosition(width-12, height-12);
	borderBotRight:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderBotRight:SetSize(12, 12);
	borderBotRight:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/corner_bot_right.tga");
	local borderSep = Turbine.UI.Label();
	borderSep:SetParent( self );
	borderSep:SetPosition(2, self.nativeH-200-2-2);
	borderSep:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderSep:SetSize(width-4, 3);
	borderSep:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_top.tga");		
	local borderTop = Turbine.UI.Label();
	borderTop:SetParent( self );
	borderTop:SetPosition(12, 0);
	borderTop:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderTop:SetSize(width-24, 3);
	borderTop:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_top.tga");	
	local borderBot = Turbine.UI.Label();
	borderBot:SetParent( self );
	borderBot:SetPosition(12, self.nativeH-3);
	borderBot:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderBot:SetSize(width-24, 3);
	borderBot:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_bot.tga");
	local borderLeft = Turbine.UI.Label();
	borderLeft:SetParent( self );
	borderLeft:SetPosition(0, 12);
	borderLeft:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderLeft:SetSize(3, height-24);
	borderLeft:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_left.tga");		
	local borderRight = Turbine.UI.Label();
	borderRight:SetParent( self );
	borderRight:SetPosition(width-3, 12);
	borderRight:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	borderRight:SetSize(3, height-24);
	borderRight:SetBackground("WalmPlugins/WarbandsSlayer/resources/box/border_right.tga");	
end

function MiniMapViewer:ShowAllMarks(warband, pos)
	if(warband==nil) then return nil; end
	local wbfound=0;
	local wmap = warband.map;
	if(warband.multipoi~=nil and warband.multipoi[pos]~=nil) then wmap=warband.multipoi[pos].map; end
	local areaData = GetMapData(wmap, pos);
	for i, rData in pairs(wadData) do
		for j, aData in pairs(rData.areas) do
			for k, wData in pairs(aData.wads) do
				if(wData~=nil) then
					local wbMap = rData.map;
					if(aData.map~=nil) then wbMap=aData.map; end
					if(wData.map~=nil) then wbMap=wData.map; end
					if(wData.multipoi~=nil) then
						for l=1, table.getn(wData.multipoi), 1 do
							if(wData.multipoi[l].map==wmap) then
								self:UpdateMap(wData, l, nil, false, wbfound>0, true);
								wbfound = wbfound +1;
							end
						end
					elseif(wbMap~=nil and wbMap==wmap) then
						self:UpdateMap(wData, 1, nil, false, wbfound>0, true);
						wbfound = wbfound + 1;
					end
				end
			end
		end
	end	
	self:UpdateMarksVisibility();
	return wmap;
end

function MiniMapViewer:UpdateMap(warband, pos, areaData, showWbName, bypassClearMarks, layers)
	if(warband==nil) then
		Turbine.Shell.WriteLine("<rgb=#FF5CCD>ERROR UpdateComponents gets nil warband</rgb>");
		return false;
	end
	if(areaData==nil) then
		areaData = GetMapData(warband.map);
	end
	if(bypassClearMarks~=true) then
		self.warband = warband;
		self.pos = pos;
		if(self.localisationArray ~= nil) then
			while(table.getn(self.localisationArray) > 0) do
				local lab = table.remove(self.localisationArray);
				lab:SetPosition(0,0);
				lab:SetParent(nil);
				lab.tooltip = nil;
				lab = nil;
			end
		end
	end
	if(self.localisationArray == nil) then self.localisationArray = {}; end
	
	if(warband.map ~= nil) then
		self.map:SetBackground("WalmPlugins/WarbandsSlayer/resources/maps/"..warband.map);
	end
	if(showWbName) then
		if(self.parent~=nil and self.parent.nameLabel~=nil) then 
			self.parent.nameLabel:SetText( warband.name );
		end
	end
	local size = 16;
	if(warband.enemyType == 2) then
		self.switchPointsVisibility:SetVisible(layer~=false);
		self.validateQuest:SetVisible(true);
		self.validateAllPoints:SetVisible(false);
		if(warband.rovingThreatData~=nil and warband.rovingThreatData.loc~=nil) then
			for id=1, table.getn(warband.rovingThreatData.loc), 1 do
				local mData = warband.rovingThreatData.loc[id];
				-- k.m  k.c  k.l
				local coords = self:ComputeDynCoords(mData, areaData, 7);
				if(coords~=nil) then
					local mFlag = nil;
					if(layers==true) then mFlag=self:GetFlagFromArray(coords.x, coords.y); end
					if(mFlag==nil) then
						mFlag = Turbine.UI.Label(); 
						mFlag:SetParent( self.map );
						mFlag:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
						mFlag:SetSize(13, 16);
						mFlag:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/tdg_flag2.tga");	
						mFlag:SetPosition(coords.x,coords.y);
						table.insert(self.localisationArray, mFlag);
						mFlag.enemyType = 2;
						mFlag.wbid = warband.id;
						mFlag.warband = warband;
						mFlag.tooltip = GenericTooltip(mFlag, TRAD("Coordonn\195\169es : ", "Coordinates : ")..mData.c, mData.l or nil);
						mFlag.tooltip:AddLayer(TRAD("Point de spawn aléatoire de :", "Random spawn point of :"), Turbine.UI.Color(207/255,181/255,59/255), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
						mFlag.tooltip:AddLayer(warband.name, Turbine.UI.Color(0.8,0.5,0), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
					else
						mFlag.tooltip:AddLayer(warband.name, Turbine.UI.Color(0.8,0.5,0), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
					end
				end
			end
		else
			Turbine.Shell.WriteLine("<rgb=#FF0000>FORMAT ERROR : wb="..warband.id.." => warband.rovingThreatData.loc not found");
		end
	elseif((warband.poi~=nil or warband.multipoi~=nil)) then
		self.switchPointsVisibility:SetVisible(true);
		self.validateAllPoints:SetVisible(true);
		self.validateQuest:SetVisible(false);
		local backgroundOn = "WalmPlugins/WarbandsSlayer/resources/minimap/chest.jpg";
		local backgroundOff = "WalmPlugins/WarbandsSlayer/resources/minimap/chestFound.jpg";
		
		if(warband.ico~=nil) then
			backgroundOn = "WalmPlugins/WarbandsSlayer/resources/minimap/"..warband.ico;
			backgroundOff = "WalmPlugins/WarbandsSlayer/resources/minimap/poiok.jpg";
			size = 12;
		end	
		local poiarray = warband.poi;
		if(warband.multipoi~=nil) then
			poiarray = warband.multipoi[pos].poi;
			if(warband.multipoi[pos].map~=nil) then 
				areaData = GetMapData(warband.multipoi[pos].map); 
			end
			self.map:SetBackground("WalmPlugins/WarbandsSlayer/resources/maps/"..warband.multipoi[pos].map);
		end
		for id=1, table.getn(poiarray), 1 do
			local mData = poiarray[id];
			local coords = self:ComputeDynCoords(mData, areaData, size);
			if(coords~=nil) then
				local mFlag = SwitchLabel(size, size, backgroundOn, backgroundOff); 
				mFlag:SetParent( self.map );
				table.insert(self.localisationArray, mFlag);
				mFlag:SetPosition(coords.x,coords.y);
				mFlag.mData = mData;
				mFlag.wbid = warband.id;
				mFlag.warband = warband;
				mFlag.enemyType = warband.enemyType;
				mFlag.Toggled = function(parent, pushed)
					if(PoiProgress==nil) then PoiProgress = {}; end;
					if(PoiProgress[warband.id]==nil) then PoiProgress[warband.id]={}; end;
					PoiProgress[warband.id][mData.id] = pushed;
					SavePOI(false);
					local completed = CheckPOICompletion(warband);
					warbandsDialog:AddCooldown(warband, warband.name, completed, completed);
				end
				local alreadyFound = false;
				if(PoiProgress~=nil and PoiProgress[warband.id]~=nil and PoiProgress[warband.id][mData.id]~=nil)then
					alreadyFound = PoiProgress[warband.id][mData.id];
				end
				mFlag:SetPushed(alreadyFound);				
				mFlag.tooltip = GenericTooltip(mFlag, TRAD("Coordonn\195\169es : ", "Coordinates : ")..mData.c, mData.l);
				mFlag.tooltip:AddLayer(warband.name, Turbine.UI.Color(207/255,181/255,59/255), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
				if(alreadyFound)then
					mFlag.tooltip:AddLayer(TRAD("Déjà trouvé !", "Already found"), Turbine.UI.Color(0, 1, 0), nil, Turbine.UI.Lotro.Font.Verdana14);
				end
			end
		end
	elseif(warband.mapPos~=nil or warband.loc~=nil) then
		local mFlag = nil;
		local coords = nil;
		if(warband.mapPos~=nil) then
			coords = self:ComputeDynCoords(warband.mapPos, nil, size);
		elseif(warband.loc~=nil) then
			coords = self:ComputeDynCoords(warband, areaData, size);			
		end		
		if(layers==true and coords~=nil) then mFlag=self:GetFlagFromArray(coords.x, coords.y); end
		if(mFlag==nil) then
			local mFlag = Turbine.UI.Label(); 
			mFlag:SetParent( self.map );
			mFlag:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
			mFlag:SetSize(13, 16);
			mFlag:SetBackground("WalmPlugins/WarbandsSlayer/resources/minimap/tdg_flag2.tga");
			mFlag.wbid = warband.id;
			mFlag.enemyType = warband.enemyType;
			mFlag.warband = warband;			
			table.insert(self.localisationArray, mFlag);

			mFlag:SetPosition(coords.x, coords.y);	
			mFlag.tooltip = GenericTooltip(mFlag, TRAD("Coordonn\195\169es : ", "Coordinates : ")..(warband.c or warband.loc), warband.l or nil);
			mFlag.tooltip:AddLayer(TRAD("Point de spawn de :", "Spawn point of :"), Turbine.UI.Color(207/255,181/255,59/255), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
			mFlag.tooltip:AddLayer(warband.name, Turbine.UI.Color(0.8,0.5,0), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
		else
			mFlag.tooltip:AddLayer(warband.name, Turbine.UI.Color(0.8,0.5,0), Turbine.UI.ContentAlignment.TopLeft, Turbine.UI.Lotro.Font.Verdana14, nil);
		end
		self.switchPointsVisibility:SetVisible(false);
		self.validateAllPoints:SetVisible(false);
		self.validateQuest:SetVisible(true);
	end
	if(bypassClearMarks~=true) then
		self.locatePlayerQs:SetVisible(areaData~=nil and areaData.c~=nil);
		self.locatePlayerQs2:SetVisible(areaData~=nil and areaData.c~=nil);	
	end
	return true;
end

function MiniMapViewer:OnPOIUpdated(wad, poi)
	--if(self.warband==nil or wad.id ~= self.warband.id) then return; end
	for i=1, table.getn(self.localisationArray), 1 do
		local cmp = self.localisationArray[i];
		if(cmp.wbid==wad.id and cmp.mData~=nil and cmp.mData.id==poi.id) then
			cmp:SetPushed(PoiProgress~=nil and PoiProgress[cmp.wbid]~=nil and PoiProgress[cmp.wbid][cmp.mData.id]==true);
		end
	end
end

function MiniMapViewer:ComputeDynCoords(mData, areaData, border)
	if(mData.x~=nil and mData.y~=nil) then
		return {x=mData.x-6, y=mData.y-8};
	elseif(mData.m~=nil) then
		return {x=mData.m.x-6, y=mData.m.y-8};
	elseif((mData.c~=nil or mData.loc) and areaData~=nil) then
		local parsingCoord = (mData.c or mData.loc);
		local a, b, y1, y2, dir_y, x1, x2, dir_x = string.find(parsingCoord, "(%d*)%.(%d)([NnSs]), (%d*)%.(%d)([OoWwEe])");
		if(x1==nil or x2==nil or dir_x==nil or y1==nil or y2==nil or dir_y==nil) then
			if(Preferences.debug==true) then 
				Turbine.Shell.WriteLine("<rgb=#FF0000>ComputeDynCoords parsing ERROR : WB="..(self.warband.id or "UNKNOWN").." id="..mData.id);
			end
			return nil;
		end
		local cx = tonumber(x1)+tonumber(x2)/10;
		local cy = tonumber(y1)+tonumber(y2)/10;
		if(dir_y=="N" or dir_y=="n") then cy=0-cy; end		
		if(dir_x~="E" and dir_x~="e") then cx=0-cx; end
		local result = {x=math.floor((cx-areaData.c.w)/areaData.CoordsByPixelsX)-6, y=math.floor((cy-areaData.c.n)/areaData.CoordsByPixelsY)-8};
		if(result.x<0) then result.x=-2 end
		if(result.x>300-border) then result.x=300-border-2 end
		if(result.y<0) then result.y=-2 end
		if(result.y>200-border) then result.y=200-border-2 end
		-- Turbine.Shell.WriteLine("<rgb=#FF5CCD>"..mData.c.." ["..areaData.w..":"..areaData.n.."] ["..areaData.e..":"..areaData.s.."]");
		-- Turbine.Shell.WriteLine("<rgb=#FF5CCD>areaData.CoordsByPixelsX="..areaData.CoordsByPixelsX.."    areaData.CoordsByPixelsY="..areaData.CoordsByPixelsY);
		-- Turbine.Shell.WriteLine("<rgb=#FF5CCD>Point = "..cx..":"..cy.." => "..(cx-areaData.w)..":"..(cy-areaData.n).." => "..result.x..":"..result.y);
		-- Turbine.Shell.WriteLine("<rgb=#FF5CCD>=> "..result.x..":"..result.y);
		return result;
	elseif(Preferences.debug==true) then 
		Turbine.Shell.WriteLine("<rgb=#FF0000>ComputeDynCoords global ERROR : WB="..self.warband.id.." id="..mData.id);
	end
end

function MiniMapViewer:GetFlagFromArray(x, y)
	if(self.localisationArray==nil) then 
		return nil; 
	end
	for i,flag in ipairs(self.localisationArray) do
		if(flag:GetLeft()==x and flag:GetTop()==y) then return flag; end
	end
	return nil;
end

function MiniMapViewer:UpdatePlayerPosition(x, y)
	if(self.warband==nil) then return; end 
	local map = self.warband.map;
	if(self.warband.multipoi~=nil and self.pos~=nil) then
		map = self.warband.multipoi[self.pos].map;
	end
	
	local aData = GetMapData(map);
	if(aData~=nil and aData.c~=nil) then
		if(x<aData.c.w) then self.playerMark:SetLeft(-8); 
		elseif(x>aData.c.e) then self.playerMark:SetLeft(self.map:GetWidth()-8); 
		else self.playerMark:SetLeft((x-aData.c.w)/aData.CoordsByPixelsX-8); end
		if(y<aData.c.n) then self.playerMark:SetLeft(-8); 
		elseif(y>aData.c.s) then self.playerMark:SetTop(self.map:GetHeight()-8); 
		else self.playerMark:SetTop((y-aData.c.n)/aData.CoordsByPixelsY-8); end
		self.lastUpdate = nil;
		self.counter = 0;
		self:SetWantsUpdates(true);
	end
	self.playerMark:SetVisible(aData~=nil);
end

function MiniMapViewer:Update( args )
	local delta = 0;
	local currentTime = Turbine.Engine.GetGameTime();
	if ( self.lastUpdate~=nil and self.lastUpdate > 0 ) then
		delta = currentTime - self.lastUpdate;
	end

	self.lastUpdate = currentTime;
	self.counter = delta + self.counter;
	local inc = self.counter - math.floor(self.counter);
	self.playerMark:SetVisible(inc<0.5);
	if(self.counter>=5) then
		self.playerMark:SetVisible(false);
		self:SetWantsUpdates(false);
	end
end

function MiniMapViewer:Unload()
	for i=1, table.getn(self.localisationArray), 1 do
		local array = self.localisationArray[i];
		array.tooltip:Free();
		array.tooltip = nil;
		array = nil;
	end
end