ProgressBar = class( Turbine.UI.Label );

function ProgressBar:Constructor(width, maxValue)
	Turbine.UI.Label.Constructor( self );    	
	self:SetSize( width, 24 );
	self:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self:SetMouseVisible( true );
	
	self.leftBack = Turbine.UI.Label();
	self.leftBack:SetParent( self );
	self.leftBack:SetSize( 24, 24 );
	self.leftBack:SetPosition( 0, 0 );	
	self.leftBack:SetBackground("WalmPlugins/WarbandsSlayer/resources/progressbar/progress_overlay_left.tga");	
	self.leftBack:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );	
	self.leftBack:SetMouseVisible( false );
	local centerBack = Turbine.UI.Label();
	centerBack:SetParent( self );
	centerBack:SetSize( width-45, 24 );
	centerBack:SetPosition( 24, 0 );	
	centerBack:SetBackground("WalmPlugins/WarbandsSlayer/resources/progressbar/progress_overlay_center.tga");
	centerBack:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );		
	centerBack:SetMouseVisible( false );
	self.rightBack = Turbine.UI.Label();
	self.rightBack:SetParent( self );
	self.rightBack:SetSize( 21, 24 );
	self.rightBack:SetPosition( width-21, 0 );	
	self.rightBack:SetBackground("WalmPlugins/WarbandsSlayer/resources/progressbar/progress_overlay_right.tga");
	self.rightBack:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );		
	self.rightBack:SetMouseVisible( false );
	
	self.progress = Turbine.UI.Label();
	self.progress:SetParent( self );
	self.progress:SetSize( 0, 16 );
	self.progress:SetPosition( 18, 4 );	
	self.progress:SetBackground("WalmPlugins/WarbandsSlayer/resources/progressbar/progress_overlay_center_b.tga");
	self.progress:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );		
	self.progress:SetMouseVisible( false );	
	
	self.labelValue = Turbine.UI.Label();
	self.labelValue:SetParent( self );
	self.labelValue:SetSize( width-45, 24 );
	self.labelValue:SetPosition(24, 0 );
	self.labelValue:SetFont( Turbine.UI.Lotro.Font.BookAntiquaBold18 );		
	self.labelValue:SetForeColor( Turbine.UI.Color(1,1,1) );
	self.labelValue:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	self.labelValue:SetMouseVisible( false );
	self.labelValue:SetText("0 %");
	self.value = 0;
	self.maxValue = maxValue;
	
	self.labelValue.MouseClick = function(o, a)
		self:UpdateValue(math.mod(self.value+10, 100));
	end
end

function ProgressBar:UpdateValue(value)
	if(type(value)~="number") then return; end
	--if(value<0 or value> (self.maxValue or 1)) then return; end
	self.value = value;
	if(self.maxValue==nil) then
		self.labelValue:SetText(math.floor(value*100).." %");
	else
		self.labelValue:SetText(self.value.." / "..self.maxValue.." ("..math.floor(value/self.maxValue*100).." %)");
		value = value/self.maxValue;
	end
	if(value>1) then value=1; end
	if(value==0) then
		self.leftBack:SetBackground("WalmPlugins/WarbandsSlayer/resources/progressbar/progress_overlay_left.tga");
	else
		self.leftBack:SetBackground("WalmPlugins/WarbandsSlayer/resources/progressbar/progress_overlay_left_b.tga");
	end
	if(value==1) then
		self.rightBack:SetBackground("WalmPlugins/WarbandsSlayer/resources/progressbar/progress_overlay_right_b.tga");
	else
		self.rightBack:SetBackground("WalmPlugins/WarbandsSlayer/resources/progressbar/progress_overlay_right.tga");
	end
	self.progress:SetWidth(value*(self:GetWidth()-18-18));
end
