SwitchLabel = class( Turbine.UI.Label );

function SwitchLabel:Constructor(width, height, backgroundOn, backgroundOff)	  	
	Turbine.UI.Label.Constructor( self );    	
	
	self:SetSize( width, height );

	self.backLabel = Turbine.UI.Label();
	self.backLabel:SetParent( self );	
	self.backLabel:SetPosition(0, 0);
	self.backLabel:SetSize(width, height);
	self.backLabel:SetBackground(backgroundOn);
	self.backLabel:SetMouseVisible(false);
	self.pushed = false;
	if(defaultPosition~= nil) then
		self.pushed = defaultPosition;
	end
	
	self.MouseClick = function(sender, args)
		self:SetPushed(not self.pushed);
		if(self.Toggled ~= nil) then
			self.Toggled(self, self.pushed);
		end			
	end
	self.MouseDoubleClick = self.MouseClick;
	self.backgroundOn = backgroundOn;
	self.backgroundOff = backgroundOff;
end

function SwitchLabel:IsPushed()
	return self.pushed;
end

function SwitchLabel:SetPushed(pushed)
	if(type(pushed) ~= "boolean")then
		Turbine.Shell.WriteLine("Err: SwitchLabel:SetPushed expected a boolean, and had "..type(checked).."\n"..Turbine.Engine.GetCallStack());
		return;
	end
	self.pushed = pushed;
	if(self.pushed) then
		self.backLabel:SetBackground(self.backgroundOff);
	else
		self.backLabel:SetBackground(self.backgroundOn);
	end
end