TextNode = class( Turbine.UI.TreeNode );

function TextNode:Constructor(title, value, width, height)
	Turbine.UI.TreeNode.Constructor( self );
	self.nativewidth = 290;
	self.nativeheight = 16;
	if(width~=nil and height~=nil) then
		self.nativewidth = width;
		self.nativeheight = height;
	end
	self:SetSize( self.nativewidth, self.nativeheight );
	self:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	
	self.labelKey = Turbine.UI.Label();
	self.labelKey:SetParent( self );
	self.labelKey:SetPosition( 0, 0 );
	self.labelKey:SetSize( self.nativewidth, self.nativeheight );	
	self.labelKey:SetZOrder(100);
	--self.labelKey:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 );	
	self.labelKey:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	self.labelKey:SetMouseVisible( false );
	self.labelKey:SetText(title);

	self.valueKey = Turbine.UI.Label();
	self.valueKey:SetParent( self );
	self.valueKey:SetPosition( 100, 0 );
	self.valueKey:SetSize( self.nativewidth-100, self.nativeheight );	
	self.valueKey:SetZOrder(100);
	--self.labelKey:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 );	
	self.valueKey:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
	self.valueKey:SetMouseVisible( false );
	self.valueKey:SetText(value);	
	
	--self:SetBackColor( Turbine.UI.Color( 0.2, 0.2, 0.2 ) );
end

function TextNode:SetText(value)
	self.labelKey:SetText(value);
	if(value==nil or value=="") then
		self:SetSize( self.nativewidth, 0 );
	else
		self:SetSize( self.nativewidth, self.nativeheight );
	end	
end

function TextNode:SetValue(value)
	self.valueKey:SetText(value);
	if(value==nil or value=="") then
		self:SetSize( self.nativewidth, 0 );
	else
		self:SetSize( self.nativewidth, self.nativeheight );
	end
end