ToggleButton = class( Turbine.UI.Label );

function ToggleButton:Constructor(width, height, background)	  	
	Turbine.UI.Label.Constructor( self );    	
	
	self:SetSize( width, height );
	--self:SetBackColor(Turbine.UI.Color( 0.2, 0.2, 0.2 ));

	self.backLabel = Turbine.UI.Label();
	self.backLabel:SetParent( self );	
	self.backLabel:SetPosition(0, 0);
	self.backLabel:SetSize(width, height);
	self.backLabel:SetBackground(background);
	self.backLabel:SetMouseVisible(false);
	self.pushed = false;
	if(defaultPosition~= nil) then
		self.pushed = defaultPosition;
	end
	
	self.crossLabel = Turbine.UI.Label();
	self.crossLabel:SetParent( self );	
	self.crossLabel:SetPosition(width-14, height-14);
	self.crossLabel:SetSize(12, 12);
	self.crossLabel:SetBackground("WalmPlugins/WarbandsSlayer/resources/cross.tga");
	self.crossLabel:SetMouseVisible(false);
	self.crossLabel:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	--self.crossLabel:SetVisible(self.pushed);
	self:SetChecked(self.pushed);
	
	self.MouseClick = function(sender, args)
		self:SetChecked(not self.pushed);
		if(self.Toggled ~= nil) then
			self.Toggled(self, self.pushed);
		end			
	end
	self.MouseDoubleClick = self.MouseClick;
end

function ToggleButton:IsSelected()
	return self.Toggled;
end

function ToggleButton:SetChecked(checked)
	if(type(checked) ~= "boolean")then
		Turbine.Shell.WriteLine("Err: ToggleButton:SetChecked expected a boolean, and had "..type(checked).."\n"..Turbine.Engine.GetCallStack());
		return;
	end
	self.pushed = checked;
	self.crossLabel:SetVisible(not self.pushed);
end