

function GetMapData(map)
	local mData = MapsData[map];
	if(mData~=nil and mData.CoordsByPixelsX==nil) then
		mData.CoordsByPixelsX = (mData.c.w - mData.c.e)/300;
		mData.CoordsByPixelsY = (mData.c.s - mData.c.n)/200;
		if(mData.CoordsByPixelsX<0) then mData.CoordsByPixelsX=0-mData.CoordsByPixelsX; end
		if(mData.CoordsByPixelsY<0) then mData.CoordsByPixelsY=0-mData.CoordsByPixelsY; end
	end
	return mData;
end

function GetWarbandByQuestName(name)
	if(name == nil) then
--		Turbine.Shell.WriteLine("<rgb=#FF5CCD>Erreur! GetWarbandByQuestName argument can't be nil !</rgb>");
		return nil;
	end
	lname = string.lower(name);
	for i=1, table.getn(wadData), 1 do
		for j=1, table.getn(wadData[i].areas), 1 do
			local area = wadData[i].areas[j];
			for k=1, table.getn(area.wads), 1 do
				local wad = area.wads[k];
				if(wad.questname==lname or wad.questname==name) then return wad; end
				if(wad.questname~=nil and (string.match(wad.questname, lname) or string.match(wad.questname, name))) then return wad; end
			end
		end
	end
	if(Preferences.debug == true) then
		Turbine.Shell.WriteLine("<rgb=#FF5CCD>Erreur, aucune troupe de guerre du nom de "..lname.." ("..name..") trouvee.</rgb>");
	end
	return nil;
end

function GetWarbandsCount(byType)
	if(byType == nil) then
		if(gWbCount~=nil) then return gWbCount; end;
		gWbCount = 0;
		for i=1, table.getn(wadData), 1 do
			for j=1, table.getn(wadData[i].areas), 1 do
				local area = wadData[i].areas[j];
				gWbCount = gWbCount + table.getn(area.wads);
			end
		end
		return gWbCount;
	else
		local typeCount = 0;
		for i=1, table.getn(wadData), 1 do
			for j=1, table.getn(wadData[i].areas), 1 do
				local area = wadData[i].areas[j];
				for k=1, table.getn(area.wads), 1 do
					local wad = area.wads[k];
					if(wad.enemyType==byType or (wad.enemyType==nil and byType==1)) then
						local classAllowed = (wad.loadingCondition==nil or wad.loadingCondition.class==nil or (wad.loadingCondition.class==Filters.class or ListContainsString(wad.loadingCondition.class,Filters.class)));
						local classNotAllowed = (wad.loadingCondition==nil or wad.loadingCondition.notClass==nil or (wad.loadingCondition.notClass~=Filters.class and ListContainsString(wad.loadingCondition.notClass,Filters.class)==false));
						if(wad.loadingCondition==nil or (classAllowed and classNotAllowed)) then
							if(wad.inc~=nil) then
								typeCount = typeCount + (wad.inc.max or 1);
							else
								typeCount = typeCount + 1;
							end
						end
					end
				end
			end
		end	
		return typeCount;
	end
end

function GetWarbandById(id)
	if(id == nil) then
--		Turbine.Shell.WriteLine("<rgb=#FF5CCD>Erreur! GetWarbandByQuestName argument can't be nil !</rgb>");
		return nil;
	end
	for i=1, table.getn(wadData), 1 do
		for j=1, table.getn(wadData[i].areas), 1 do
			local area = wadData[i].areas[j];
			for k=1, table.getn(area.wads), 1 do
				local wad = area.wads[k];
				if(wad.id == id) then return wad; end
			end
		end
	end
	if(Preferences.debug == true) then
		Turbine.Shell.WriteLine("<rgb=#FF5CCD>Erreur, aucune troupe de guerre avec l'id "..id.." trouvee.</rgb>");
	end
	return nil;
end
function GetWarbandByTarget(target)
	if(target == nil) then
--		Turbine.Shell.WriteLine("<rgb=#FF5CCD>Erreur! GetWarbandByQuestName argument can't be nil !</rgb>");
		return nil;
	end
	local target2=StringCleaner(target);
	for i=1, table.getn(wadData), 1 do
		for j=1, table.getn(wadData[i].areas), 1 do
			local area = wadData[i].areas[j];
			for k=1, table.getn(area.wads), 1 do
				local wad = area.wads[k];
				if(wad.target==target or wad.target==target2) then return wad; end
				if(wad.target=="SUB") then
					for l=1, table.getn(wad.poi), 1 do
						local poi = wad.poi[l];
						if((poi.t==target or poi.t==target2) and (PoiProgress==nil or PoiProgress[wad.id]==nil or PoiProgress[wad.id][poi.id]~=true)) then 
							return wad; 
						end
					end
				end
			end
		end
	end
	if(Preferences.debug == true) then
		Turbine.Shell.WriteLine("<rgb=#FF5CCD>Erreur, aucune entree avec target="..target.." trouvee.</rgb>");
	end
	return nil;
end

function GetWarbandByCollectible(collect, loc)
	if(collect==nil or loc==nil) then return nil end
	local x=0; local y=0;
	--loc = string.gsub( loc, ".", ",");
	local a, b, x1, x2, dir_x, y1, y2, dir_y = string.find(loc, "(%d*)%.(%d)([NS]), (%d*)%.(%d)([WE])");
	if(x1==nil or x2==nil or dir_x==nil or y1==nil or y2==nil or dir_y==nil) then
		Turbine.Shell.WriteLine("<rgb=#FF5CCD>Erreur : Impossible d'identifier vos coordonn\195\169es : vous \195\170tes certainement dans une zone instanci\195\169e.</rgb>"..loc);
		return nil;
	end

	if(dir_x=="N") then dir_x="[Nn]"; else dir_x="[Ss]"; end
	if(dir_y=="E") then dir_y="[Ee]"; else dir_y="[WwOo]"; end
	
	-- local requestx="(("..string.format("%.1f",x)..")|("..string.format("%.1f",x-0.1)..")|("..string.format("%.1f",x+0.1).."))[Nn]";
	-- requestx=string.gsub(requestx, ",", "%%%.");
	-- local requesty="(?:(?:"..string.format("%.1f",y)..")|(?:"..string.format("%.1f",y-0.1)..")|(?:"..string.format("%.1f",y+0.1).."))[WEwe]";
	-- requesty=string.gsub(requesty, ",", "%%%.");
	-- local request = "(?:"..requestx..", "..y1.."."..y2.."[WEwe])|(?:"..x1.."."..x2.."[Nn], "..requesty..")";
	-- Turbine.Shell.WriteLine("<rgb=#FF5CCD>requestx : </rgb>"..requestx);
	-- request="(30.0)|(30.1)[Nn]";
	
	local request =  x1.."."..x2..dir_x.."[, ]*"..y1.."."..y2..dir_y;
	local collect2=StringCleaner(collect);
	if(Preferences.debug==true) then
		Turbine.Shell.WriteLine("<rgb=#FF5CCD>RECHERCHE : </rgb>"..request);
		Turbine.Shell.WriteLine("<rgb=#FF5CCD>TARGET : </rgb>"..collect2);
	end
	for i=1, table.getn(wadData), 1 do
		for j=1, table.getn(wadData[i].areas), 1 do
			local area = wadData[i].areas[j];
			for k=1, table.getn(area.wads), 1 do
				local wad = area.wads[k];
				if(wad.target==collect or wad.target==collect2 or wad.target=="SUB") then 
					if(Preferences.debug==true) then Turbine.Shell.WriteLine("<rgb=#FF5CCD>FOUND wad : </rgb>"..wad.name); end
					local poi=GetWarbandByCollectiblePOIRequest1(wad, collect, request);
					local x = tonumber(x1)+tonumber(x2)/10;
					local y = tonumber(y1)+tonumber(y2)/10;				
					if(poi==nil) then
						poi=GetWarbandByCollectiblePOIRequest1(wad, collect, x1.."."..x2..dir_x.."[, ]*"..string.gsub(string.format("%.1f",y-0.1),",",".")..dir_y);
					end
					if(poi==nil) then
						poi=GetWarbandByCollectiblePOIRequest1(wad, collect, x1.."."..x2..dir_x.."[, ]*"..string.gsub(string.format("%.1f",y+0.1),",",".")..dir_y);
					end
					if(poi==nil) then
						poi=GetWarbandByCollectiblePOIRequest1(wad, collect, string.gsub(string.format("%.1f",x-0.1),",",".")..dir_x.."[, ]*"..y1.."."..y2..dir_y);
					end
					if(poi==nil) then
						poi=GetWarbandByCollectiblePOIRequest1(wad, collect, string.gsub(string.format("%.1f",x+0.1),",",".")..dir_x.."[, ]*"..y1.."."..y2..dir_y);
					end
					if(poi~=nil) then
						if(Preferences.debug==true) then  Turbine.Shell.WriteLine("<rgb=#FF5CCD>FOUND POI : </rgb>"..poi.c.." "..(poi.l or "nihil")); end
						if PoiProgress == nil then PoiProgress = {}; end
						if PoiProgress[wad.id] == nil then PoiProgress[wad.id] = {}; end
						PoiProgress[wad.id][poi.id] = true;
						SavePOI(false);
						warbandsDialog:OnPOIUpdated(wad, poi);
						Turbine.Shell.WriteLine(TRAD("<rgb=#FF5CCD>Le collectible \""..collect.."\" trouv\195\169 \195\160 "..loc.." a bien \195\169t\195\169 ajout\195\169 \195\160 la collection \""..wad.name.."\"", "<rgb=#FF5CCD>The collectible \""..collect.."\" found at "..loc.." has been added to your collection \""..wad.name.."\""));
						warbandsDialog:AddCooldown(wad, wad.name, CheckPOICompletion(wad), false);	
						return wad;
					end
					if(Preferences.debug==true) then  Turbine.Shell.WriteLine("<rgb=#FF5CCD>LOC NOT FOUND :/ </rgb>"); end
				end
			end
		end
	end	
	return nil;
end

function GetWarbandByCollectiblePOIRequest1(wad, collect, request)
	if(Preferences.debug==true) then  Turbine.Shell.WriteLine("<rgb=#FF5CCD>Test new request : </rgb>"..request); end
	if(wad~=nil and wad.poi~=nil) then
		return GetWarbandByCollectiblePOIRequest2(wad, collect, wad.poi, request);
	elseif(wad~=nil and wad.multipoi~=nil) then
		local poi = nil;
		for l=1, table.getn(wad.multipoi), 1 do
			if(poi==nil) then
				poi = GetWarbandByCollectiblePOIRequest2(wad, collect, wad.multipoi[l].poi, request);
			end
			if(poi~=nil)then return poi; end
		end
	end
end

function GetWarbandByCollectiblePOIRequest2(wad, collect, POIList, request)
	if(POIList==nil) then return nil; end
	for i, poi in ipairs(POIList) do
		local collect2=StringCleaner(collect);
		if(poi~=nil and poi.c~=nil and wad.target~="SUB") then
			local found=string.find(poi.c, request);
			if(Preferences.debug==true and poi.id==5) then 
				local prout="NIHIL"; if(found~=nil) then prout="FOUND"; end
				Turbine.Shell.WriteLine("<rgb=#FF5CCD>TESTING A \""..request.."\" with \""..poi.c.."\" => RSLT="..prout); 
			end			
			--if(found==nil and poi.c2~=nil) then found=string.find(poi.c2, request); end
			if(found~=nil and (PoiProgress==nil or PoiProgress[wad.id]==nil or PoiProgress[wad.id][poi.id]~=true)) then
				return poi;
			end
		elseif (poi~=nil and poi.c~=nil and wad.target=="SUB" and (collect==poi.t or collect2==poi.t)) then
			if(Preferences.debug==true) then Turbine.Shell.WriteLine("<rgb=#FF5CCD>TESTING B \""..request.."\" with \""..poi.c.."\""); end
			local found=string.find(poi.c, request);
			--if(found==nil and poi.c2~=nil) then found=string.find(poi.c2, request); end
			if(found~=nil and (PoiProgress==nil or PoiProgress[wad.id]==nil or PoiProgress[wad.id][poi.id]~=true)) then
				return poi;
			end		
		end
	end
	return nil;
end

function CheckPOICompletion(warband)
	if(warband==nil or (warband.poi==nil and warband.multipoi==nil)) then return false; end
	local okCnt = 0;
	for i=1, table.getn(PoiProgress[warband.id]), 1 do 
		if(PoiProgress[warband.id][i]==true) then okCnt=okCnt+1; end
	end
	if(warband.poi~=nil) then 
		return okCnt==table.getn(warband.poi);
	elseif(warband.multipoi~=nil) then
		local count=0;
		for i=1, table.getn(warband.multipoi), 1 do 
			local poi = warband.multipoi[i];
			count = count + table.getn(poi.poi);
		end
		return okCnt==count;
	end	
	return false;
end