WarbandsNode = class( Turbine.UI.TreeNode );

function WarbandsNode:Constructor(wb, region)
	self.warband = wb;
	self.region = region;
	
	Turbine.UI.TreeNode.Constructor( self );    	
	self:SetSize( 312, 35 );
	self:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	
	self.labelLevel = Turbine.UI.Label();
	self.labelLevel:SetParent( self );
	self.labelLevel:SetSize( 27, 16 );
	self.labelLevel:SetPosition( 40, 4 );
	self.labelLevel:SetZOrder(100);
	self.labelLevel:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 );	
	self.labelLevel:SetTextAlignment( Turbine.UI.ContentAlignment.TopLeft );
	self.labelLevel:SetMouseVisible( false );
	self.labelLevel:SetText(value);

	self.labelValue = Turbine.UI.Label();
	self.labelValue:SetParent( self );
	self.labelValue:SetSize( 240, 26 );
	self.labelValue:SetPosition( 71, 4 );
	self.labelValue:SetZOrder(100);
	self.labelValue:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 );	
	self.labelValue:SetTextAlignment( Turbine.UI.ContentAlignment.TopLeft );
	self.labelValue:SetMouseVisible( false );
	self.labelValue:SetText(value);

	self.iconQuest = Turbine.UI.Control();
	self.iconQuest:SetParent( self );
	self.iconQuest:SetSize( 22, 23 );
	self.iconQuest:SetPosition( self:GetWidth()-30, 6 );
	self.iconQuest:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.iconQuest:SetMouseVisible( false );
	self.difficultyIcone = Turbine.UI.Control();
	self.difficultyIcone:SetParent( self );
	self.difficultyIcone:SetSize( 11, 12 );
	self.difficultyIcone:SetPosition( 42, 22 );
	self.difficultyIcone:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.difficultyIcone:SetMouseVisible( false );	

	self.tagIcone = Turbine.UI.Control();
	self.tagIcone:SetParent( self );
	self.tagIcone:SetSize( 32, 32 );
	self.tagIcone:SetPosition( 2, 0 );
	self.tagIcone:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.tagIcone:SetMouseVisible( false );	

	self.hightlight_middle = Turbine.UI.Label();
	self.hightlight_middle:SetParent( self );
	self.hightlight_middle:SetSize( self:GetWidth()-16, self:GetHeight() );
	self.hightlight_middle:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.hightlight_middle:SetPosition( 8, 0 );
	self.hightlight_middle:SetBackground( "WalmPlugins/WarbandsSlayer/resources/TdGCartouche/hightlight_middle.tga" );
	self.hightlight_middle:SetMouseVisible( false );
	self.hightlight_middle:SetVisible( false );
	self.hightlight_left = Turbine.UI.Label();
	self.hightlight_left:SetParent( self );
	self.hightlight_left:SetSize( 8, 36 );
	self.hightlight_left:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.hightlight_left:SetPosition( 0, 0 );
	self.hightlight_left:SetBackground( "WalmPlugins/WarbandsSlayer/resources/TdGCartouche/hightlight_left.tga" );
	self.hightlight_left:SetMouseVisible( false );	
	self.hightlight_left:SetVisible( false );	
	self.hightlight_right = Turbine.UI.Label();
	self.hightlight_right:SetParent( self );
	self.hightlight_right:SetSize( 8, 36 );
	self.hightlight_right:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	self.hightlight_right:SetPosition( self:GetWidth()-8, 0 );
	self.hightlight_right:SetBackground( "WalmPlugins/WarbandsSlayer/resources/TdGCartouche/hightlight_right.tga" );
	self.hightlight_right:SetMouseVisible( false );	
	self.hightlight_right:SetVisible( false );	

	self.SelectedChanged = function (o, e)
		self.hightlight_middle:SetVisible(self:IsSelected());
		self.hightlight_left:SetVisible(self:IsSelected());
		self.hightlight_right:SetVisible(self:IsSelected());
	end

	self.cooldown = false;	
	self.lastKillDate = nil;
	self:UpdateWBNodeStatus(self.warband.id, nil, true);	
	
	self:CreateIconeLabel();	
end

function WarbandsNode:CreateIconeLabel()	
	if(self.warband~=nil) then
		if(self.warband.target~=nil) then self.difficultyIcone:SetBackground("WalmPlugins/WarbandsSlayer/resources/difficulty/pick_mini.tga");
		else self.difficultyIcone:SetBackground("WalmPlugins/WarbandsSlayer/resources/difficulty/"..(self.warband.size or "1").."_mini.tga"); end
		local playerlvl = Filters.playerLevel or Turbine.Gameplay.LocalPlayer.GetInstance():GetLevel();
		local diff = (self.warband.level or playerlvl) - playerlvl;
		if(diff>=1 and diff<=-1) then
			self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/white.tga");
		elseif(diff==-2 or diff==-3) then
			self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/blue.tga");
			self.labelLevel:SetForeColor( Turbine.UI.Color(45/255, 80/255, 130/255) );
			self.labelValue:SetForeColor( Turbine.UI.Color(45/255, 80/255, 130/255) );
		elseif(diff==-4 or diff==-5) then
			self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/cyan.tga");
			self.labelLevel:SetForeColor( Turbine.UI.Color(0, 1, 1) );
			self.labelValue:SetForeColor( Turbine.UI.Color(0, 1, 1) );
		elseif(diff<=-6 and diff>=-8) then 
			self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/green.tga");
			self.labelLevel:SetForeColor( Turbine.UI.Color(0, 1, 0) );
			self.labelValue:SetForeColor( Turbine.UI.Color(0, 1, 0) );
		elseif(diff<-8) then
			self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/grey.tga");
			self.labelLevel:SetForeColor( Turbine.UI.Color(0.5, 0.5, 0.5) );
			self.labelValue:SetForeColor( Turbine.UI.Color(0.5, 0.5, 0.5) );
		elseif(diff==2 or diff==3) then
			self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/yellow.tga");
			self.labelLevel:SetForeColor( Turbine.UI.Color(1, 1, 0) );
			self.labelValue:SetForeColor( Turbine.UI.Color(1, 1, 0) );
		elseif(diff==4 or diff==5) then
			self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/orange.tga");
			self.labelLevel:SetForeColor( Turbine.UI.Color(1, 0.5, 0) );
			self.labelValue:SetForeColor( Turbine.UI.Color(1, 0.5, 0) );
		elseif(diff==6 or diff==7) then 
			self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/red.tga");
			self.labelLevel:SetForeColor( Turbine.UI.Color(1, 0, 0) );
			self.labelValue:SetForeColor( Turbine.UI.Color(1, 0, 0) );
		elseif(diff>7) then 
			self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/purple.tga");	
			self.labelLevel:SetForeColor( Turbine.UI.Color(150/255, 0, 0.5) );
			self.labelValue:SetForeColor( Turbine.UI.Color(150/255, 0, 0.5) );
		else
			self:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/white.tga");
		end
		if(self.warband.level~=nil and self.warband.level>0) then
			self.labelLevel:SetText("["..self.warband.level.."]");
		end
		self.labelValue:SetText(self.warband.name);
		
		if(self.warband.enemyType==1 or self.warband.enemyType==nil) then
			self.tagIcone:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/tag_wb.tga");
		elseif(self.warband.enemyType==2) then
			self.tagIcone:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/tag_kill.tga");
		elseif(self.warband.tag~=nil) then
			self.tagIcone:SetBackground("WalmPlugins/WarbandsSlayer/resources/TdGCartouche/"..self.warband.tag);
		end
	end
end

function WarbandsNode:UpdateWBNodeStatus(wbid, warbandLastKillDate, cdUp, alwaysOn, warbandsCooldown)
	if(self.warband.id == wbid) then
		if(self.warband.repeatable~=nil) then
			local currentGameTime = Turbine.Engine.GetLocalTime();
			if(warbandsCooldown==nil or (warbandsCooldown~=nil and (warbandsCooldown.resetTime==nil or warbandsCooldown.resetTime<currentGameTime))) then
				self.status = 0;
			else
				self.status = 3;
			end
		elseif warbandsCooldown~=nil and warbandsCooldown.value~=nil then
			if(self.warband.inc~=nil and self.warband.inc.max~=nil and warbandsCooldown.value>=self.warband.inc.max) then
				self.status = 2;
			elseif(self.warband.inc~=nil and self.warband.inc.progressMax~=nil and warbandsCooldown.value==0 and (warbandsCooldown.progress or 0)>0) then
				self.status = 1;
			elseif(self.warband.inc~=nil and self.warband.inc.max~=nil and (warbandsCooldown.value or 0)>0 and (warbandsCooldown.value or 0)<self.warband.inc.max) then
				self.status = 1;
			elseif(self.warband.inc~=nil and self.warband.inc.max==nil and warbandsCooldown.value>0) then
				self.status = 2;
			else
				self.status = 0;
			end
		elseif(self.warband.poi~=nil) then
			if(PoiProgress~=nil and PoiProgress[self.warband.id]~=nil) then
				local cpt = 0;
				for i, poi in pairs(self.warband.poi) do
					if(PoiProgress[self.warband.id][poi.id]==true) then cpt=cpt+1; end
				end
				if(cpt==0) then self.status = 0;
				elseif(cpt>=table.getn(self.warband.poi)) then self.status = 2;
				else self.status = 1; end
			else
				self.status = 0;
			end
		elseif(self.warband.multipoi~=nil) then
			if(PoiProgress~=nil and PoiProgress[self.warband.id]~=nil) then
				local cpt = 0; local total=0;
				for i, pois in pairs(self.warband.multipoi) do
					total=total+table.getn(pois.poi);
					for j, poi in pairs(pois.poi) do
						if(PoiProgress[self.warband.id][poi.id]==true) then cpt=cpt+1; end
					end
				end
				if(cpt==0) then self.status = 0;
				elseif(cpt>=total) then self.status = 2;
				else self.status = 1; end
			else
				self.status = 0;
			end
		elseif(warbandLastKillDate~=nil and self.warband.repeatable==false and alwaysOn==nil) then
			self.status = 3;
		elseif(alwaysOn~=nil and alwaysOn==true) then
			self.status = 3;
		elseif((alwaysOn==nil or alwaysOn==false) and not cdUp ) then	
			self.status = 3;
		end
		
		if(self.status==1) then
			self.iconQuest:SetBackground( "WalmPlugins/WarbandsSlayer/resources/inprogress.tga" );
		elseif(self.status==2) then
			self.iconQuest:SetBackground( "WalmPlugins/WarbandsSlayer/resources/green_check.tga" );
		elseif(self.status==3) then
			self.iconQuest:SetBackground( "WalmPlugins/WarbandsSlayer/resources/hourglass2.tga" );
		else
			self.iconQuest:SetBackground( nil );
			self.status = 0;
		end
		self.cooldown = cdUp;	
		self.lastKillDate = warbandLastKillDate;
	end
end

function WarbandsNode:AppliFilters(filters)
	local shouldshow = 1;
	if(self.warband~= nil and filters~=nil) then		
		if(filters.show1 and self.warband.size==1) then
			shouldshow = 0;
		elseif(filters.show6 and (self.warband.size==6 or self.warband.size==3 or self.warband.size==12)) then
			shouldshow = 0;
		elseif(not filters.todo and self.status~=2 and self.status~=3) then
			shouldshow = 0;
		elseif(not filters.done and (self.status==2 or self.status==3)) then
			shouldshow = 0;
		elseif(string.find(string.lower(self.warband.name), filters.search)==nil) then
			shouldshow = 0;
		elseif(not filters.unrepeat and self.warband.repeatable~=nil and self.warband.repeatable==false) then
			shouldshow = 0;
		elseif((filters.tab==nil or filters.tab==1) and not (self.warband.enemyType==nil or self.warband.enemyType==1)) then
			shouldshow = 0;
		elseif(filters.tab==2 and self.warband.enemyType~=2) then
			shouldshow = 0;
		elseif(filters.tab==4 and self.warband.enemyType~=4) then
			shouldshow = 0;
		elseif(filters.tab==5 and self.warband.enemyType~=5) then
			shouldshow = 0;
		elseif(filters.tab==3 and self.warband.poi==nil and self.warband.multipoi==nil) then
			shouldshow = 0;	
		elseif(filters.lvlp5==true and self.warband.level~=nil and (Filters.playerLevel-self.warband.level<-6 or Filters.playerLevel-self.warband.level>6)) then
			shouldshow = 0;
		elseif(filters.filtre_customrep==false and self.warband.custom==true) then
			shouldshow = 0;
		end
		
		if(shouldshow~=0) then
			if(self.warband.enemyType==5 and self.warband.rewards~=nil)then
				local foundItem = false;
				for i, v in ipairs(self.warband.rewards) do 
					if((filters.filtre_rewardVertues~=false and v[1]==Rewards.VERTUES) or
					(filters.filtre_rewardBraises~=false and v[1]==Rewards.BRAISES) or
					(filters.filtre_rewardGrains~=false and v[1]==Rewards.GRAINS) or
					(filters.filtre_rewardTraceries~=false and v[1]==Rewards.TRACERIES_RUNES) or
					(filters.filtre_rewardReput~=false and v[1]==Rewards.REPUTATION) ) then
						foundItem = true;
					end
				end
				if(foundItem==false) then 
					shouldshow = 0;
				end
			elseif(filters.targetEriador==false and self.region==1)then
				shouldshow = 0;
			elseif(filters.targetRhovanion==false and self.region==2)then
				shouldshow = 0;
			elseif(filters.targetGondor==false and self.region==3)then
				shouldshow = 0;
			elseif(filters.filtre_fanorien==false and self.region==4)then
				shouldshow = 0;
			else
			end
		end
		if(shouldshow==1) then
			self:SetSize(312, 35);
		else
			self:SetSize(312, 0);
		end
	end
	self:CreateIconeLabel();
	return shouldshow;
end

function WarbandsNode:ExpandAll()
	self:SetExpanded(true);
	for i=1, self:GetChildNodes():GetCount(), 1 do
		self:GetChildNodes():Get(i):ExpandAll();
	end
end

function WarbandsNode:CollapseAll()
	self:SetExpanded(false);
	for i=1, self:GetChildNodes():GetCount(), 1 do
		self:GetChildNodes():Get(i):CollapseAll();
	end	
end