
Difficulty = {
	FAIBLE={
		name="Weak";
	},
	NORMAL={
		name="Normal";
	},
	SIGNATURE={
		name="Signature";
	},
	ELITE={
		name="Elite";
	},
	GRAND_ELITE={
		name="Great Elite";
	},
	NEMESIS={
		name="Nemesis";
	},
	NEMESIS_SUPREME={
		name="Supreme Nemesis";
	},
	TBD={
		name="TBD";
	},
	CANICHE={
		name="Poodle";
	};
};

-- Format: {id, "wb_name", area_id, "quest_name", Coordinate{x,"S/N", y, "W/E"}, size[1,3,4,12], lvl, moral, "race", Adds{Qty, "name", lvl}, "comment", <Rewards{qty, id}>, priority, "frame_name" }

wadData = {
	{name="Repetables added", insertCustoms=true, region=0, areas={
		{name="Repetables added", showme=false, insertCustoms=true, wads={
			-- Made by player
		}}
	}},
	{name="Craft", region=0, areas={
		{name="Craft", showme=false, wads={
			{id=5009, name="Craft for Embers", enemyType=5, size=1, level=120, questname="craftforembers", subname="craftforembers", rewards={{Rewards.BRAISES, 1000}},quest={pnj="Mozhek", loc="Skarald (34.7N, 45.4W)"}, how="Craft 7 [Ember-worthy crafts]", repeatable=1, tag="tag_braises.tga"},
			{id=5012, name="Craft for Motes", enemyType=5, size=1, level=130, questname="craftformotes", subname="craftformotes", rewards={{Rewards.GRAINS, 250}},quest={pnj="Motes and Ember Craft Traider", loc="Bree Market Square (30.3S, 51.2W)"}, how="Craft 7 [Motes-worthy crafts]", repeatable=1, tag="tag_grains.tga"}
		}}
	}},
	{name="Character", region=0, areas={
		{name="Leveling", wads={
			--{id=-1, name="TEST", enemyType=4, frame=nil, level=7, tag="tag_lvl.tga", loadingCondition={class={172, 214}}},
			{id=10001, name="Points earned when leveling up", enemyType=4, frame=nil, inc={max=55, updatefct=function() warbandsDialog:AddLevelCooldown(); end}, how="Your character earns Class Trait points as you level up:\n* Levels 7 to 105 : 1 point every 2 levels\n* Levels 108 to 114 : 1 point every 3 levels\n* Level 120 : 1 point\n* Level 140 : 1 point", loadingCondition={notClass=214}, updateMsg="LVL", tag="tag_lvl.tga"},
			{id=10020, name="Points earned when leveling up",  enemyType=4, frame=nil, inc={max=58, updatefct=function() warbandsDialog:AddLevelCooldown(); end}, how="Your character earns Class Trait points as you level up (the benornid having different calculation rules):\n* Levels 7 to 105 : 1 point every 2 levels\n* Level 15 : 1 point\n* Level 30 : 1 point\n* Level 60 : 1 point\n* Levels 108 to 114 : 1 point every 3 levels\n* Level 120 : 1 point\n* Level 140 : 1 point", loadingCondition={class=214}, updateMsg="LVL", tag="tag_lvl.tga"},
		}},	
		{name="Epic Battles", wads={
			{id=10003, name="100 Promotion Points", enemyType=4, frame=nil, inc={progressMax=100}, how="Promotion Points are obtained by earning new medals during Epic Battles.", check={default="From the Epic Battles pannel (key MAJ+B by default) and then the tab \"Promotions\"."}, updateMsg="GB", tag="tag_gb.tga"},
			{id=10004, name="200 Promotion Points", enemyType=4, frame=nil, inc={progressMax=200}, how="Promotion Points are obtained by earning new medals during Epic Battles.", check={default="From the Epic Battles pannel (key MAJ+B by default) and then the tab \"Promotions\"."}, updateMsg="GB", tag="tag_gb.tga"}
		}},	
		{name="Class Quests and Deeds", wads={ 
			{id=10010, name="Class Deeds - Tier 1", enemyType=4, frame="deed.tga", how="This meta-deed is validated by completing the following deeds:\nSTEPS", questname="ClassDeedsTier1", inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Class Deeds - Tier 1", validatefct=true}, check={cdiary="Class Deeds - Tier 1"}, replaceStringsByClass={{key="STEPS", str={[214]="* Complete Get your Bearings\n* Complete Quick Slash\n* Complete Full Force",[162]="* Complete Quick as the Wind\n* Complete Sturdy Traps\n* Complete Blindsided",[194]="* Complete Wary Blocks\n* * Complete Know Your Enemy\n* Skill and Power",[31]="* Complete Harmonious Melody\n* Complete Herald's Hammer\n* Complete Smooth Voice",[193]="* Complete Winter-storm\n* Complete Thunderous Words\n* Complete Master of Allusion",[40]="* Complete Hidden Dagger\n* Complete Cunning Wound\n* Complete Swift and Subtle",[23]="* Complete Stinging Blow\n* Complete Shield Expertise\n* Complete Reactive Block",[172]="* Complete Swift to Anger\n* Complete All in All\n* Complete Deadly Strikes",[24]="* Complete Renewed Voice\n* Complete Devastation\n* Complete With Absolute Certainty",[185]="* Complete Master of the Staff\n* Complete Light of Hope\n* Complete Power and Wisdom",[215]="* Complete Set-up Strikes\n* Complete Overhand Smash\n* Complete Smash Through the Ranks"}}}, updateMsg="DO", tag="tag_deed.tga"},
			{id=10011, name="Class Deeds - Tier 2", enemyType=4, frame="deed.tga", how="Cette meta-prouesse de CLASS se valide en faisant les prouesses suivantes, consitant at executer les comp\195\169tances du meme nom:\nSTEPS", questname="ClassDeedsTier2", inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Class Deeds - Tier 2", validatefct=true}, check={cdiary="Class Deeds - Tier 2"}, replaceStringsByClass={{key="STEPS", str={[214]="* Complete Building Rage\n* Complete Hearten !\n* Complete Hearth and Home",[162]="* Complete Strong Draw\n* Complete Combat Traps\n* Complete Heightened Senses",[194]="* Complete Efficient Thrust\n* Complete Shield-trickery\n* Complete Deadly Insult",[31]="* Complete Powerful Voice\n* Complete Enduring Morale\n* Complete Life-singer",[193]="* Complete Tale of Rage\n* Complete Rune Master\n* Complete Versatility",[40]="* Complete Leaf-walker\n* Complete Side-step\n* Complete Perplexing Riddle",[23]="* Complete Controlled Breathing\n* Complete Guardian's Ward\n* Complete Retaliatory Strike",[172]="* Complete Winds of the Storm\n* Complete Rip to Shreds\n* Complete Wild Thing",[24]="Complete A Sense of Urgency\n* Complete A Call to Arms\n* Complete Fear No Darkness",[185]="* Complete Master of Beasts\n* Complete Deep Lore\n* Complete Dunadan-learning",[215]="* Complete Long-distance Fling\n* Complete Serious Demeanor\n* Complete Make a Mockery"}},{key="CLASS", str={[214]="Beorning",[162]="Hunter",[194]="Warden",[31]="Minstrel",[193]="Rune-keeper",[40]="Burglar",[23]="Guardian",[172]="Champion",[24]="Captain",[185]="Lore-master",[215]="Brawler"}}}, updateMsg="DO", tag="tag_deed.tga"},
			{id=10012, name="Class Deeds - Tier 3", enemyType=4, frame="deed.tga", how="This meta-deed is validated by completing the following deeds:\nSTEPS", questname="ClassDeedsTier3", inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Class Deeds - Tier 3", validatefct=true}, check={cdiary="Class Deeds - Tier 3"}, replaceStringsByClass={{key="STEPS", str={[214]="* Complete the quest \"The speech of animals\" (Clothar at Camp of Adso)\n* Complete Rattling Roar\n* Complete Master the Basics",[162]="* Complete Focused and Ready\n* Complete Swift and Sharp\n* Complete the quest \"The Hunter's Path\" (level 15 given by a mentor)",[194]="* Complete the quest \"A Spear at the Southern March\"\n*Complete Skillful Blocking\n* Complete Find Weakness",[31]="* Complete Unrelenting\n* Complete the quest \"A Song for the Company\" (level 15, by mentor)\n* Complete Light in the Dark",[193]="* Complete the quest \"An Eye in the Storm\" (level 15 by the mentor)\n* Complete Conflagration of Runes\n* Complete Confounding Principles",[40]="* Complete the quest \"A Thief in the Night\" (level 15 by the mentor)\n* Complete Cruel Odds\n* Complete Bleeding is Better",[23]="* Complete Swept Away\n* Complete To the Rescue\n* Complete the quest \"A Shield Against Adversity\"",[172]="* Complete the quest \"A Blade of Renown\" (level 15)\n* Complete Call of the Wild\n* Complete A Challenge Accepted",[24]="* Complete the quest \"An Inspiration to Men\" (level 15 by the mentor)\n* Complete Valour\n* Complete Strong Voice",[185]="* Complete Healer\n* Complete A Shocking Strike\n* Complete the quest \"A Well-Ordered Mind\" (level 15 by the mentor)",[215]="* Complete The Way of the Fulcrum\n* Complete The Way of the Maelstrom"}}}, updateMsg="DO", tag="tag_deed.tga"},
			{id=10013, name="Class Deeds - Tier 4", enemyType=4, frame="deed.tga", how="This meta-deed is validated by completing the following deeds:\nSTEPS", questname="ClassDeedsTier4", inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Class Deeds - Tier 4", validatefct=true}, check={cdiary="Class Deeds - Tier 4"}, replaceStringsByClass={{key="STEPS", str={[214]="* Complete Beorn's Gift\n* Complete Unexpectidly Agile\n* Complete Weight on their Shoulders",[162]="* Complete True Shot\n* Complete Deadly Precision\n* Complete Cut Them Down",[194]="Complete Never Say Die\n* Complete A Keen Response\n* Complete Strong Voice",[31]="* Complete Improved Herald's Strike\n* Complete Improved Raise the Spirit\n* Complete DynFriendc Performance",[193]="* Complete Written in Stone\n* Complete The Prophetic Word\n* Complete A Critical Writ",[40]="* Complete Strike from Shadows\n* Complete Mass Confusion\n* Complete Trickster",[23]="* Complete Heat of Battle\n* Complete Phantom Pain\n* Complete Grim Challenge",[172]="* Complete Flashing Blade\n* Complete Deep Strikes\n* Complete At the Ready",[24]="* Complete Improved Routing Cry\n* Expert Attacks\n* Brother in Arms",[185]="* Complete Harmony with Nature\n* Complete Subtlety of Wisdom\n* Complete Improved Inner Flame",[215]="* Complete Rally the Fellowship\n* Complete The Brawler's Dance\n* Complete Unflappable"}}}, updateMsg="DO", tag="tag_deed.tga"},
			{id=10014, name="Class Deeds - Tier 5", enemyType=4, frame="deed.tga", how="This meta-deed is validated by completing the following deeds:\nSTEPS", questname="ClassDeedsTier5", inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Class Deeds - Tier 5", validatefct=true}, check={cdiary="Class Deeds - Tier 5"}, replaceStringsByClass={{key="STEPS", str={[214]="* Complete A thousand Stringers\n* Complete Overbearing Presence\n* Complete the quest \"Hatred of Bears and Men\" (level 30)",[162]="* Complete Poison? What Poison?\n* Complete Stealthy Shot\n* Complete the quest \"A Hunter's Charge\" (level 30)",[194]="* Complete the quest \"A Defence in the Darkness\"\n* Complete Efficient Shield-work\n* Complete Perseverance",[31]="* Complete Silver Tongue\n* Complete the quest \"A Minstrel's Hope\" (level 30)\n* Complete Graceful Demeanour	",[193]="* Complete the quest \"The Word of a Healer\" (level 30)\n* Complete Harsh Words\n* Complete Epic Essay",[40]="* Complete Footpad\n* Complete the quest \"A Burglar's Errand\"\n* Complete Opportunist",[23]="* Complete Quickness\n* Complete First Line of Defence\n* Complete the quest \"A Guardian's Duty\" (niveau 30)",[172]="* Complete Raging Storm\n* Complete No Surrender\n* Complete the quest \"A Champion's Courage\" (level 30, at Ost Guruth)",[24]="* Now for Wrath\n* Complete the quest \"A Captain's Standard\" (level 30)\n* Complete Quick Wrist",[185]="* Complete the quest \"A Loremaster's Will\" (level 30)\n* Complete Knowledge of the Past\n*Complete Tactically Adept",[215]="* Complete Fast Reflexes\n* Complete Balance"}}}, updateMsg="DO", tag="tag_deed.tga"},
			{id=10015, name="Class Deeds - Tier 6", enemyType=4, frame="deed.tga", how="This meta-deed is validated by completing the following deeds:\nSTEPS", questname="ClassDeedsTier6", inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Class Deeds - Tier 6", validatefct=true}, check={cdiary="Class Deeds - Tier 6"}, replaceStringsByClass={{key="STEPS", str={[214]="* Complete Overwhelming Strenght\n* Complete To battle !\n* Complete Stand Firm",[162]="* Complete The Quality of Mercy\n* Complete Skill Shot\n* Complete Total Attention",[194]="* Complete Terrible Visage\n* Complete Expert Hurler\n* Complete On the Brink of Victory",[31]="* Complete Subtle Movements\n* Complete Heralded Saviour\n* Complete Power of Song",[193]="* Complete Stare at the Flame\n* Complete Self Starter\n* Complete New Beginnings",[40]="* Complete Quick Wrist\n* Complete No Time For Games\n* Complete Burglarize",[23]="* Complete Brave Heart\n* Complete Quick Wrist\n* Complete The Best Defence is a Better Offence",[172]="* Complete Time of Need\n* Complete Clobbered\n* Complete Athletic",[24]="* Captain's Victory\n* In Darkest Days\n* Complete Inspire Valour",[185]="* Complete Proof against all Ills\n* Complete Awareness of Body\n* Complete The Study of Wind-lore",[215]="* Complete Opening Move\n* Complete Crowd Control\n* Complete The Proper Stance"}}}, updateMsg="DO", tag="tag_deed.tga"},
			{id=10016, name="Class Deeds - Tier 7", enemyType=4, frame="deed.tga", how="This meta-deed is validated by completing the following deeds:\nSTEPS", questname="ClassDeedsTier7", inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Class Deeds - Tier 7", validatefct=true}, check={cdiary="Class Deeds - Tier 7"}, replaceStringsByClass={{key="STEPS", str={[214]="* Complete Not the Bees !\n* Complete Impervious\n* Complete Natural Beorn Leadership",[162]="* Complete Tools of the Trade\n* Complete Dazed and Confused\n* Complete Sneaky Sneaky",[194]="* Complete Mighty Throw\n* Complete Master of the Spear\n* Complete Force of Personality",[31]="* Complete Improved Echoes of Battle\n* Complete Battle-hymn\n* Complete Strength of Voice",[193]="* Complete Closing Remarks\n* Complete Alternate Ending\n* Complete Sign of the Times",[40]="* Complete Better and Better\n* Complete Resistance is Futile\n* Complete Finish What You Started",[23]="* Complete Blocking Force\n* Complete Never Bashful\n* Complete Quick of Foot",[172]="* Complete Battle Acumen\n* Complete Heroic Resolve\n* Complete Tight Grip",[24]="* Tactical Prowess\n* Complete Deeds before Words\n* Never in Doubt",[185]="* Complete The Study of Fire-lore\n* Complete The Study of Frost-lore\n* Complete Improved Storm-lore",[215]="* Complete Ultimate Techniques\n* Complete Leg Strike"}}}, updateMsg="DO", tag="tag_deed.tga"},
			{id=10017, name="Class Deeds - Tier 8", enemyType=4, frame="deed.tga", how="This meta-deed is validated by completing the following deeds:\nSTEPS", questname="ClassDeedsTier8", inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Class Deeds - Tier 8", validatefct=true}, check={cdiary="Class Deeds - Tier 8"}, replaceStringsByClass={{key="STEPS", str={[214]="* Complete Beer in Mind and Hearth\n* Complete the quest \"The Path Homeward\"\n* Complete Beorn Might",[162]="* Complete Rapid Fire\n* Complete Shot Through the Heart\n* Complete Scorching Rain",[194]="* Complete Master of the Shield\n* Complete Master of the Fist\n* Complete Dark Before Dawn",[31]="* Complete Dauntless\n* Complete Lyrics of Bravery\n* Complete Spectacular Finish",[193]="* Complete Armour of Exaltation\n* Complete Master of Tragedy\n* Complete Wordsmith",[40]="* Complete An Unpleasant Surprise\n* Complete Insult to Injury\n* Complete On the Move",[23]="* Complete Final Straw\n* Complete Stoic\n* Complete Hit Where It Hurts",[172]="* Complete Mighty Blast\n* Complete Always in Control\n* Complete Bountiful Mercy",[24]="* Complete Adherent of Elendil\n* Complete Grave Digger\n* Complete Precise Ally",[185]="* Complete Improved Sign of Power: Command\n* Complete Improved Sign of Battle\n* Complete The Secret of Tar",[215]="* Complete Sharing is Caring\n* Complete Challenge the Corrupt"}}}, updateMsg="DO", tag="tag_deed.tga"},	
			{id=10036, name="Threat of a Good Punch", region=1, enemyType=4, frame="quest.tga", level=15, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Threat of a Good Punch", validatefct=true}, check={qdiary="Brawler"}, quest={pnj="Brom Hawksbeard", loc="Bree-town Jail"}, questname="ThreatofaGoodPunch", updateMsg="DO", tag="tag_ring.tga", loadingCondition={class=215}},
			{id=10035, name="The Melee in the Square", region=1, enemyType=4, frame="quest.tga", level=30, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*The Melee in the Square", validatefct=true}, check={qdiary="Brawler"}, quest={pnj="Brom Hawksbeard", loc="Bree-town Jail"}, questname="TheMeleeintheSquare", updateMsg="DO", tag="tag_ring.tga", loadingCondition={class=215}},
			{id=10030, name="BOOK1", enemyType=4, frame="deed.tga", level=39, how="Once level 39, buy the book \"BOOK1\" from your class mentor. It unlocks a deed requiring 8 pages.\nYou can find pages by killing ennemies in Misty Mountains, Trollshaws, Moria and Wildwoods.", questname="BOOK28of8", inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*BOOK1", validatefct=true}, check={cdiary="BOOK1"}, replaceStringsByClass={{key="BOOK1", str={[214]="Genealogy of the Beornings",[162]="The Furthest Charge",[194]="Chieftains of the Dunedain",[31]="The Rising Chord",[193]="Thunder and Flame",[40]="The Expert's Guide to Dirty Fighting",[23]="A Shield-maiden's Song",[172]="The Joy of Battle",[24]="The Candle's Flame",[185]="Of Leaf and Twig",[215]="Knowledge of Kicks"}},{key="BOOK2", str={[214]="GenealogyoftheBeornings",[162]="TheFurthestCharge",[194]="ChieftainsoftheDnedain",[31]="TheRisingChord",[193]="ThunderandFlame",[40]="TheExpertsGuidetoDirtyFighting",[23]="AShieldmaidensSong",[172]="TheJoyofBattle",[24]="TheCandlesFlame",[185]="OfLeafandTwig",[215]="KnowledgeofKicks"}}}, updateMsg="DO", tag="tag_deed.tga"},
			{id=10031, name="BOOK1", enemyType=4, frame="deed.tga", level=39, how="Once level 39, buy the book \"BOOK1\" from your class mentor. It unlocks a deed requiring 8 pages.\nYou can find pages by killing ennemies in Misty Mountains, Trollshaws, Moria and Wildwoods.", questname="BOOK28of8", inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*BOOK1", validatefct=true}, check={cdiary="BOOK1"}, replaceStringsByClass={{key="BOOK1", str={[214]="A Study of the Skin-changer",[162]="The Way of the Hunter",[194]="Bullroarer's Boy",[31]="Valour's Marches",[193]="Golu o Maeth",[40]="The Book of Knives",[23]="The Final Word",[172]="The Tome of Swords",[24]="The Treatise of Valour",[185]="Lore of the Blade",[215]="Martial Movement"}},{key="BOOK2", str={[214]="AStudyoftheSkinchanger",[162]="TheWayoftheHunter",[194]="BullroarersBoy",[31]="ValoursMarches",[193]="GoluoMaeth",[40]="TheBookofKnives",[23]="TheFinalWord",[172]="TheTomeofSwords",[24]="TheTreatiseofValour",[185]="LoreoftheBlade",[215]="MartialMovement"}}}, updateMsg="DO", tag="tag_deed.tga"},
			{id=10032, name="BOOK1", enemyType=4, frame="deed.tga", region=2, level=39, how="Once level 39, buy the book \"BOOK1\" from your class mentor. It unlocks a deed requiring 8 pages.\nYou can find pages by killing ennemies in Misty Mountains, Trollshaws, Moria and Wildwoods.", questname="BOOK28of8", inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*BOOK1", validatefct=true}, check={cdiary="BOOK1"}, replaceStringsByClass={{key="BOOK1", str={[214]="A Hobbit's Holiday",[162]="A Shot in the Dark",[194]="The Watch Against the Night",[31]="Melodies of the Valar",[193]="Whispers in the Dark",[40]="Knee-breaker's Manual",[23]="The Best Defence",[172]="The Artisan Blade",[24]="The Book of Oaths",[185]="The Book of Beasts",[215]="The Art of the Perfect Punch"}},{key="BOOK2", str={[214]="AHobbitsHoliday",[162]="AShotintheDark",[194]="TheWatchAgainsttheNight",[31]="MelodiesoftheValar",[193]="WhispersintheDark",[40]="KneebreakersManual",[23]="TheBestDefence",[172]="TheArtisanBlade",[24]="TheBookofOaths",[185]="TheBookofBeasts",[215]="TheArtofthePerfectPunch"}}}, updateMsg="DO", tag="tag_deed.tga"},
			{id=10005, name="NAME", enemyType=4, frame="quest.tga", size=12, region=1, level=50, how="This class quest is unlocked at level 45. You will have to complete two quests requiring each to collect 3 sets of items:\n\nQuest 1: Q1\n\nQuest 2: Q2", questname="SHORT", inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*NAME", validatefct=true}, check={qdiary="CLASSE"}, replaceStringsByClass={{key="CLASSE", str={[214]="Beornide",[162]="Hunter",[194]="Warden",[31]="Minstrel",[193]="Rune-keeper",[40]="Burglar",[23]="Guardian",[172]="Champion",[24]="Captain",[185]="Lore-master",[215]="Brawler"}},{key="NAME", str={[214]="Grimbeorn's Challenge",[162]="A Lesson from Legolas",[194]="Wisdom of the Wardens",[31]="A Lesson from Lindir",[193]="Deep Secrets of Rune-craft",[40]="A Lesson from Bilbo Baggins",[23]="A Lesson from Samwise Gamgee",[172]="A Lesson from Gimli",[24]="A Lesson from Boromir",[185]="A Lesson from Lord Elrond",[215]="Brawling Lessons"}},{key="SHORT", str={[214]="GrimbeornsChallenge",[162]="ALessonfromLegolas",[194]="WisdomoftheWardens",[31]="ALessonfromLindir",[193]="DeepSecretsofRunecraft",[40]="ALessonfromBilboBaggins",[23]="ALessonfromSamwiseGamgee",[172]="ALessonfromGimli",[24]="ALessonfromBoromir",[185]="ALessonfromLordElrond",[215]="BrawlingLessons"}},{key="Q1", str={[214]="\"Implements of Ferocity\" require:\n* 5 Brimstone-tinged Tarkrip-spears (Angmar)\n* Shataz's Cruel Bludgeon (Misty Mountains 30.6S, 1.8E)\n* 20 Splintered Warg Claws (Angmar or Misty Mountains)\n* 20 Barbed Barghest Tails (Imlad Balchorth)\n* Sigil of War (Gruglok in Urugarth)\n*Crimson Gorthorog Horn (Barashal in Carn Dum)",[162]="\Implements of the Hunt\" require:\n* Driftclaw's Razor-sharp Claw (30.2S, 3.2E Misty Mountains)\n* 5 Corroded Iron-crown Staves (in Fasach-falroid and Malenhad in Angmar)\n* 20 Clouded Worm Eyes (Forochel and Angmar)\n* 5 Venomous Dread Turtle Beaks (Angmar)\n* 5 Putrid Fingernails (Decaying Hands in Angmar)\n* Medallion of Passage (Carn Dum on Urro)\n* Putrid Slime of Helchgam (Carn Dum on Helchgam",[194]="\"A Warden's Second Best Ally\" require:\n* 6 Hoary Aurochs Hides (Misty Mountains)\n* Redtusk's Hide (Eregion 44.0S, 9.2W)\n* 10 Barbed Barghest Tails (Imlad Balchorth)\n* 20 Coiled Spider Spinnerets (Angmar)\n* Rune of Evil Presence (Carn Dum on Salvakh)\n* Teeth of the Gorthorog (Urugarth: Brzrip, Dushkal or Thordragh)",[31]="\"Implements of Song\" require:\n* 12 Chipped Rock-worm Fangs (Misty Mountains)\n* Narglup's Blunted Tooth (Angmar 1.8N, 36.6W)\n* 5 Corrosive Droplets (Angmar)\n* 15x Splintered Warg Claws (Angmar or Misty Mountains)\n* 5 Grisly Bat Talons (Angmar)\n* Emblem of Ritual (Urugarth on Morthrang)\n* Rune of Winged Dominance (Carn Dum on Mormoz)",[193]="\"Hewing a New Stone\" require:\n* 12 Misty-mountain Stones (Goblin-town)\n* Archivist nraig's Runes (17.5S, 69.5W Annuminas)\n* 12 Corroded Neekerbreeker Horns (Angmar)\n* 20 Hooked Warg Claws (Angmar or Forochel)\n* Sigil of War (Urugarth on Gruglok)\n* Rune of Winged Dominance (Carn Dum on Mormoz)",[40]="\"Implements of the Night\" require:\n* 5 Hollow Brimstone-leech Fangs (Angmar)\n* Narglup's Split Claw (Angmar 1.8N, 36.7W)\n* 20 Hateful Worm Eyes (Angmar, Eregion or Forochel)\n* 15 Venomous Dread Turtle Beaks (Angmar)\n* Warg-keeper's Token (Urugarth on Athpukh)\n* Cruel Talon of Azgoth (Carn Dum)",[23]="\"Articles of Fortitude\" require:\n* 10 Snow-encrusted Dourhand Boots (Misty Mountains)\n* Grimgore's Ashen Hide (Angmar 1.9N, 38.7W)\n* 25 Unyielding Drake Scales (Angmar or Moria)\n* 15 Gem-encrusted Nails (Angmar)\n* Flawless Scale of Lhugrien (Urugarth)\n* Warg-keeper's Token (Urugarth on Athpukh)",[172]="\"Articles of Valour\" require:\n* 10 Brimstone-tinged Tarkrp-boots (Misty Mountains)\n* Raillug's Frozen Hide (Misty Mountains 19.0S, 2.0W)\n* 20 Mottled Spider Mandibles (Angmar)\n 15 Bubbling Droplets (Angmar)\n* Bloodstained Tally Stick (Urugarth: Dafrim or Grishakrum)\n* Insignia of Battle (Urugarth on Sorkrank)",[24]="\"Implements of War\" require:\n* 8 Nasty Snowreap-knives (Misty Mountains)\n* Fakhthal's Jagged Blade (Angmar 5.3N, 36.6W)\n* 15 Coiled Spider Spinnerets (Angmar)\n* 15 Hateful Worm Eyes (*Angmar, Eregion or Forochel)\n* 5 Rotted Barghest Paws (Imlad Balchorth)\n* Teeth of the Gorthorog (Carn Dum on Barashal)\n* Medallion of Passage (Carn Dum on Urro)",[185]="\"Articles of Mystery\" require:\n* Grimgore's Matted Fur (Angmar 1.9N, 38.7W)\n* 12 Distasteful Corcur-emblems (Misty Mountains)\n* 15 Revered Wight Remains (Angmar or Forochel)\n* 15 Bubbling Dropletss (Angmar)\n* Putrid Slime of Helchgam (Carn Dum)\n* Goblin Badge of Rank (Urugarth on Akrur)",[215]="\"Articles of Durability\" require:\n* loots from Wildhoods\n* 20 Mottled Spider Mandibles (Angmar)\n* 15 Bubbling Dropletss\n* Ashen Gorthorog Horn (Carn Dum on Tarlug)\n* Goblin Badge of Rank (Urugarth on Akrur)"}},{key="Q2", str={[214]="\"Articles of Resilience\" require:\n* 12 Steam-scorched Carapaces (Corrupted Norboglir in Angmar)\n* Hogni's Spiked Helmet (28.0S, 0.8E Misty Mountains)\n* 20 Corroded Neekerbreeker Horns (	Corrupted Norboglir in Angmar)\n* 20 Grisly Bat Talons (Angmar)\n* Putrid Slime of Helchgam (Helchgam in Carn Dum)\n* Badge of Command (Lagmas in Urugarth)",[162]="\"Articles of Discovery\" require:\n* Zorrgolug's matted hide (6.2N, 37.0W Angmar)\n* 5 Brimstone-tinged Tarkrip helmets (Malenhad in Angmar)\n* 10 Glossy Cave-claw Skins (Angmar or Moria)\n* 15 Corroded Neekerbreeker Horns (Angmar)\n* Rune of Winged Dominance (Carn Dum on Mormoz)\n* Insignia of Battle (Urugarth on Sorkrank)",[194]="\"A Weapon of Might and Glory\" require:\n* 12 Invader's Breastplates (Annuminas)\n* Bryok's Spear (Forochel 12.2N, 82.0W)\n* 10 Revered Wight Remains (Angmar or Forochel)\n* 20 Gem-encrusted Nails (Cave-claw of Angmar)\n* Bloodstained Tally Stick (Urugarth on Grishakrum)\n* Crimson Gorthorog Horne (Carn Dum on Barashal)",[31]="\"Articles of Harmony\" require:\n* 12 Matted Snow-beast Fur (Misty Mountains)\n* 5 Brimstone-tinged Tarkrp-plates (Tarkrip of Angmar)\n* 15 Clouded Worm Eyes (Forochel and Angmar)\n* 20 Revered Wight Remains (Angmar or Forochel)\n* Ashen Gorthorog Horn (Carn Dum on Tarlug)\n* Goblin Badge of Rank (Urugarth on Akrur)",[193]="\"A Worthy Garment\" require:\n* 12 Glad Ereg Vines (wood-trolls and Huorns of Eregion)\n* Helchuan's hide (10.3N, 81.2W Forochel)\n* 10 Rotted Barghest Paws (Imlad Balchorth)\n* 20 Corrosive Droplets (Angmar)\n* Ashen Gorthorog Horn (Carn Dum on Tarlug)\n* Badge of Command (Urugarth on Lagmas)",[40]="\"Articles of Cunning\" require:\n* 12 Blinding Snowbeast-furs (Misty Mountains)\n* Driftclaw's Windswept Hide (Misty Mountains 30.4S, 3.2E)\n* 20 Unyielding Drake Scales (Angmar or Moria)\n* 10 Glossy Cave-claw Skins (Angmar or Moria)\n* Goblin Badge of Rank (Urugarth on Akrur)\n* Insignia of Battle (Urugarth on Sorkrank and Burzfil)",[23]="\"Implements of Battle\" require:\n* Shataz's Cruel Bludgeon (Misty Mountains 30.6S, 1.8E)\n* 5 Brimstone-tinged Tarkrip-spears (Angmar)\n* 20 Grisly Bat Talons (Angmar)\n* 15 Mottled Spider Mandible (Angmar or Forochel)\n* 5 Hooked Warg Claws\n* Crimson Gorthorog Horn (Carn Dum on Tarlug)\n* Sigil of War (Urugarth on Gruglok)",[172]="\"Implements of Daring\" require:\n* 5 Notched Ongburz-swords (Angmar)\n*Tramug's Hand-axe (Angmar 0.7S, 32.0W)\n* 20 Splintered Warg Claws (Angmar or Misty Mountains)\n 20 Barbed Barghest Tails (Imlad Balchorth)\n* Flawless Scale of Lhugrien (Urugarth)\n* Sigil of War (Urugarth on Gruglok)",[24]="\"Articles of Command\" require:\n* 12Steam-scorched Carapaces (Angmar)\n* Hogni's Spiked Helmet (Misty Mountains 28.7S, 0.1E)\n* 20Corroded Neekerbreeker Horns (Angmar)\n* 20 Grisly Bat Talons (Angmar)\n* Badge of Command (Urugarth on Lagmas)\n* Putrid Slime of Helchgam (Carn Dum)",[185]="\"Implements of Knowledge\" require:\n* 8 Frosted Corcur-staves (Misty Mountains)\n* Driftclaw's Rending-tooth (Misty Mountains 30.2S, 3.2E)\n* 20 Hateful Worm Eyes (Angmar, Eregion or Forochel)\n* 10 Putrid Fingernails (Angmar)\n* Emblem of Ritual (Urugarth on Morthrang)\n* Rune of Evil Presence (Carn Dum on Salvakh)",[215]="\"Implements of Striking\" require:\n* loots on Wildwoods\n* 20 Clouded Worm Eyes\n* 5 Venomous Dread Turtle Beaks (Angmar)\n* Crimson Gorthorog Horn (Carn Dum on Barashal)\n* Sigil of War (Urugarth on Gruglok)"}}}, updateMsg="DO", tag="tag_ring.tga"},				
			{id=10116, name="NAME1", loadingCondition={notClass={214,215}}, region=1, enemyType=4, frame="quest.tga", level=58, how="Once level 58, complete the following Class Quests:\nDETAILS", questname="NAME23sur3", inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*NAME1", validatefct=true}, check={cdiary="NAME1"}, replaceStringsByClass={{key="NAME1", str={[162]="The Path of the Trapper",[194]="The Path of the Masterful Fist",[31]="The Path of the Watcher of Resolve",[193]="The Path of the Rune of Restoration",[40]="The Path of the Mischief-maker",[23]="The Path of the Defender of the Free",[172]="Path of the Martial Champion",[24]="The Path of the Healing Hands",[185]="The Path of the Ancient Master"}},{key="NAME2", str={[162]="ThePathoftheTrapper",[194]="ThePathoftheMasterfulFist",[31]="ThePathoftheWatcherofResolve",[193]="ThePathoftheRuneofRestoration",[40]="ThePathoftheMischiefmaker",[23]="ThePathoftheDefenderoftheFree",[172]="PathoftheMartialChampion",[24]="ThePathoftheHealingHands",[185]="ThePathoftheAncientMaster"}},{key="DETAILS", str={[162]="* Complete the quest \"Blindside\"\n* Complete the quest \"Passage of Foes\"\n* Complete the quest \"Strength of the Earth\"",[194]="* Complete the quest \"Goad\"\n* Complete the quest \"Forced March\"\n* Complete the quest \"Offensive Strike\"",[31]="* Complete the quest \"Triumphant Spirit\"\n* Complete the quest \"Song of the Hopeful Heart\"\n* Complete the quest \"Echoes of Battle\"",[193]="* Complete the quest \"Prelude to Hope\"\n* Complete the quest \"Rousing Words\"\n* Complete the quest \"A Rune of Restoration\"",[40]="* Complete the quest \"Bag of Tricks\"\n* Complete the quest \"Tracking Treasure\"\n* Complete the quest \"A Startling Twist\"",[23]="* Complete the quest \"Thrill of Danger\"\n* Complete the quest \"Litany of Defiance\"\n* Complete the quest \"Salt the Wounde\"",[172]="* Complete the quest \"Controlled Burn\"\n* Complete the quest \"Getting Strong Now\"\n* Complete the quest \"Boast\"",[24]="Complete the quest \"A Cry of Vengeance\"\n* Complete the quest \"Rallying Cry\"\n* Complete the quest \"Routing Cry\"",[185]="* Complete the quest \"Beacon of Hope\"\n* Complete the quest \"Share the Power\"\n* Complete the quest \"Knowledge of the Lore-master\""}}}, updateMsg="DO", tag="tag_deed.tga"},
			{id=10037, name="A Drubbing in the Deep", region=1, enemyType=4, frame="quest.tga", level=58, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*A Drubbing in the Deep", validatefct=true}, check={qdiary="Brawler"}, quest={pnj="Brom Hawksbeard", loc="Refuge des Ombres"}, questname="ADrubbingintheDeep", updateMsg="DO", tag="tag_ring.tga", loadingCondition={class=215}},			
		}}
	}},
	{name="Epic books", areas={
		{name="Epic books", showme=false, wads={
			{id=10200, name="Volume IV - Book 2, Chapter 9:\nEven in Darkness", region=3, enemyType=4, frame="quest.tga", level=100, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Book 2, Chapter 9: Even in Darkness", validatefct=true}, serie={name="Book 2 - The dawnless Day", pnj="Lothiriel", loc="Dol Amroth, Court of the Prince, entrance at 74.4S,72.2W"}, check={qdiary="Epique - Volume IV, Book 2: The dawnless Day", ddiary="The Strenght of Sauron"}, quest={pnj="Aragorn", loc="Camp of the grey host at 82.6S,37.5W"}, questname="book2chapter9evenindarkness", updateMsg="DO", tag="tag_ring.tga"},
			{id=10201, name="Volume IV - Book 4, Chapter 10:\nThe Defence of Minas Tirith", region=3, enemyType=4, frame="quest.tga", level=100, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Book 4, Chapter 10: The Defence of Minas Tirith", validatefct=true}, serie={name="Book 4 - Siege of the White City", pnj="Damrod", loc="Rangers hiding place in Osgiliath (culvert of Osigiliath at 62.7S, 8.8W)"}, check={qdiary="Epique - Volume IV, Book 4: Siege of the White City", ddiary="The Strenght of Sauron"}, quest={pnj="Imrahil", loc="At the top of the rampart, southeast of the Second Circle of Besieged Minas Tirith (58.1N, 19.2E)"}, questname="book4chapter10thedefenceofminastirith", updateMsg="DO", tag="tag_ring.tga"},
			{id=10210, name="Volume IV - Book 4, Chapter 11:\nHammer of the Underworld", region=3, enemyType=4, frame="quest.tga", level=100, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Book 4, Chapter 11: Hammer of the Underworld", validatefct=true}, serie={name="Book 4 - Siege of the White City", pnj="Damrod", loc="Rangers hiding place in Osgiliath (culvert of Osigiliath at 62.7S, 8.8W)"}, check={qdiary="Epique - Volume IV, Book 4: Siege of the White City", ddiary="The Strenght of Sauron"}, quest={pnj="Mithrandir", loc="Southeast of the Second Circle of besieged Minas Tirith (58.2N, 19.2E)"}, questname="book4chapter11hammeroftheunderworld", updateMsg="DO", tag="tag_ring.tga"},
			{id=10202, name="Volume IV - Book 8 - Chapter 7:\nMordor Triumphant", enemyType=4, region=3, frame="quest.tga", level=105, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Book 8, Chapter 7: Mordor Triumphant", validatefct=true}, serie={name="Book 8 - The Black Gate", pnj="Daervunn", loc="The Wastes, Camp of the Host (39.8S, 10.8W)"}, check={qdiary="Epic - Volume IV, Book 8: The Black Gate", ddiary="The Strenght of Sauron"}, quest={pnj="Aragorn", loc="At the top of the eastern hill in the Wastes at 35.0S, 3.3W"}, questname="book8chapter7mordortriumphant", updateMsg="DO", tag="tag_ring.tga"}, 
			{id=10203, name="Volume IV - Book 9, Chapter 5:\nThe Next Adventure", enemyType=4, region=3, frame="quest.tga", level=105, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Book 9, Chapter 5: The Next Adventure", validatefct=true}, serie={name="Book 9 - The Ring of Power", pnj="Aragorn", loc="The Wastes at 34.6S, 4.3W"}, check={qdiary="Epic - Volume IV, Book 9 - The Ring of Power", ddiary="The Strenght of Sauron"}, quest={pnj="Frodon", loc="Inside the cottage - Field of Cormallen (46.9S, 12.9W)"}, questname="Book9Chapter5TheNextAdventure", updateMsg="DO", tag="tag_ring.tga"},
			{id=10204, name="The Black Book of Mordor - 4.4:\nUnion of Evil", enemyType=4, region=4, frame="quest.tga", level=115, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Chapter 4.4: Union of Evil", validatefct=true}, serie={name="Where the Shadows lie, Chapter 4", pnj="Mithrandir", loc="Cirith Gorgor at 39.0S, 2.6W"}, check={qdiary="The Black Book of Mordor", ddiary="The Black Book of Mordor"}, quest={pnj="Aragorn", loc="Camp of the Host at 82.6S,37.5W"}, questname="Chapter44unionofevil", updateMsg="DO", tag="tag_ring.tga"}, -- KO
			{id=10205, name="The Black Book of Mordor - 5.5:\nThe Walls Brought Down", enemyType=4, region=2, frame="quest.tga", level=115, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Chapter 5.5: The Walls Brought Down", validatefct=true}, serie={name="Where the Shadows lie, Chapter 5", pnj="Mithrandir", loc="Cirith Gorgor at 39.0S, 2.6W"}, check={qdiary="The Black Book of Mordor", ddiary="The Black Book of Mordor"}, quest={pnj="Sigileth", loc="Gostador (Mirkwood) at 14.6.0S, 43.6W"}, questname="Chapter55TheWallsBroughtDown", updateMsg="DO", tag="tag_ring.tga"}, -- OK
			{id=10206, name="The Black Book of Mordor - 8.7:\nThe First Promise", enemyType=4, region=2, frame="quest.tga", level=119, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Chapter 8.7: The First Promise", validatefct=true}, serie={name="Where the Shadows lie, Chapter 8", pnj="Gandalf", loc="Khil's Home (Jernfast)"}, check={qdiary="The Black Book of Mordor", ddiary="The Black Book of Mordor"}, quest={pnj="B\195\179tuz Frostblood", loc="Skarhald"}, questname="Chapter87TheFirstPromise", updateMsg="DO", tag="tag_ring.tga"}, 
			{id=10207, name="The Black Book of Mordor - 10.7:\nThe Arrival of the Wise", enemyType=4, region=2, frame="quest.tga", level=120, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Chapter 10.7: The Arrival of the Wise", validatefct=true}, serie={name="Where the Shadows lie, Chapter 10", pnj="Gandalf", loc="Skarhald [35.6N, 46.3W]"}, check={qdiary="The Black Book of Mordor", ddiary="The Black Book of Mordor"}, quest={pnj="Gandalf", loc="Beorninghus at 13.8N, 53.3W"}, questname="Chapter107TheArrivaloftheWise", updateMsg="DO", tag="tag_ring.tga"}, 
			{id=10208, name="The Black Book of Mordor - 12.5:\nThe End of the Tale", enemyType=4, region=2, frame="quest.tga", level=122, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Chapter 12.5: The End of the Tale", validatefct=true}, serie={name="Where the Shadows lie, Chapter 12", pnj="Meldaran", loc="Dingarth"}, check={qdiary="The Black Book of Mordor", ddiary="The Black Book of Mordor"}, quest={pnj="Gandalf", loc="Vales of Anduin, Tol Send at 2.3N, 58.1W"}, questname="Chapter125TheEndoftheTale", updateMsg="DO", tag="tag_ring.tga"}, 
			{id=10209, name="The Black Book of Mordor - 14.5:\nA Final Escape", enemyType=4, region=4, frame="quest.tga", level=128, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Chapter 14.5: A Final Escape", validatefct=true}, serie={name="Where the Shadows lie, Chapter 14", pnj="The Eagle and Star", loc="Minas Tirith (After-battle) [66.7S, 17.4W]"}, check={qdiary="The Black Book of Mordor", ddiary="The Black Book of Mordor"}, quest={pnj="Culang", loc="Barad Curon, the Tower of the Crescent Moon [67.8S, 1.8E]"}, questname="Chapter145AFinalEscape", updateMsg="DO", tag="tag_ring.tga"}, 
			{id=10213, name="The Legacy Of Durin - Chapter 2.7:\nA Thirst For Blood", enemyType=4, region=2, frame="quest.tga", level=130, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Chapter 2.7: A Thirst For Blood", validatefct=true}, serie={name="The Legacy Of Durin And The Trials Of The Dwarves - Chapter 2", pnj="Gloin", loc="Ered Mithrin at 33.1N, 54.9W"}, check={qdiary="The Legacy Of Durin And The Trials Of The Dwarves", ddiary="The Legacy Of Durin And The Trials Of The Dwarves"}, quest={pnj="Imak", loc="Limlok at 21.1N, 56.2W"}, questname="Chapter27AThirstForBlood", updateMsg="DO", tag="tag_ring.tga"}, 
			{id=10211, name="Volume V - Book 1, Chapter 8:\nThe Wedding Banquet", enemyType=4, region=3, frame="quest.tga", level=10, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Book 1, Chapter 8: The Wedding Banquet", validatefct=true}, serie={name="Book 1 - A Time of Celebration", pnj="King Elessar", loc="Tower of Ecthelion, Minas Tirith (Midsummer)"}, check={qdiary="Epic - Volume V, Book 1: A Time of Celebration", ddiary="The Peace of Middle-earth"}, quest={pnj="Rodwen", loc="Minas Tirith (Midsummer) in front of the banquet hall of Merethrond"}, questname="Book1Chapter8TheWeddingBanquet", updateMsg="DO", tag="tag_ring.tga"}, -- OK
			{id=10212, name="The Legacy Of Durin - Chapter 4.9:\nThe Lord of Gundabad", enemyType=3, enemyType=4, frame="quest.tga", level=130, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Chapter 4.9: The Lord of Gundabad", validatefct=true}, serie={name="The Legacy Of Durin And The Trials Of The Dwarves - Chapter 4", pnj="Durin", loc="Annak-khurfu (War Room)"}, check={qdiary="The Legacy Of Durin And The Trials Of The Dwarves", ddiary="The Legacy Of Durin And The Trials Of The Dwarves"}, quest={pnj="Bori", loc="Zarkul-sulun at 100.9S, 17.3W"}, questname="Chapter49TheLordofGundabad", updateMsg="DO", tag="tag_ring.tga"},
			{id=10214, name="The Legacy of Durin and the Trials of the Dwarves, Chapter 7.8:\nA Silent Presence", enemyType=3, enemyType=4, frame="quest.tga", level=136, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Chapter 7.8: A Silent Presence", validatefct=true}, serie={name="The Legacy Of Durin And The Trials Of The Dwarves - Chapter 7.8", pnj="TBD", loc="TBD"}, check={qdiary="The Legacy Of Durin And The Trials Of The Dwarves", ddiary="The Legacy Of Durin And The Trials Of The Dwarves"}, quest={pnj="TBD", loc="TBD"}, questname="Chapter78ASilentPresence", updateMsg="DO", tag="tag_ring.tga"},
			{id=10215, name="The Legacy of Durin and the Trials of the Dwarves, Chapter 11.5:\nGundabad Is Ours!", enemyType=3, enemyType=4, frame="quest.tga", level=130, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Chapter 11.5: Gundabad Is Ours!", validatefct=true}, serie={name="The Legacy Of Durin And The Trials Of The Dwarves - Chapter 11.5", pnj="TBD", loc="TBD"}, check={qdiary="The Legacy Of Durin And The Trials Of The Dwarves", ddiary="The Legacy Of Durin And The Trials Of The Dwarves"}, quest={pnj="TBD", loc="TBD"}, questname="11.5:GundabadIsOurs", updateMsg="DO", tag="tag_ring.tga"}
		}}
	}},
	{name="Landscape deeds", areas={
		{name="Blood of Azog", region=3, wads={
			{id=10117, name="Interlude: Blood of Azog", enemyType=4, frame="quest.tga", level=130, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Interlude[\194\160%s]*:[\194\160%s]*Blood of Azog", validatefct=true}, questname="InterludeBloodofAzog", check={qdiary="Blood of Azog > Interlude: Blood of Azog"}, todo="Ends with Gloin (quest : Blood of Azog: A Lesson Hard-learned)", updateMsg="DO", tag="tag_ring.tga", quest={pnj="Gloin", loc="Annak-khurfu"}},
			
		}},
		{name="Old An\195\179rien", region=3, wads={
			{id=10100, name="Quests of Old An\195\179rien", enemyType=4, frame="deed.tga", level=100, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Quests of Old An\195\179rien", validatefct=true}, questname="QuestsofOldAnrien", check={adiary="Tab Gondor>Old An\195\179rien"}, todo="1) Complete Quests of Minas Tirith\n2) Complete Quests of Pelennor\n3) Complete Quests of Talath Anor\n4) Complete Old Anorien's RoFriendng Enemies", updateMsg="DO", tag="tag_ring.tga"},
			{id=10101, name="Deeds of Old An\195\179rien", enemyType=4, frame="deed.tga", level=100, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Deeds of Old An\195\179rien", validatefct=true}, questname="DeedsofOldAnrien", check={adiary="Tab Gondor>Old An\195\179rien"}, todo="1) Complete Explorer of Old An\195\179rien\n2) Complete Quests of Old An\195\179rien\n3) Complete Slayer of Old An\195\179rien", updateMsg="DO", tag="tag_ring.tga"},
			{id=10104, name="Ashes and Stars, Chapter 4", enemyType=4, frame="quest.tga", level=100, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Ashes and Stars, Chapter 4", validatefct=true}, serie={name="Ashes and Stars", pnj="Mablung", loc="Osgiliath Culverts at 62.7S, 8.8W"}, check={qdiary="Ashes and Stars"}, quest={pnj="Mablung", loc="Osgiliath Culverts at 62.7S, 8.8W"}, questname="AshesandStarsChapter4", updateMsg="DO", tag="tag_ring.tga", size=3}
		}},
		{name="Central Gondor", region=3, wads={
			{id=10105, name="A Ruthless End", enemyType=4, frame="quest.tga", level=100 , inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*A Ruthless End", validatefct=true}, serie={name="Central Gondor: Ringlo Vale", pnj="Candur", loc="Ethring"}, check={qdiary="Central Gondor: Ringlo Vale"}, quest={pnj="Arvaethor", loc="in the cave of Nimrond (68.8S, 51.8W)"}, questname="ARuthlessEnd", updateMsg="DO", tag="tag_ring.tga"},
			{id=10106, name="Sons of the Usurper", enemyType=4, frame="quest.tga", level=100, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Sons of the Usurper", validatefct=true}, serie={name="Dor-en-Ernil - Lindir"}, check={qdiary="Central Gondor: Lebennin"}, quest={pnj="Erchar", loc="80.6S, 44.9W"}, questname="SonsoftheUsurper", updateMsg="DO", tag="tag_ring.tga"},
			{id=10107, name="Blood for Blood", enemyType=4, frame="quest.tga", level=100, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Blood for Blood", validatefct=true}, serie={name="Dor-en-Ernil - Lindir"}, check={qdiary="Central Gondor: Dor-en-Ernil"}, quest={pnj="Erchar", loc="80.6S, 44.9W"}, questname="BloodforBlood", updateMsg="DO", tag="tag_ring.tga"},
			{id=10108, name="Faltharan's Confrontation", enemyType=4, frame="quest.tga", level=100, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Faltharan's Confrontation", validatefct=true}, serie={name="Pelargir"}, check={qdiary="Central Gondor: Pelargir"}, quest={pnj="Thandor", loc="83.8S, 32.6W"}, questname="FaltharansConfrontation", updateMsg="DO", tag="tag_ring.tga"}
		}},	
		{name="West Rohan", region=2, wads={
			{id=10109, name="The Road to Dunharrow", enemyType=4, frame="quest.tga", level=88 , inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*The Road to Dunharrow", validatefct=true}, serie={name="Edoras", pnj="Eowyn", loc="Meduseld (62.0S, 72.8W)"}, check={qdiary="Kingstead"}, quest={pnj="Eowyn", loc="Meduseld (62.0S, 72.8W)"}, questname="TheRoadtoDunharrow", updateMsg="DO", tag="tag_ring.tga"},
			{id=10110, name="All Roads Lead Back to Aldburg", enemyType=4, frame="quest.tga", level=89, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*All Roads Lead Back to Aldburg", validatefct=true}, serie={name="Beaconwatch", pnj="Meregyth", loc="at 69.8S, 57.1W"}, check={qdiary="Estfolde"}, quest={pnj="Cutha", loc="Beaconwatch Mead Hall"}, questname="AllRoadsLeadBacktoAldburg", updateMsg="DO", tag="tag_ring.tga"},
			{id=10111, name="The Broadacres Betrayed", enemyType=4, frame="quest.tga", level=91, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*The Broadacres Betrayed", validatefct=true}, serie={name="Torsbury", pnj="Tordag", loc="at 45.6S, 72.20"}, check={qdiary="Broadacres"}, quest={pnj="Torferth", loc="Mead Hall of Stoke 45.7S, 72.2W"}, questname="TheBroadacresBetrayed", updateMsg="DO", tag="tag_ring.tga"},
			{id=10112, name="Woodhurst Has Fallen", enemyType=4, frame="quest.tga", level=93, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*Woodhurst Has Fallen", validatefct=true}, serie={name="Herubrand", pnj="Herubrand", loc="46.9s, 79.2W"}, check={qdiary="Woodhurst"}, quest={pnj="Gifemund", loc="Woodhurst (47.8S, 79.6W)"}, questname="WoodhurstHasFallen", updateMsg="DO", tag="tag_ring.tga"},
			{id=10113, name="To Helm's Deep", enemyType=4, frame="quest.tga", level=94, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*To Helm's Deep", validatefct=true}, check={qdiary="Westfold"}, quest={pnj="Gandalf", loc="Erkenbrand's Refuge (56.5S, 90.5W)"}, questname="ToHelmsDeep", updateMsg="DO", tag="tag_ring.tga"}
		}},	
		{name="Moria", wads={
			{id=10114, name="BOOK1", loadingCondition={notClass={214,215}}, enemyType=4, frame="deed.tga", level=58, how="Reach Kindred reputation with the Iron Garrison Guards, then purchase the book \"BOOK1\" from Thorth Splintershield (5.7S, 105.1W) in the Twenty-first Hall (Moria).", questname="BOOK2", inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*BOOK1", validatefct=true}, check={cdiary="BOOK1"}, replaceStringsByClass={{key="BOOK1", str={[162]="The Jolly Hunter",[194]="The Path Less Trod",[31]="The Verses of the North",[193]="On the Patterns of Wind and Rain",[40]="A guide to the Quiet Knife",[23]="A Keen Blade",[172]="The Boiling Rage",[24]="The Master of the Charge",[185]="The Book of Nature"}},{key="BOOK2", str={[162]="TheJollyHunter",[194]="ThePathLessTrod",[31]="TheVersesoftheNorth",[193]="OnthePatternsofWindandRain",[40]="AguidetotheQuietKnife",[23]="AKeenBlade",[172]="TheBoilingRage",[24]="TheMasteroftheCharge",[185]="TheBookofNature"}}}, updateMsg="DO", tag="tag_deed.tga"},
			{id=10115, name="Epic books in The Mines of Moria", enemyType=4, frame="deed.tga", level=50, loadingCondition={notClass={214, 215}}, inc={trigger="^Completed[\194\160%s]*:[\194\160%s]*The Mines of Moria (6 on 6)", validatefct=true}, questname="TheMinesofMoria6of6", check={ddiary="The Mines of Moria"}, todo="Complete Epic books in the Moria up to Book VI.", updateMsg="DO", tag="tag_deed.tga"}
		}}
	}},
	{name="Gundabad", map="44.jpg", region=2, areas={
		{map="50.jpg", name="Mount Gundabad", wads={
			{id=2370, name="Vistas of Welkin-lofts", target="Dwarfmarker", ico="poi.jpg", enemyType=3, frame="POI_balise.tga", size=1, level=135, poi={{id=1, c="43.9N, 74.2W"},{id=2, c="44.5N, 74.7W"},{id=3, c="47.1N, 76.5W"},{id=4, c="42.2N, 71.4W"},{id=5, c="44.8N, 73.9W"},{id=6, c="49.4N, 73.9W"},{id=7, c="47.3N, 71.1W"},{id=8, c="40.8N, 73.9W"},{id=9, c="49.2N, 76.0W"},{id=10, c="46.1N, 78.2W"}}, rewards={{Rewards.VERTUES, 1000}, {Rewards.TURBINE, 5}, {Rewards.TITLE, "Peak Scaler"}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}} , tag="tag_flag.tga"},
			{id=2385, name="Rare Gundabad Chests of Welkin-lofts", target="Rare Gundabad Chest", enemyType=3, frame="treasure.tga", size=1, level=135, poi={{id=1, c="40.7N, 73.7W"},{id=2, c="44.5N, 73.8W"},{id=3, c="48.3N, 74.6W"},{id=4, c="46.3N, 77.1W", l="inside Thyrstath"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga"},
			{id=2371, name="Treasure of Welkin-lofts", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=135, poi={ {id=1, c="44.8N, 75.0W"},{id=2, c="47.0N, 70.9W"},{id=3, c="49.7N, 75.3W"},{id=4, c="50.3N, 74.2W"},{id=5, c="42.1N, 71.5W"},{id=6, c="49.5N, 76.0W"},{id=7, c="48.4N, 75.3W"},{id=8, c="47.8N, 77.0W"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.TITLE, "Treasure seeker of Welkin-lofts"}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga"},
			{id=2383, name="Rare Gundabad Chests of C\195\162r Bronach", target="Rare Gundabad Chest", enemyType=3, frame="treasure.tga", size=1, level=135, poi={{id=1, c="54.3N, 72.9W"},{id=2, c="52.7N, 69.1W"},{id=3, c="49.2N, 63.1W"},{id=4, c="48.2N, 70.3W"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga", map="51.jpg"},
			{id=2372, name="Treasure of C\195\162r Bronach", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=135, poi={ {id=1, c="54.1N, 70.6W"},{id=2, c="53.1N, 74.2W"},{id=3, c="48.6N, 67.6W"},{id=4, c="52.0N, 60.3W"},{id=5, c="51.0N, 59.3W"},{id=6, c="56.1N, 72.3W"},{id=7, c="52.2N, 69.1W"},{id=8, c="48.2N, 71.0W"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.TITLE, "Treasure seeker of C\195\162r Bronach"}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga", map="51.jpg"},
			{id=117, name="Khanakarg", questname="Khanakarg", size=1, level=140, difficulty=Difficulty.SIGNATURE, moral="1,753,200", race="Warg", adds=nil, frame=nil, loc="Randomly among:", rovingThreatData={loc={{c="47.8N, 77.0W"},{c="49.1N, 75.6W"}}}, enemyType=2, note="Respawn every hour", map="50.jpg"},
			{id=116, name="Skerla", questname="Skerla", size=1, level=136, difficulty=Difficulty.SIGNATURE, moral="TBD", race="lathbear", adds=nil, frame=nil, loc="Randomly among:", rovingThreatData={loc={{c="48.5N, 68.7W"},{c="50.4N, 61.6W"}}}, enemyType=2, note="Respawn every hour", map="51.jpg"}
		}},
		{map="50.jpg", name="Delvings of Gundabad", wads={
			{id=5057, name="Silver Coins of Gundabad for Embers", enemyType=5, size=1, level=140, questname="Silver Coins of Gundabad for Embers", subname="Silver Coins of Gundabad for Embers", rewards={{Rewards.BRAISES, 500}}, quest={pnj="Quartermaster of Gundabad", loc="Zidir-nesad"}, how="Exchange [100 Silver Coins of Gundabad] for 500 Embers.", repeatable=1, tag="tag_braises.tga"},
			{id=2382, name="Rare Gundabad Chests of Clovengap", target="Rare Gundabad Chest", enemyType=3, frame="treasure.tga", size=1, level=135, poi={{id=1, c="34.9S, 121.4W"},{id=2, c="36.9S, 124.1W"},{id=3, c="38.5S, 123.0W"},{id=4, c="39.7S, 122.7W"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga", map="52.jpg"},
			{id=2381, name="Treasure of Clovengap", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=135, poi={{id=1, c="34.5S, 123.6W"},{id=2, c="35.7S, 121.3W"},{id=3, c="35.7S, 123.8W"},{id=4, c="39.0S, 122.2W"},{id=5, c="40.8S, 122.3W"},{id=6, c="42.2S, 120.5W"},{id=7, c="39.1S, 120.2W"},{id=8, c="27.4S, 121.9W"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.TITLE, "Treasure-seeker of Clovengap"}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga", map="52.jpg"},
			{id=2380, name="Rare Gundabad Chests of Gloomingtarn", target="Rare Gundabad Chest", enemyType=3, frame="treasure.tga", size=1, level=135, poi={{id=1, c="48.7S, 120.2W", l="inside Ormgren"},{id=2, c="45.5S, 124.0W"},{id=3, c="49.6S, 122.4W", l="inside Glittengrof"},{id=4, c="46.3S, 123.9W", l="in Min Lorg"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga",map="53.jpg"},
			{id=2379, name="Treasure of Gloomingtarn", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=130, poi={{id=1, c="49.0S, 120.5W]"},{id=2, c="45.9S, 119.1W"},{id=3, c="48.2S, 121.8W"},{id=4, c="42.9S, 121.6W"},{id=5, c="44.0S, 122.3W"},{id=6, c="45.4S, 122.6W"},{id=7, c="46.0S, 120.5W"},{id=8, c="48.7S, 121.8W"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.TITLE, "Treasure-seeker of Gloomingtarn"}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga",map="53.jpg"},
			{id=2384, name="Crystal Hunter", target="SUB", enemyType=3, frame="treasure.tga", size=1, level=130, poi={{id=1, c="42.3S, 112.9W",t="Red Crystal"},{id=2, c="39.7S, 112.8W",t="Violet Crystal"},{id=3, c="39.9S, 111.8W",t="Yellow Crystal"},{id=4, c="39.5S, 110.2W",t="Blue Crystal"},{id=5, c="40.8S, 115.2W",t="Orange Crystal"},{id=6, c="43.5S, 109.6W",t="Indigo Crystal"},{id=7, c="39.6S, 113.4W",t="Green Crystal"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga",map="54.jpg"},
			{id=2378, name="Rare Gundabad Chests of Stonejaws", target="Rare Gundabad Chest", enemyType=3, frame="treasure.tga", size=1, level=130, poi={{id=1, c="43.8S, 109.9W"},{id=2, c="39.3S, 110.0W"},{id=3, c="39.7S, 113.7W"},{id=4, c="40.2S, 113.3W"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga",map="54.jpg"},
			{id=2374, name="Treasure of Stonejaws", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=130, poi={{id=1, c="40.0S, 113.4W"},{id=2, c="39.4S, 109.8W"},{id=3, c="38.8S, 114.6W"},{id=4, c="43.4S, 109.8W"},{id=5, c="42.8S, 111.8W"},{id=6, c="40.5S, 114.6W"},{id=7, c="41.0S, 116.5W"},{id=8, c="40.0S, 116.1W"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.TITLE, "Treasure-seeker of Stonejaws"}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga",map="54.jpg"},		
			{id=2377, name="Rare Gundabad Chests of Deepscrave", target="Rare Gundabad Chest", enemyType=3, frame="treasure.tga", size=1, level=130, poi={{id=1, c="49.1S, 118.2W", l="in Durshulot, middle level"},{id=2, c="50.0S, 118.5W", l="ground level"},{id=3, c="48.7S, 115.8W", l="middle level"},{id=4, c="51.0S, 115.9W", l="upper level"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga",map="55.jpg"},
			{id=2376, name="Treasure of Deepscrave", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=130, poi={{id=1, c="51.5S, 117.2W", l="upper level : take stairs at 48.9S,115.6W, then go south and follow the way"},{id=2, c="52.2S, 119.4W", l="ground level"},{id=3, c="47.2S, 117.4W", l="medium level"},{id=4, c="49.4S, 116.2W", l="ground level"},{id=5, c="51.2S, 115.3W", l="upper level"},{id=6, c="48.5S, 117.6W", l="ground level"},{id=7, c="49.5S, 117.4W", l="ground level"},{id=8, c="50.3S, 117.8W", l="ground level"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.TITLE, "Treasure-seeker of Deepscrave"}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga",map="55.jpg"},
			{id=2373, name="Rare Gundabad Chests of Mattugard", target="Rare Gundabad Chest", enemyType=3, frame="treasure.tga", size=1, level=130, poi={{id=1, c="47.0S, 110.7W"},{id=2, c="44.8S, 113.3W"},{id=3, c="48.2S, 114.7W"},{id=4, c="51.3S, 112.0W"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga",map="56.jpg"},
			{id=2375, name="Treasure of Mattugard", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=130, poi={ {id=1, c="45.8S, 112.6W"},{id=2, c="46.5S, 114.6W"},{id=3, c="47.9S, 115.5W"},{id=4, c="47.9S, 115.0W"},{id=5, c="47.4S, 111.2W"},{id=6, c="44.7S, 113.5W"},{id=7, c="45.6S, 114.0W"},{id=8, c="46.5S, 114.8W"}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.TITLE, "Treasure-seeker of Mattugard"}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 700}}, tag="tag_vault.tga",map="56.jpg"},
			{id=118, name="Kurzkub", questname="Kurzkub", size=1, level=139, difficulty=Difficulty.SIGNATURE, moral="1,717,650", race="Grim", adds=nil, frame=nil, loc="Randomly among:", rovingThreatData={loc={{c="35.8S, 122.5W"},{c="35.2S, 124.0W"}}}, enemyType=2, note="Respawn every hour",map="52.jpg"},
			{id=119, name="Gullush", questname="Gullush", size=1, level=138, difficulty=Difficulty.SIGNATURE, moral="1,661,198", race="Frog", adds=nil, frame=nil, loc="Randomly among:", rovingThreatData={loc={{c="47.9S, 120.1W"},{c="47.2S, 121.8W"}}}, enemyType=2, note="Respawn every hour", map="53.jpg"},
			{id=120, name="Skrizug", questname="Skrizug", size=1, level=136, difficulty=Difficulty.SIGNATURE, moral="TBD", race="TBD", adds=nil, frame=nil, loc="Randomly among:", rovingThreatData={loc={{c="42.2S, 113.0W"},{c="38.3S, 111.9W"}}}, enemyType=2, note="Respawn every hour", map="54.jpg"},
			{id=122, name="Gurlazg", questname="Gurlazg", size=1, level=134, difficulty=Difficulty.SIGNATURE, moral="1,437,750", race="Insect", adds=nil, frame=nil, loc="Randomly among:", rovingThreatData={loc={{c="49.5S, 117.7W"},{c="51.3S, 118.4W"}}}, enemyType=2, note="Respawn every hour", map="55.jpg"},
			{id=121, name="Forsting", questname="Forsting", size=1, level=133, difficulty=Difficulty.SIGNATURE, moral="1,387,350", race="Dragon", adds=nil, frame=nil, loc="Randomly among:", rovingThreatData={loc={{c="49.6S, 113.5W"},{c="47.2S, 112.3W"}}}, enemyType=2, note="Respawn every hour", map="56.jpg"} 
		}},
		{name="Instances and repeatable", wads={
			{id=5058, name="Challenges of Gundabad (Weekly)", enemyType=5, size=1, questname="ChallengesofGundabadWeekly", subname="ChallengesofGundabadWeekly", rewards={{Rewards.REPUTATION, "Allegiance: Zhelruka Clan", 2000},{Rewards.TRACERIES_RUNES, 6, 131},{Rewards.VERTUES, 2000}}, how="Complete 4 instances of Gundabad", quest={given="automatically by launching an instance"},  repeatable=5, tag="tag_vault.tga"},	
			{id=5059, name="Reclaiming of the Mountain-hold (Weekly)", enemyType=5, size=1, questname="ReclaimingoftheMountainholdWeekly", subname="ReclaimingoftheMountainholdWeekly", rewards={{Rewards.REPUTATION, "Allegiance: Zhelruka Clan", 2000},{Rewards.TRACERIES_RUNES, 6, 131},{Rewards.VERTUES, 2000}}, how="Complete 20 Gundabad challenges", quest={pnj="Zova", loc="Great Hall of Vernozal"},  repeatable=5, tag="tag_vault.tga"},			
			{id=5055, name="Missions of Gundabad (Weekly)", enemyType=5, size=1, questname="MissionsofGundabadWeekly", subname="MissionsofGundabadWeekly", rewards={{Rewards.REPUTATION, "Allegiance : Zhelruka Clan", 10000}}, how="Complete 20 Gundabad missions", quest={pnj="Zova", loc="Vernozal"},  repeatable=5, tag="tag_braises.tga"},	
			{id=5056, name="Missions of Gundabad (Daily)", enemyType=5, size=1, questname="MissionsofGundabadDaily", subname="MissionsofGundabadDaily", rewards={{Rewards.REPUTATION, "Allegiance : Zhelruka Clan", 2000}}, quest={pnj="Zova", loc="Vernozal"}, how="Complete 20 Gundabad missions", tag="tag_braises.tga"},	
			{id=5050, name="Clovengap: Terror in the Trees", enemyType=5, size=1, level=140, questname="ClovengapTerrorintheTrees", subname="ClovengapTerrorintheTrees", rewards={{Rewards.TRACERIES_RUNES, 1, 131}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 300}}, quest={pnj="Zadock Flint-eye", loc="Zidir-nesad, the Steepset"}, how="Crafting instance to collect wood.\nContains another quest to collect Enhancement Runes.", tag="tag_bag.tga"}, 
			{id=5051, name="Stonejaws: Leader of the Frost", enemyType=5, size=1, level=140, questname="StonejawsLeaderoftheFrost", subname="StonejawsLeaderoftheFrost", rewards={{Rewards.TRACERIES_RUNES, 1, 131}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 300}}, quest={pnj="Zadock Flint-eye", loc="Zidir-nesad, the Steepset"}, how="Crafting instance to collect Scholar chests.\nContains another quest to collect Enhancement Runes.", tag="tag_bag.tga"}, 
			{id=5052, name="Gloomingtarn: Dr\195\180k-and-Kharb", enemyType=5, size=1, level=140, questname="gloomingtarndrkandkharb", subname="gloomingtarndrkandkharb", rewards={{Rewards.TRACERIES_RUNES, 1, 131}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 300}}, quest={pnj="Zadock Flint-eye", loc="Zidir-nesad, the Steepset"}, how="Crafting instance to pick up skarn.\nContains another quest to collect Enhancement Runes.", tag="tag_bag.tga"}, 
			{id=5053, name="Battle of Welkin-lofts", enemyType=5, size=6, level=140, questname="BattleofWelkinlofts", subname="BattleofWelkinlofts", rewards={{Rewards.TRACERIES_RUNES, 5, 131}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 1500}}, quest={pnj="Agatur the Boastful", loc="Zidir-nesad, the Steepset"}, how="Instance with 5 quests each giving 1 box of Enhancement Runes 131 and 300 of reputation.", tag="tag_bag.tga"}, 
			{id=5054, name="Battle at the forge", enemyType=5, size=6, level=140, questname="Battleattheforge", subname="Battleattheforge", rewards={{Rewards.TRACERIES_RUNES, 1, 131}, {Rewards.REPUTATION, "Reclaimers of the Mountain-hold", 300}}, quest={pnj="Agatur the Boastful", loc="Zidir-nesad, the Steepset"}, how="Instance with 5 quests each giving 1 box of Enhancement Runes 131 and 300 of reputation.", tag="tag_bag.tga"}, 			
		}},	
		{map="44.jpg", name="Elderslade - The Gates of Gundabad", showme=false, wads={
			{id=5005, name="Copper Coins of Gundabad for Motes", enemyType=5, size=1, level=130, questname="CopperCoinsofGundabadforMotes", subname="CopperCoinsofGundabadforMotes", rewards={{Rewards.GRAINS, 500}, {Rewards.REPUTATION, "Protectors of Wilderland", 300}}, quest={pnj="Quartermaster (March on Gundabad)", loc="second floor of Annak-khurfu"}, how="Exchange 30 [Copper Coins of Gundabad] against 500 motes.", repeatable=1, tag="tag_grains.tga"},	
			{id=5008, name="On a Mission (Weekly)", enemyType=5, size=1, questname="OnaMissionWeekly", subname="OnaMissionWeekly", rewards={{Rewards.GRAINS, 500},{Rewards.VERTUES, 1000},{Rewards.TRACERIES_RUNES}}, how="Complete 15 missions", quest={given="automatically when completing a mission"}, repeatable=5, tag="tag_grains.tga"},	
			{id=5021, name="On a Continuing Mission (Weekly)", enemyType=5, size=1, questname="OnaContinuingMissionWeekly", subname="enmissioncontinuehebdomadaire", rewards={{Rewards.GRAINS, 500},{Rewards.VERTUES, 1000},{Rewards.TRACERIES_RUNES}}, quest={given="automatically when completing a mission"}, how="Complete 45 missions", repeatable=5, tag="tag_grains.tga"},	
			{id=5006, name="The War Effort: Missions for the Cause (Weekly)", enemyType=5, size=1, level=130, questname="TheWarEffortMissionsfortheCauseWeekly", subname="TheWarEffortMissionsfortheCauseWeekly", rewards={{Rewards.GRAINS, 400}},quest={pnj="Elof", loc="second floor of Annak-khurfu"}, how="Complete 4 times \"March on Gundabad: Missions for the Cause\"", repeatable=5, tag="tag_grains.tga"}, 
			{id=5020, name="The War Effort: A Great Leap (Weekly)", enemyType=5, size=1, level=130, questname="TheWarEffortAGreatLeapWeekly", subname="TheWarEffortAGreatLeapWeekly", rewards={{Rewards.TRACERIES_RUNES, 2, 121}}, quest={pnj="Hlothi", loc="second floor of Annak-khurfu"}, how="Complete 4 times \"March on Gundabad: Additional Steps\"", tag="tag_bag.tga"},	
			{id=5007, name="March on Gundabad: Missions for the Cause", enemyType=5, size=1, level=130, questname="MarchonGundabadMissionsfortheCause", subname="MarchonGundabadMissionsfortheCause", rewards={{Rewards.GRAINS, 42}}, quest={pnj="Elof", loc="second floor of Annak-khurfu"}, how="Complete 3 Gabil'akka Missions", tag="tag_grains.tga"},	
			{id=5023, name="March on Gundabad: Assisting the War Effort (Daily)", enemyType=5, size=1, level=130, questname="MarchonGundabadAssistingtheWarEffortDaily", subname="MarchonGundabadAssistingtheWarEffortDaily", rewards={{Rewards.TRACERIES_RUNES, 2, 121}}, quest={pnj="Hlothi", loc="second floor of Annak-khurfu"}, how="Complete 3 Gabil'akka Missions", tag="tag_bag.tga"},	
			{id=5022, name="March on Gundabad: Shakalush, the Stair Battle (Daily)", enemyType=5, size=1, level=130, questname="MarchonGundabadShakalushtheStairBattleDaily", subname="MarchonGundabadShakalushtheStairBattleDaily", rewards={{Rewards.TRACERIES_RUNES, 2, 121}}, quest={pnj="Hlothi", loc="second floor of Annak-khurfu"}, how="Complete \"Shakalush, the stair Battle\"", tag="tag_bag.tga"},			
			{id=2360, name="Dwarf-surveys in Elderslade", target="Dwarf surveys", ico="poi.jpg", enemyType=3, frame="POI_balise.tga", size=1, level=130, poi={ { id=1, c="32.9N, 58.2W", l="Sud-Ouest de Rushgate" }, { id=2, c="33.7N, 57.7W", l="West of Rushgate"}, { id=3, c="33.1N, 57.3W", l="Southwest of Rushgate"}, { id=4,c="33.4N, 61.2W", l="North of de Ann\195\162k-khurfu" }, { id=5,c="33.7N, 60.5W", l="Northeast of Ann\195\162k-khurfu" }, { id=6, c="33.6N, 63.9W", l="Nord-Ouest de Zarkul-sul\195\187n" }, { id=7, c="33.7N, 62.3W", l="Northeast of Zarkul-sul\195\187n" }, { id=8,c="39.3N, 67.1W", l="Northeast of the Gates of Gundabad" }, { id=9,c="37.1N, 67.9W", l="in front of the Gates, on the south" }, { id=10, c="39.5N, 64.7W", l="Near a waterfall, Northeast of the Gates" }, { id=11,c="38.0N, 65.8W", l="Near a waterfall" }, { id=12, c="34.1N, 62.4W", l="West of Shakal-atr\195\162d" } }, rewards={{Rewards.VERTUES, 2000}, {Rewards.TURBINE, 5}, {Rewards.TITLE, "Surveyor of Elderslade"}, {Rewards.REPUTATION, "March on Gundabad", 700}} , tag="tag_flag.tga"},	
			{id=2361, name="Treasure-seeker of Elderslade", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=130, poi={ { id=1, c="33.9N, 57.6W", l="Northeast of Klorgren" }, { id=2, c="34.3N, 61.9W", l="Down the stairs of Shakal-atrad"}, { id=3, c="32.6N, 58.7W", l=""}, { id=4, c="40.7N, 62.9W", l="" }, { id=5, c="37.1N, 66.0W", l="" }, { id=6, c="36.0N, 62.2W", l="Howlers' Notch interior North"}, { id=7, c="32.4N, 62.6W", l="" }, { id=8, c="35.1N, 66.6W", l="" }, { id=9,c="39.3N, 67.5W", l="In Kulug-mokh, passing through the bridge north of the Gundabad gates" }, { id=10,c="37.3N, 68.5W", l="" }, { id=11, c="36.4N, 68.5W", l="" }, { id=12, c="33.0N, 57.1W", l="" }, { id=13, c="36.2N, 60.6W", l="" }, { id=14, c="33.0N, 63.6W", l="" }}, rewards={{Rewards.VERTUES, 2000}, {Rewards.TURBINE, 5}, {Rewards.TITLE, "Chercheur de Treasure of du Val-D'A\195\175eul"}, {Rewards.REPUTATION, "March on Gundabad", 700}}, tag="tag_vault.tga"}
		}}
	}},
	{name="Azanulbizar", map="49.jpg", region=2, areas={
		{map="49.jpg", name="Azanulbizar", showme=false, wads={		
			{id=2364, name="Treasure of Azanulbizar", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=130, poi={ { id=1, c="63.3N, 133.9W", l="Near Amdam" }, { id=2, c="65.0N, 135.4W", l="Gash Ujaf"}, { id=3, c="65.0N, 134.6W", l="Hill north of Amdam"}, { id=4, c="66.2N, 136.2W", l="" }, { id=5, c="68.4N, 138.0W", l="NE Rung-shakam" }, { id=6, c="67.0N, 138.2W", l="NW of Zirakazhar"}, { id=7, c="66.4N, 132.5W", l="" }, { id=8, c="70.2N, 136.9W", l="" }, { id=9,c="66.3N, 132.2W", l="North of the road to Atrad-zarakh" }, { id=10,c="69.9N, 135.4W", l="Tar-kutoz" }, { id=11, c="67.2N, 137.0W", l="" }, { id=12, c="65.3N, 132.6W", l="" }}, rewards={{Rewards.VERTUES, 2000}, {Rewards.TITLE, "Treasure-seeker of Azanulbizar"}, {Rewards.REPUTATION, "The Haban'akka of Thrin", 700}}, tag="tag_vault.tga"},		
			{id=111, name="Kr\195\185mpug", hideStats=true, closedPOI="Zaghuth", size=1, level=130, difficulty=Difficulty.SIGNATURE, moral="783,724", race="Goblin", adds=nil, frame=nil, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="70.2N, 137.1W"},{c="70.2N, 136.6W"},{c="71.3N, 137.2W"}}}, enemyType=2, note="Respawn every hour"},
			{id=112, name="Muzbuk", hideStats=true, loc="69.0N, 134.6W",size=1, level=130, difficulty=Difficulty.SIGNATURE, moral="2,233,612", race="Bat", adds=nil, frame=nil, mapPos={x=140, y=173}, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="69.0N, 134.6W"},{c="69.9N, 134.0W"},{c="69.3N, 134.1W"}}}, enemyType=2, note="Respawn every hour"},
			{id=113, name="Bagnaz Rot-sting", hideStats=true, loc="65.7N, 135.7W",size=1, level=130, difficulty=Difficulty.SIGNATURE, moral="783,724", race="Orc", adds=nil, frame=nil, mapPos={x=140, y=173}, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="65.7N, 135.7W"},{c="64.8N, 134.7W"},{c="65.1N, 134.8W"}}}, enemyType=2, note="Respawn every hour"},
			{id=114, name="Skegghorn", hideStats=true, loc="66.7N, 132.0W",size=3, level=130, difficulty=Difficulty.SIGNATURE, moral="6,649,777", race="Auroch", adds=nil, frame=nil, mapPos={x=140, y=173}, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="66.7N, 132.0W"},{c="66.4N, 132.4W"},{c="66.8N, 133.2W"}}}, enemyType=2, note="Respawn every hour"},
			{id=115, name="Zaugnakh", hideStats=true, loc="67.3N, 138.4W",size=3, level=130, difficulty=Difficulty.SIGNATURE, moral="2,374,920", race="Warg", adds=nil, frame=nil, mapPos={x=140, y=173}, addlinked=true, loc="Randomly among:", rovingThreatData={loc={{c="67.3N, 138.4W"},{c="67.8N, 138.3W"},{c="68.2N, 138.2W"}}}, enemyType=2, note="Respawn every hour"}
		}}
	}},	
	{name="Wells of Langflood", map="43.jpg", region=2, areas={
		{map="43.jpg", name="Wells of Langflood", showme=false, wads={
			{id=5004, name="Protectors of Wilderland: Bounties", enemyType=5, size=1, level=130, questname="ProtectorsofWilderlandBounties", subname="ProtectorsofWilderlandBounties", rewards={{Rewards.GRAINS, 300}, {Rewards.TRACERIES_RUNES, 2, 121}, {Rewards.REPUTATION, "Protectors of Wilderland", 300}},quest={pnj="automatically by taking a bounty from the Bounty Board", loc="Limlok at 20.9N, 55.9W"}, how="Accomplish 5 bounties at Limlok", repeatable=5, tag="tag_bag.tga"},		
			{id=2350, name="Dwarf-surveys in the Wells of Langflood", target="Dwarf markers", ico="poi.jpg", enemyType=3, frame="POI_balise.tga", size=1, level=130, poi={ { id=1,c="24.2N, 58.9W", l="South of Thokvist" }, { id=2, c="21.0N, 57.5W", l=""}, { id=3, c="20.1N, 57.5W", l=""}, { id=4, c="21.1N, 62.7W", l="Near the bridge to Sundergrot" }, { id=5, c="21.0N, 60.7W", l="Egvarth" }, { id=6, c="20.1N, 59.5W", l="Between Egvarth and Stramvarth" }, { id=7, c="25.2N, 60.0W", l="" }, { id=8, c="25.2N, 58.9W", l="West of Dunabrygg" }, { id=9, c="30.4N, 58.7W", l="" }, { id=10, c="31.8N, 59.6W", l="" } }, rewards={{Rewards.TURBINE, 5}, {Rewards.TITLE, "Surveyor of the Langflood"}, {Rewards.REPUTATION, "Protectors of Wilderland", 700}}, tag="tag_flag.tga"},			
			{id=2352, name="Treasure-seeker of the Wells of Langflood", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=130, poi={ { id=1, c="21.8N, 52.1W", l="" }, { id=2, c="21.5N, 50.3W", l=""}, { id=3,c="23.4N, 56.6W", l=""}, { id=4, c="20.6N, 57.1W", l="" }, { id=5, c="In Sundergrot (22.0N, 63.0W)", l="" }, { id=6, c="In Scraper's Clough 19.9N, 62.4W", l=""}, { id=7, c="21.1N, 60.2W", l="" }, { id=8, c="25.9N, 55.8W", l="" }, { id=9,c="30.2N, 58.3W", l="" }, { id=10, c="In Framsburg (27.6N, 60.6W)", l="" }, { id=11,c="32.0N, 61.0W", l="" }, { id=12, c="In Tithroz 17.6N, 54.3W", l="At the second tunnel to the left" }}, rewards={{Rewards.TURBINE, 5},{Rewards.TITLE, "Treasure Seeker of the Langflood"}, {Rewards.REPUTATION, "Protectors of Wilderland", 700}}, tag="tag_vault.tga"},
			{id=2351, name="Natural Formations in the Wells of Langflood", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=130, poi={ { id=1, c="Tithroz 17.6N, 54.3W", l="" }, { id=2, c="32.1N, 60.1W", l="Reikfoss of Greylin: Jump into the waterfall from the top of the cliff" }, { id=3, c="31.4N, 62.7W", l="Capedouble" }, { id=4, c="30.5N, 58.3W", l="Veithhol" }, { id=5,c="19.9N, 62.4W", l="Scraper's Clough" }, { id=6, c="25.9N, 62.5W", l="Caleb Rhimdath" }}, rewards={{Rewards.REPUTATION, "Protectors of Wilderland", 700}, {Rewards.TITLE, "Natural Wanderer"}}, tag="tag_flag.tga"}		
		}}
	}},	
	{name="Morgul Vale", map="25.jpg", region=4, areas={
		{map="39.jpg", name="Minas Morgul", wads={
			{id=2341, name="Rare Chests of Minas Morgul", target="Rare treasure chest", enemyType=3, frame="treasure.tga", size=1, level=127, poi={ { id=1, c="68.8S, 0.4E", l="Cercle 1" }, { id=2, c="67.2S, 3.5E", l="Cercle 1"}, { id=3,c="67.3S, 3.1E", l="Cercle 2, in the House of Songs"}, { id=4, c="66.2S, 0.9E", l="In Burzangh, the Dark Forge, upstairs behind the boss" }, { id=5, c="68.5S, 0.6E", l="In Dar Grazadh, Hall of Rot, in the south corner" }, { id=6, c="67.3S, 2.7E", l="Cercle 3"}, { id=7, c="67.2S, 0.7E", l="Cercle 3" }, { id=8, c="68.2S, 0.7E", l="Cercle 3" }, { id=9, c="66.9S, 1.5E", l="Cercle 4" }, { id=10, c="66.9S, 2.2E", l="Cercle 4" }, { id=11, c="67.3S, 2.4E", l="Cercle 5" }, { id=12,c="67.6S, 1.7E", l="Cercle 6" }}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "The White Company", 700}} , note="12 chests are hidden in Minas Morgul, but only 6 are required for the deed.", tag="tag_vault.tga"},			
			{id=2342, name="Lost Lore of the Morgul Vale: Minas Morgul", target="Glowing Page", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=127, multipoi={{map="41.jpg", poi={{ id=1, c="64.3S, 2.0W", l="Page 1" }, { id=2, c="64.6S, 0.9W", l="Page 2" }, { id=3, c="64.3S, 2.7W", l="Page 3" }, { id=4, c="64.8S, 0.9E", l="Page 4" }, { id=5, c="64.0S, 5.6E", l="Page 5" },  { id=16, c="63.8S, 2.3E", l="Page 16" }, { id=17, m={x=18, y=91}, c="64.3S, 2.4W", l="Page 17" }}},{map="39.jpg", poi={{id=6, c="67.0S, 1.3E", l="Page 6" }, {id=7, c="67.6S, 2.2E", l="Page 7" }, {id=8, c="65.8S, 2.0E", l="Page 8" }, {id=9, c="67.2S, 3.2E", l="Page 9" }, {id=10,c="68.5S, 0.6E", l="Page 10: In Dar Grazadh, south-west" }, {id=11, c="67.4S, 1.6E", l="Page 11" }, {id=12,c="66.7S, 2.4E", l="Page 12" }, {id=13, c="67.8S, 1.7E", l="Page 13" }, {id=14, c="67.8S, 1.2E", l="Page 14" },{id=15, c="67.3S, 0.2W", l="Page 15" }, {id=18, c="67.0S, 2.3E", l="Page 18" }, {id=19, c="67.1S, 1.8E", l="Page 19" }}}}, rewards={{Rewards.REPUTATION, "The Great Alliance", 900}, {Rewards.BOOK_SAVOIROUBLIE, "Minas Morgul"}}, tag="tag_page.tga"},			
		}},
		{map="25.jpg", name="Imlad Morgul", wads={
			{id=5000, name="Sigils of Imlad Ithil for Motes", enemyType=5, size=1, level=130, questname="SigilsofImladIthilforMotes", subname="SigilsofImladIthilforMotes", rewards={{Rewards.GRAINS, 500}},quest={pnj="Quartermaster of the White Compagny", loc="Estolad L\195\162n at 64.6S, 2.0W"}, how="Exchange [100 Sigils of Imlad Ithil] for [500 Motes of Enchantment].", repeatable=1, tag="tag_virtues.tga"},
			{id=5002, name="Imlad Morgul: The Reclamation", enemyType=5, size=1, level=130, questname="ImladMorgulTheReclamation", subname="ImladMorgulTheReclamation", rewards={{Rewards.GRAINS, 500}, {Rewards.TRACERIES_RUNES, 1, 121}},quest={pnj="automatically by taking an Instance Quest of Imlad Morgul from Ereblen", loc="Estolad Uial at 65.1S, 4.1E"}, how="Complete 10 Instance Quests of Imlad Ithil given by Ereblen or Tordoron.", repeatable=5, tag="tag_grains.tga"},	
			{id=5003, name="Imlad Morgul: Vale of Sorcery", enemyType=5, size=1, level=130, questname="ImladMorgulValeofSorcery", subname="ImladMorgulValeofSorcery", rewards={{Rewards.GRAINS, 500}, {Rewards.TRACERIES_RUNES, 2, 121}},quest={pnj="automatically when entering one of the instances of Minas Morgul", loc="Estolad Uial at 65.1S, 4.1E"}, how="Complete 4 instances of Minas Morgul", repeatable=5, tag="tag_grains.tga"},			
			{id=2344, name="Rare Chests of Thuringwath", target="Rare Mordor Chest", enemyType=3, frame="treasure.tga", size=1, level=130, multipoi={{map="42.jpg", poi={ { id=1, c="69.6S, 10.2E", l="" }, { id=2, c="70.4S, 10.7E", l=""}, { id=3,c="71.9S, 7.3E", l=""}, { id=4, c="71.7S, 7.7E", l="" }, { id=5, c="71.9S, 8.0E", l="" }, { id=6, c="73.7S, 7.5E", l=""}}}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "The White Company", 700}}, tag="tag_vault.tga"},			
			{id=2345, name="Lost Lore of the Morgul Vale: Thuringwath", target="RuneinscribedPage", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=130, multipoi={{map="42.jpg", poi={ { id=1,c="69.8S, 7.4E", l="Page 1" }, { id=2,c="71.6S, 7.7E", l="Page 2" }, { id=3,c="68.2S, 6.1E", l="Page 3" }, { id=4, c="70.4S, 10.7E", l="Page 4" }, { id=5, c="69.4S, 8.5E", l="Page 5" }, { id=6, c="72.2S, 7.7E", l="Page 6" }, { id=7, c="72.7S, 7.7E", l="Page 7" }, { id=8, c="71.2S, 7.7E", l="Page 8" }, { id=9, c="69.6S, 10.2E", l="Page 9" }, { id=10, c="73.7S, 7.7E", l="Page 10" }, { id=11, c="69.1S, 7.0E", l="Page 11" }, { id=12, c="70.9S, 8.8E", l="Page 12" }, { id=13, c="70.3S, 8.0E", l="Page 13" }, { id=14, c="70.7S, 7.6E", l="Page 14" }, { id=15, c="73.5S, 7.9E", l="Page 15" }, { id=16, c="73.4S, 7.5E", l="Page 16" }, { id=17, c="71.3S, 8.0E", l="Page 17" }, { id=18, c="71.3S, 7.3E", l="Page 18" }}}}, rewards={{Rewards.REPUTATION, "The White Company", 900}, {Rewards.BOOK_SAVOIROUBLIE, "Thuringwath"}}, tag="tag_page.tga"},		
			{id=2343, name="Rare Chests of Rath D\195\186ath", target="Rare Mordor Chest", enemyType=3, frame="treasure.tga", size=1, level=127, multipoi={{map="41.jpg", poi={ { id=1, c="66.3S, 0.1W", l="" }, { id=2, c="63.4S, 1.7E", l=""}, { id=3, c="66.9S, 7.8E", l="At the top passing by Shakam Moz"}, { id=4, c="63.7S, 4.6E", l="" }, { id=5, c="68.8S, 3.3E", l="Up through Daru Lagurz" }, { id=6, c="65.3S, 3.4E", l=""}}}}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "The White Company", 700}}, tag="tag_vault.tga"},			
			{id=2339, name="Rare Chests of Cirith Ungol", target="Rare Mordor Chest", enemyType=3, frame="treasure.tga", size=1, level=125, multipoi={{map="40.jpg", poi={{ id=1,c="59.3S, 1.2W", l="" },{ id=2, c="59.6S, 3.6E", l="" },{ id=3, c="61.9S, 2.2E", l="" },{ id=4, c="61.0S, 3.9E", l="" }}},{map="38.jpg", poi={{id=5, c="31.6N, 14.7E", l=""},{id=6, c="34.0N, 13.9E", l=""}}}}, rewards={{Rewards.REPUTATION, "The White Company", 700}, {Rewards.VERTUES, 2000}}, tag="tag_vault.tga"},			
			{id=2340, name="Lost Lore of the Morgul Vale: Cirith Ungol", target="Ancient page", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=125, multipoi={{map="40.jpg", poi={{ id=1, c="60.4S, 1.5W", l="Page 1" },{ id=2, c="63.4S, 0.7W", l="Page 2" },{ id=3, c="59.9S, 3.0E", l="Page 3" },{ id=4, c="62.6S, 1.3E", l="Page 4" },{ id=5, c="62.4S, 0.8E", l="Page 5" },{ id=6, c="60.4S, 3.1E", l="Page 6" },{ id=7,c="59.7S, 3.8E", l="Page 7" },{ id=8, c="61.5S, 3.5E", l="Page 8" },{ id=9,c="61.3S, 4.2E", l="Page 9" },{ id=11, c="61.8S, 2.1E", l="Page 11" },{ id=12,c="61.0S, 2.6E", l="Page 12" },{id=19, c="61.9S, 0.6W", l="Page 19"}}},{map="38.jpg", poi={{ id=10, c="32.0N, 11.9E", l="Page 10" },{ id=13,c="32.7N, 14.9E", l="Page 13" },{id=14, c="32.2N, 13.4E", l="Page 14"},{id=15, c="32.5N, 12.4E", l="Page 15"},{id=16, c="33.7N, 13.7E", l="Page 16"},{id=17, c="31.8N, 13.6E", l="Page 17"},{id=18, c="34.6N, 14.1E", l="Page 18"}}}}, rewards={{Rewards.REPUTATION, "The White Company", 700}, {Rewards.VERTUES, 2000}}, tag="tag_page.tga"},			
		}},		
		{map="37.jpg", name="Mordor Besieged", wads={
			{id=5011, name="Imlad Morgul: Continued Threats", enemyType=5, size=1, level=120, questname="ImladMorgulContinuedThreats", subname="ImladMorgulContinuedThreats", rewards={{Rewards.GRAINS, 500}, {Rewards.TRACERIES_RUNES, 2, 121}},quest={pnj="automatically when approaching a Roving threat.\nThis quest is unlocked at level 130, after completing the Minas Morgul quests.", loc="Mordor Besieged"}, how="Kill 8 of 9 Roving Threats of the Mordor Besieged.", repeatable=5, tag="tag_grains.tga"},
			{id=101, name="The Witch-king, Lord of the Nazg\195\187l, Scourge of Mordor", subname="TheWitchking", questname="TheWitchkingLordoftheNazglScourgeofMordor", loc="97.5S, 118.1W", closedPOI="Dol Naeg", size=6, level=130, difficulty=Difficulty.NEMESIS, moral="10,555,201", race="Nazgul", adds={}, rewards={{Rewards.REPUTATION, "The Great Alliance", 700}, {Rewards.ITHIL_REPUTATION_ITEM, 1}}, frame="race_nazgul.tga"},
			{id=102, name="The Grim Southron, Scourge of Mordor", subname="The Grim Southron", questname="TheGrimSouthronScourgeofMordor", loc="100.1S, 130.9W", closedPOI="Dingarth", size=3, level=130, difficulty=Difficulty.NEMESIS, moral="2,932,000", race="Nazgul", adds={}, rewards={{Rewards.REPUTATION, "The Great Alliance", 700}, {Rewards.ITHIL_REPUTATION_ITEM, 1}}, frame="race_nazgul.tga"},
			{id=103, name="The Woe of Khand, Scourge of Mordor", questname="TheWoeofKhandScourgeofMordor", loc="98.1S, 128.9W", closedPOI="Dingarth", size=3, level=130, difficulty=Difficulty.NEMESIS, moral="2,932,000", race="Nazgul", adds={}, rewards={{Rewards.REPUTATION, "The Great Alliance", 700}, {Rewards.ITHIL_REPUTATION_ITEM, 1}}, frame="race_nazgul.tga"},
			{id=104, name="The Cursed Rider, Scourge of Mordor", subname="The Cursed Rider", questname="TheCursedRiderScourgeofMordor", loc="94.5S, 124.5W", closedPOI="Dingarth", size=3, level=130, difficulty=Difficulty.NEMESIS, moral="2,932,000", race="Nazgul", adds={}, rewards={{Rewards.REPUTATION, "The Great Alliance", 700}, {Rewards.ITHIL_REPUTATION_ITEM, 1}}, frame="race_nazgul.tga"},
			{id=105, name="The Bane of Rh\195\187n, Scourge of Mordor", subname="BaneofRhn", questname="TheBaneofRhnScourgeofMordor", loc="94.1S, 121.9W", closedPOI="Lughash", size=3, level=130, difficulty=Difficulty.NEMESIS, moral="2,932,000", race="Nazgul", adds={}, rewards={{Rewards.REPUTATION, "The Great Alliance", 700}, {Rewards.ITHIL_REPUTATION_ITEM, 1}}, frame="race_nazgul.tga"},
			{id=106, name="The Black Blade of Lebennin, Scourge of Mordor", subname="The Black Blade of Lebennin", questname="TheBlackBladeofLebenninScourgeofMordor", loc="94.1S, 120.9W", closedPOI="Barthost", size=3, level=130, difficulty=Difficulty.NEMESIS, moral="2,932,000", race="Nazgul", adds={}, rewards={{Rewards.REPUTATION, "The Great Alliance", 700}, {Rewards.ITHIL_REPUTATION_ITEM, 1}}, frame="race_nazgul.tga"},
			{id=107, name="The Gloom of Nurn, Scourge of Mordor", subname="The Gloom of Nurn", questname="TheGloomofNurnScourgeofMordor", loc="96.1S, 119.9W", closedPOI="Dol Naeg", size=3, level=130, difficulty=Difficulty.NEMESIS, moral="2,932,000", race="Nazgul", adds={}, rewards={{Rewards.REPUTATION, "The Great Alliance", 700}, {Rewards.ITHIL_REPUTATION_ITEM, 1}}, frame="race_nazgul.tga"},
			{id=108, name="The High Sorcerer of Harad, Scourge of Mordor", subname="The High Sorcerer of Harad", questname="TheHighSorcererofHaradScourgeofMordor", loc="94.9S, 116.3W", closedPOI="Matum Graz", size=3, level=130, difficulty=Difficulty.NEMESIS, moral="2,932,000", race="Nazgul", adds={}, rewards={{Rewards.REPUTATION, "The Great Alliance", 700}, {Rewards.ITHIL_REPUTATION_ITEM, 1}}, frame="race_nazgul.tga"},
			{id=109, name="The Forsaken Reaver, Scourge of Mordor", subname="The Forsaken Reaver", questname="TheForsakenReaverScourgeofMordor", loc="97.1S, 114.9W", closedPOI="Sous le pont de Barad-dur", size=3, level=130, difficulty=Difficulty.NEMESIS, moral="2,932,000", race="Nazgul", adds={}, rewards={{Rewards.REPUTATION, "The Great Alliance", 700}, {Rewards.ITHIL_REPUTATION_ITEM, 1}}, frame="race_nazgul.tga"},
			{id=2337, name="Rare Chests of Mordor Besieged", target="Rare Mordor Chest", enemyType=3, frame="treasure.tga", size=1, level=125, poi={ { id=1, c="102.2S, 129.5W", l="Mokh Shapat" }, { id=2, c="93.9S, 124.0W", l="Amon Fuin"}, { id=3, c="Entrance: 93.5S, 123.8W", l="In Amon Fuin, straight ahead"}, { id=4,c="96.8S, 118.5W", l="Dol Naeg" }, { id=5, c="99.0S, 115.4W", l="Emyn Duir" }, { id=6, c="96.5S, 115.1W", l=""}, { id=7, c="95.1S, 115.9W", l="Matum Graz" }, { id=8, c="95.5S, 114.2W", l="Angathrai" }, { id=9, c="93.9S, 119.1W", l="Urshulagar" }, { id=10, c="95.7S, 124.0W", l="Mokh Darga" }}, rewards={{Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "The Great Alliance", 700}}, tag="tag_vault.tga"},
			{id=2338, name="Lost Lore of the Great Alliance", target="StarkwhitePage", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=125, poi={ { id=1, m={x=90, y=142}, c="99.1S, 125.8W", l="Page 1" }, { id=2, m={x=9, y=106}, c="96.6S, 131.7W", l="Page 2" }, { id=3, m={x=14, y=113}, c="96.8S, 131.6W", l="Page 3" }, { id=4, c="96.6S, 115.2W", l="Page 4" }, { id=5, c="98.7S, 115.3W", l="Page 5" }, { id=6, c="94.5S, 117.6W", l="Page 6" }, { id=7,c="95.3S, 119.9W", l="Page 7" }, { id=8, m={x=20, y=118}, c="97.1S, 131.4W", l="Page 8" }, { id=9, m={x=100, y=142}, c="99.1S, 125.8W", l="Page 9" }, { id=10, m={x=110, y=142}, c="99.1S, 125.8W", l="Page 10" }, { id=11, m={x=218, y=120}, c="97.0S, 118.5W", l="Page 11" }, { id=12, c="94.6S, 122.9W", l="Page 12" }, { id=13, c="97.1S, 125.7W", l="Page 13" }, { id=14, c="97.0S, 118.3W", l="Page 14" }, { id=15, c="93.5S, 124.2W", l="Page 15" }, { id=16, c="93.5S, 123.6W", l="Page 16" }, { id=17, c="94.9S, 121.7W", l="Page 17" }, { id=18, c="93.0S, 116.7W", l="Page 18" }, { id=19, c="95.2S, 121.0W", l="Page 19" }, { id=20, c="96.1S, 117.4W", l="Page 20" }, { id=21, c="97.8S, 115.8W", l="Page 21" }, { id=22,m={x=255, y=103}, c="96.5S, 115.5W", l="Page 22" }, { id=23, c="95.5S, 114.3W", l="Page 23" }, { id=24, c="95.0S, 115.8W", l="Page 24" }, { id=25, c="98.2S, 126.0W", l="Page 25" }, { id=26, m={x=78, y=94}, c="95.9S, 127.7W", l="Page 26" }, { id=27, c="96.0S, 127.9W", l="Page 27" }}, rewards={{Rewards.REPUTATION, "The Great Alliance", 900}, {Rewards.BOOK_SAVOIROUBLIE, "Mordor Besieged"}}, tag="tag_page.tga"},
		}}	
	}},	
	{name="Vales of Anduin",  map="24.jpg", region=2, areas={
		{map="24.jpg", name="Vales of Anduin", showme=false, wads={
			{id=5017, name="Gulmarks for Motes", enemyType=5, size=1, level=120, questname="glmarksformotes", subname="glmarksformotes", rewards={{Rewards.GRAINS, 200}},quest={pnj="Ragnild", loc="Hultvis (5.0N, 54.9W)"}, how="Exchange against 55 Gulmarks", repeatable=1, tag="tag_grains.tga"},
			{id=5013, name="Protecting the Beornings", enemyType=5, size=1, level=120, questname="ProtectingtheBeornings", subname="ProtectingtheBeornings", rewards={{Rewards.GRAINS, 300},{Rewards.TRACERIES_RUNES, 2, 116}},quest={pnj="Ragnild", loc="Hultvis (5.0N, 54.9W)"}, how="Complete twice the quest \"Protecting Shathur-munzu\"", repeatable=9, tag="tag_grains.tga"},	
			{id=5015, name="Protecting the Elves", enemyType=5, size=1, level=120, questname="ProtectingtheElves", subname="ProtectingtheElves", rewards={{Rewards.GRAINS, 300},{Rewards.TRACERIES_RUNES, 2, 116}},quest={pnj="Hithril", loc="Hultvis (5.0N, 54.9W)"}, how="Complete twice the quest \"Protecting Kidzul-kalah\"", repeatable=9, tag="tag_grains.tga"},	
			{id=5016, name="Protecting the Woodmen", enemyType=5, size=1, level=120, questname="ProtectingtheWoodmen", subname="ProtectingtheWoodmen", rewards={{Rewards.GRAINS, 300},{Rewards.TRACERIES_RUNES, 2, 116}},quest={pnj="Audvak", loc="Hultvis (5.0N, 54.9W)"}, how="Complete twice the quest \"Protecting Avabarg\"", repeatable=9, tag="tag_grains.tga"},	
			{id=2332, name="Jumped At the Chance\n[Hidden deed]", questname="JumpedAttheChance", subname="JumpedAttheChance", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=120, poi={ { id=1, c="8.6N, 56.6W", l="Jump from either end of the Hadhodiant down onto the higher part of the central broken pillar." }}, rewards={{Rewards.TITLE, "Jumped at the Chance"}}, tag="tag_flag.tga"},						
			{id=2333, name="A Chronicle of the Company", ico="poi.jpg", enemyType=3, frame="deed.tga", size=1, level=120, poi={ { id=1, c="12.0N, 63.4W", l="Where Bilbo lost his buttons" }, { id=2, c="10.9N, 61.3W", l="Where Bilbo reunites with the Company"}, { id=3, c="10.9N, 59.8W", l="	Where the Company encountered Wargs"}, { id=4, c="14.7N, 61.0W", l="	Where the Eagles took the Company to safety" }, { id=5, c="13.1N, 58.4W", l="Where the Eagles set down the Company" }, { id=6, c="13.4N, 57.8W", l="Where the Company gathered at the Carrock"}, { id=7, m={x=212, y=34}, c="12.9N, 54.4W", l="Where the Company walked through Beorn's bee-pastures" }, { id=8, m={x=217, y=27}, c="13.6N, 53.3W", l="Where the Company came upon Beorn's house" }, { id=9, m={x=226, y=27}, c="13.5N, 53.3W", l="	Where Beorn meets the Company" }, { id=10, m={x=220, y=38}, c="In Beorn's house", l="Where the Company had supper with Beorn" }, { id=11, c="15.7N, 51.2W", l="Where the Company enters the Mirkwood" }, { id=12, c="9.8N, 64.8W", l="Where Bilbo returns home" }}, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}, {Rewards.TITLE, "Chronicler of Thorin and Company"}, {Rewards.REPUTATION, "Wilderfolk", 700}}, tag="tag_flag.tga"},			
			{id=2334, name="Treasure-seeker of the Vales",  target="Hidden Cache", enemyType=3, frame="treasure.tga", size=1, level=120, poi={ { id=1, c="0.7S, 59.5W", l="" }, { id=2, c="0.8S, 61.6W", l=""}, { id=3, c="1.2S, 51.4W", l=""}, { id=4, c="1.6N, 51.8W", l="" }, { id=5, c="1.7N, 53.6W", l="" }, { id=6, c="5.7N, 57.1W", l=""}, { id=7, c="7.1N, 56.0W", l="" }, { id=8, c="16.7N, 54.3W", l="" }, { id=9, c="11.0N, 52.5W", l="" }, { id=10, c="16.7N, 57.0W", l="" }, { id=11, c="11.8N, 59.4W", l="" }, { id=12, c="8.5N, 62.8W", l="" }, { id=13, c="9.4N, 60.1W", l="" }, { id=14, c="2.4N, 57.8W", l="" }, { id=15, c="3.0N, 56.5W", l="" }, { id=16, c="10.1S, 59.7W", l="" }, { id=17, c="5.1S, 59.1W", l="" }, { id=18, c="11.0S, 62.2W", l="" }}, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}, {Rewards.TITLE, "Treasure Seeker of the Anduin"}, {Rewards.REPUTATION, "Wilderfolk", 700}}, tag="tag_vault.tga"},			
			{id=2335, name="Lost Lore of the Vales: Tauralindal\195\171",  target="OldelvenParchment", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=120, poi={ { id=1, c="2.9S, 53.6W", l="Page 1" }, { id=2, c="0.7N, 53.1W", l="Page 2" }, { id=3, c="1.2S, 56.4W", l="Page 3" }, { id=4, c="5.3N, 57.2W", l="Page 4" }, { id=5, c="10.9N, 56.3W", l="Page 5" }, { id=6, c="8.1N, 55.4W", l="Page 6" }, { id=7, c="4.1N, 54.7W", l="Page 7" }, { id=8, c="8.6N, 56.7W", l="Page 8" }, { id=9, c="3.6S, 58.3W", l="Page 9" }}, rewards={{Rewards.REPUTATION, "Wilderfolk", 900}, {Rewards.BOOK_SAVOIROUBLIE, "Tauralindal\195\171"}}, tag="tag_page.tga"},		
			{id=2336, name="Lost Lore of the Vales: Old Mad Ubb",  target="BirchbarkPage", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=120, poi={ { id=1, c="0.7N, 60.6W", l="Page 1" }, { id=2, c="1.7S, 60.5W", l="Page 2: room to the north, in the burrow" }, { id=3, c="12.0N, 63.4W", l="Page 3" }, { id=4, c="7.1N, 55.9W", l="Page 4: In the well of sorrows, room east" }, { id=5, c="8.0N, 56.7W", l="Page 5" }, { id=6, c="1.4S, 55.5W", l="Page 6" }, { id=7, c="4.8N, 54.6W", l="Page 7" }, { id=8, c="4.8N, 54.1W", l="Page 8" }, { id=9, c="5.3N, 57.1W", l="Page 9: in Avabarg, south-eastern room" }, { id=10, c="1.1S, 61.1W", l="Page 10" }}, rewards={{Rewards.REPUTATION, "Wilderfolk", 900}, {Rewards.BOOK_SAVOIROUBLIE, "Old Mad Ubb"}}, tag="tag_page.tga"}	
		}}	
	}},	
	{name="Grey Mountains Expedition", region=2, areas={
		{map="21.jpg", name="Grey Mountains Expedition", showme=false, wads={
			{id=2326, name="Survey Markers of the Dwarf-holds",  target="Dwarf-marker", ico="poi.jpg", enemyType=3, frame="POI_balise.tga", size=1, level=120, multipoi={{map="23.jpg", poi={{ id=1, c="26.1N, 12.0W", l="" },{ id=2, c="25.5N, 11.7W", l="" },{ id=3, c="22.7N, 9.5W", l="" },{ id=4, c="22.8N, 16.8W", l="" },{ id=5, c="20.5N, 16.3W", l="" },{ id=6, c="21.5N, 13.1W", l="" }}},{map="21.jpg", poi={{id=7, c="33.8N, 51.8W", l=""},{id=8, c="34.6N, 52.2W", l=""},{id=9, c="32.9N, 47.6W", l=""},{id=10, c="34.0N, 42.2W", l=""},{id=11, c="35.0N, 43.3W", l=""},{id=12, c="35.1N, 39.4W", l=""}}}}, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}, {Rewards.TITLE, "Surveyor of Mountains"}, {Rewards.REPUTATION, "Grey Mountains Expedition", 700},{Rewards.TRACERIES_RUNES, 2, 116}}, tag="tag_flag.tga"},			
		}},			
		{map="21.jpg", name="Ered Mithrin", wads={
			{id=5001, name="Longbeard Marks for Motes", enemyType=5, size=1, level=120, questname="longbeardmarksformotes", subname="longbeardmarksformotes", rewards={{Rewards.GRAINS, 100}},quest={pnj="Quartermaster", loc="Skarald at 34.7N, 45.4W"}, how="Exchange [15 Longbeard Marks] against [100 Motes of Enchantment].", repeatable=1, tag="tag_grains.tga"},
			{id=5010, name="Reclaiming the Grey", enemyType=5, size=1, level=120, questname="ReclaimingtheGrey", subname="ReclaimingtheGrey", rewards={{Rewards.GRAINS, 300},{Rewards.TRACERIES_RUNES, 2, 121}},quest={pnj="This quest is automatically bestowed upon acceptance of any of the four 'Resource Instance Daily quests' from Strhek the Stout", loc="Skarald at 34.7N, 45.4W"}, how="Complete 10 Gray Mountains instance quests given by Strahek", repeatable=5, tag="tag_grains.tga"},
			{id=2327, name="Treasure-seeker of Ered Mithrin", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=120, poi={ { id=1, c="30.1N, 32.3W", l="" }, { id=2, c="31.4N, 35.3W", l=""}, { id=3, c="30.2N, 49.7W", l=""}, { id=4, c="33.1N, 56.1W", l="" }, { id=5, c="36.2N, 53.6W", l="" }, { id=6, c="39.2N, 54.0W", l=""}, { id=7, c="36.5N, 44.0W", l="" }, { id=8, c="31.9N, 49.0W", l="" }, { id=9, c="33.4N, 42.1W", l="" }, { id=10, c="35.2N, 40.0W", l="" }, { id=11, c="43.5N, 34.6W", l="" }, { id=12, c="34.1N, 50.1W", l="" }}, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}, {Rewards.TITLE, "Treasure Seeker of the Grey Mountains"}, {Rewards.REPUTATION, "Grey Mountains Expedition", 700}}, tag="tag_vault.tga"},			
			{id=2329, name="Lost Lore of the Dwarf-holds: Ered Mithrin", target="Frozen Page", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=120, poi={ { id=1, c="40.2N, 37.7W", l="Page 1" }, { id=2, c="35.7N, 52.7W", l="Page 2" }, { id=3, c="36.8N, 43.7W", l="Page 3" }, { id=4, c="38.5N, 47.7W", l="Page 4" }, { id=5, c="36.3N, 46.5W", l="Page 5" }, { id=6, c="35.8N, 46.4W", l="Page 6" }, { id=7, c="38.1N, 53.9W", l="Page 7" }, { id=8, c="30.6N, 48.9W", l="Page 8" }}, rewards={{Rewards.REPUTATION, "Grey Mountains Expedition", 900}, {Rewards.BOOK_SAVOIROUBLIE, "Ered Mithrin"}}, tag="tag_page.tga"},		
			{id=2330, name="Lost Lore of the Dwarf-holds: Thikil-gundu", target="Rust-stained Writing", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=120, multipoi={{map="21.jpg", poi={{ id=1, c="33.0N, 39.5W", l="Page 1" },{ id=2, c="33.8N, 41.8W", l="Page 2" },{ id=3, c="35.5N, 42.0W", l="Page 3" },{ id=4, c="37.7N, 53.4W", l="Page 4" },{ id=5, c="37.8N, 54.2W", l="Page 5" }}},{map="34.jpg", poi={{id=6, m={x=156, y=163}, c="Page 6 - 22.9N, 136.0W", l="Instance Thikil-gundu: entrance"},{id=7, m={x=155, y=90}, c="Page 7 - 24.2N, 136.0W", l="Instance Thikil-gundu: banquet hall"},{id=8, m={x=199, y=126}, c="Page 8 - 23.6N, 135.5W", l="Instance Thikil-gundu: Against the north wall of the forges of Kall-Khebab"},{id=9, m={x=154, y=137}, c="Page 9 - 23.4N, 136.0W", l="Instance Thikil-gundu: In the center of Duruz-mazal"},{id=10, m={x=94, y=151}, c="Page 10 - 23.1N, 136.8W", l="Thikil-gundu Crafting Instance: in Bekar-mazal, near Zanmog"},{id=11, m={x=214, y=103}, c="Page 11 - 24.0N, 135.4W", l="Instance Thikil-gundu: In the library of Thikil Gundu"},{id=12, m={x=166, y=109}, c="Page 12 - 23.8N, 136.0W", l="Instance Thikil-gundu: In the feast room"},{id=13, m={x=90, y=97}, c="Page 13 - 24.2N, 137.2W", l="Instance Thikil-gundu: Near Karazgar's chest"},{id=14, m={x=158, y=60}, c="Page 14 - 24.9N, 136.0W", l="Instance Thikil-gundu - In the throne room of Thikil-Gundu"}}}}, rewards={{Rewards.REPUTATION, "Grey Mountains Expedition", 900}, {Rewards.BOOK_SAVOIROUBLIE, "Thikil-gundu"}}, tag="tag_page.tga"},			
			{id=2331, name="Lost Lore of the Dwarf-holds: Smaug", target="Claw-mark Writing", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=120, multipoi={{map="21.jpg", poi={{ id=2, c="39.2N, 43.8W", l="Page 2: In front of the Stormwall entrance" },{ id=10, c="39.2N, 47.5W", l="Page 10: Before entering Glimmerdeep" }}},{map="35.jpg", poi={{id=1, m={x=143, y=156}, c="Page 1 - 30.2N, 136.9W", l="Instance Glimmerdeep: entrance"},{id=3, m={x=143, y=121}, c="Page 3 - 30.8N, 136.9W", l="Instance Glimmerdeep: straight from the entrance"},{id=4, m={x=239, y=19}, c="Page 4 - 32.1N, 135.9W", l="Instance Glimmerdeep: on the platform of the second boss"},{id=5, m={x=150, y=35}, c="Page 5 - 32.0N, 136.8W", l="Glimmerdeep Crafting Instance: after the left bridge which is broken in the normal instance"},{id=8, m={x=232, y=133}, c="Page 8 - 30.5N, 135.9W", l="Instance Glimmerdeep"},{id=9, m={x=241, y=51}, c="Page 9 - 31.6N, 135.9W", l="Instance Glimmerdeep: after the first boss"}}},{map="36.jpg", poi={{ id=6, m={x=100, y=136}, c="Before Askurth Hall", l="Page 6: Instance Caverns of Thrumfall" },{ id=7, m={x=24, y=26}, c="Etterfang room", l="Page 7: Instances Caverns of Thrumfall" },{ id=11, m={x=280, y=79}, c="First room", l="Page 11: Instance Caverns of Thrumfall" }}}}, rewards={{Rewards.REPUTATION, "Grey Mountains Expedition", 900}, {Rewards.BOOK_SAVOIROUBLIE, "Smaug"}}, tag="tag_page.tga"},			
		}},		
		{map="23.jpg", name="Iron Hills", wads={
			{id=2324, name="Seeking Iron Veins", target="Rich Iron Vein", ico="poi.jpg", enemyType=3, frame="POI_balise.tga", size=1, level=120, poi={ { id=1, c="25.6N, 17.4W", l="" }, { id=2, c="28.7N, 15.9W", l=""}, { id=3, c="23.5N, 8.9W", l=""}, { id=4, c="25.7N, 7.6W", l="" }, { id=5, c="24.6N, 5.7W", l="" }, { id=6, c="23.5N, 18.4W", l="" }, { id=7, c="20.5N, 17.5W", l="" }, { id=8, c="23.8N, 12.0W", l="" }, { id=9, c="22.6N, 14.0W", l="" }, { id=10, c="23.1N, 15.4W", l="" }}, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}, {Rewards.TITLE, "Seeker of Iron"}, {Rewards.REPUTATION, "Dwarves of Erebor", 700}}, tag="tag_flag.tga"},		
			{id=2325, name="Treasure-seeker of the Ironfold", target="Mining Cache", enemyType=3, frame="treasure.tga", size=1, level=120, poi={ { id=1, c="27.5N, 17.3W", l="" }, { id=2, c="27.8N, 12.7W", l=""}, { id=3, c="22.0N, 11.6W", l=""}, { id=4, c="24.2N, 9.5W", l="" }, { id=5, c="22.9N, 8.8W", l="" }, { id=6, c="29.0N, 6.8W", l=""}, { id=7, c="25.0N, 5.3W", l="" }, { id=8, c="26.4N, 4.6W", l="" }, { id=9, c="27.9N, 4.7W", l="" }, { id=10, c="28.6N, 5.0W", l="" }}, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}, {Rewards.TITLE, "Seeker of Dwarf Mines"}, {Rewards.REPUTATION, "Dwarves of Erebor", 700}}, tag="tag_vault.tga"},
			{id=2328, name="Lost Lore of the Dwarf-holds: Ironfold", target="Rusted Page", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=120, multipoi={{map="23.jpg", poi={{ id=1, c="28.6N, 4.0W", l="Page 1" },{ id=2, c="26.1N, 8.1W", l="Page 2" },{ id=3, c="29.9N, 12.0W", l="Page 3" },{ id=5, c="30.7N, 12.3W", l="Page 5" },{ id=6, c="20.4N, 14.5W", l="Page 6" },{ id=8, c="28.8N, 15.6W", l="Page 8" },{ id=9, c="21.0N, 15.6W", l="Page 9" }}},{map="33.jpg", poi={{id=4, m={x=111, y=169}, c="Page 4 - Inside Jarnfast", l="Near supervisor Brumbur"},{id=7, m={x=164, y=43}, c="Inside Jarnfast", l="Page 7 - Behind the throne of Nain"},{id=10, m={x=176, y=45}, c="Page 10 - Inside Jarnfast", l="Down the stairs behind Nain"}}}}, rewards={{Rewards.REPUTATION, "Dwarves of Erebor", 900}, {Rewards.BOOK_SAVOIROUBLIE, "Iron Hills"}}, tag="tag_page.tga"}
		}}
	}},	
	{name="Eryn Lasgalen and the Dale-lands", map="32.jpg", region=2, areas={
		{map="32.jpg", name="Eryn Lasgalen and the Dale-lands", showme=false, wads={
			{id=5014, name="Restoring the Three Kingdoms", enemyType=5, size=1, level=115, questname="Restoring the Three Kingdoms", subname="Restoring the Three Kingdoms", rewards={{Rewards.GRAINS, 300},{Rewards.TRACERIES_RUNES, 2, 106}},quest={pnj="King Thorin III", loc="Hall Under the Mountain"}, how="Complete 8 repeatable quests in Dale, Erebor and Felegoth.", repeatable=1, tag="tag_parcgrain.tga"},			
			{id=1120, name="Urd\195\162r, Scourge of the Dale-lands", subname="urdr", questname="urdrscourgeofthedalelands", loc="Randomly among:", size=12, level=115, difficulty=Difficulty.NEMESIS, moral="1,624,000", power="36,781", race="Hill-man", adds={{6, "cats 427k", Difficulty.ELITE}}, rewards={{Rewards.FELEGOTH_TOKEN, 3}}, frame=nil, enemyType=2, rovingThreatData={loc={{c="23.5N, 27.7W", l=""},{c="20.7N, 24.7W", l=""},{c="17.5N, 23.5W", l=""},{c="15.2W, 22.8W", l=""}}}},
			{id=1121, name="Kalabraz\195\162n, Scourge of the Dale-lands", subname="kalabrazn", questname="kalabraznscourgeofthedalelands", loc="Randomly among:", size=12, level=115, difficulty=Difficulty.NEMESIS, moral="1,624,000", power="36,781", race="Angmarim", adds={{6, "men 427k", Difficulty.ELITE}}, rewards={{Rewards.FELEGOTH_TOKEN, 3}}, frame=nil, enemyType=2, rovingThreatData={loc={{c="22.8N, 27.4W", l=""},{c="20.7N, 24.7W", l=""},{c="17.5N, 32.5W", l=""},{c="15.2W, 22.8W", l=""}}}},
			{id=1122, name="Gloomthorn, Scourge of Eryn-Lasgalen", subname="Gloomthorn", questname="gloomthornscourgeoferynlasgalen", loc="Randomly among:", size=12, level=115, difficulty=Difficulty.NEMESIS, moral="1,624,000", power="36,781", race="Huorn", adds={{10, "Angry bees 142k", Difficulty.SIGNATURE}}, rewards={{Rewards.FELEGOTH_TOKEN, 3}}, frame=nil, enemyType=2, rovingThreatData={loc={{c="20.9N, 43.2W", l=""},{c="16.9N, 47.9W", l=""},{c="15.4N, 43.1W", l=""},{c="16.0W, 36.2W", l=""}}}},
			{id=2318, name="Surveyor of the Dwarf-marker",  target="Dwarf-marker", ico="poi.jpg", enemyType=3, frame="POI_balise.tga", size=1, level=115, poi={ { id=1, c="22.8N, 43.5W", l="atop an island in the river in Eryn Lasgalen" }, { id=2, c="26.2N, 28.9W", l=""}, { id=3,m={x=218, y=58}, c="27.3N, 29.2W", l=""}, { id=4, m={x=218, y=50}, c="27.9N, 29.3W", l="On a rocky outcrop" }, { id=5,c="28.0N, 28.8W", l="" }, { id=6,c="28.9N, 27.6W", l="South of the Secret Door leading into Erebor" }, { id=7, c="27.4N, 27.9W", l="" }, { id=8, c="26.4N, 27.1W", l="" }, { id=9, c="28.2N, 26.7W", l="" }, { id=10,c="26.6N, 23.8W", l="" }, { id=11, c="22.8N, 27.7W", l="" }, { id=12, c="23.7N, 28.3W", l="" }, { id=13, c="22.3N, 24.7W", l="" }, { id=14, c="21.6N, 25.6W", l="" }, { id=15, c="20.1N, 23.2W", l="" }, { id=16, c="16.9N, 30.0W", l="" }}, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}, {Rewards.TITLE, "Surveyor of Ores"}, {Rewards.REPUTATION, "Dwarves of Erebor", 700}}, tag="tag_flag.tga"},			
			{id=2319, name="The Path of the Company", ico="poi.jpg", enemyType=3, frame="POI_balise.tga", size=1, level=115, multipoi={{map="32.jpg", poi={ { id=1, c="15.7N, 50.9W", l="Where the Company entered Mirkwood" }, { id=2, c="16.2N, 47.3W", l="Where the Company grew to hate the forest"}, { id=3, c="16.8N, 39.1W", l="Where Bombur fell into the enchanted River"}, { id=4, m={x=152, y=136}, c="16.8N, 36.9W", l="Where Bilbo climbed above the trees\n(clickable branch)" }, { id=5, c="17.3N, 37.0W", l="Where the Company was lured off the path" }, { id=6, c="18.4N, 36.3W", l="Where the Company is ambushed by Spiders"}, { id=7, m={x=168, y=123}, c="18.3N, 35.8W", l="Where Bilbo frees the Company from webs" }, { id=11, c="16.1N, 31.8W", l="Where the barrels came ashore near Loeglond" }, { id=12, c="13.4N, 29.6W", l="Where Bilbo freed the company from their barrels" }, { id=13, c="14.5N, 28.9W", l="Where Thorin declared himself before the Master of Lake-town" }, { id=14, c="18.9N, 27.3W", l="Where the Company landed at the top of the Long Lake" }, { id=15, c="26.9N, 29.1W", l="Where they scouted the slopes of the Mountain" }, { id=16, c="31.8N, 27.8W", l="Where the company found the secret way into Erebor" }}},{map="46.jpg", poi={{ id=8, c="48.1N, 127.2W", l="Where Thorin was brought before the Elvenking\In Felegoth: the bridge in front of the Thranduil throne" }, { id=9, c="47.4N, 125.3W", l="Where the Company was jailed by the Elvenking\nIn Felegoth: the second northernmost prison on the left" }, { id=10, c="48.7N, 124.7W", l="Where the company stuffed themselves into barrels\nIn Felegoth: in the northernmost cave in the boatmen's area" }}}}, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}, {Rewards.TITLE, "Follower of Thorin and Company"}, {Rewards.REPUTATION, "Dwarves of Erebor", 900}}, tag="tag_flag.tga"},			
			{id=2320, name="Treasure-seeker of the North", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=115, poi={ { id=1, c="32.1N, 28.8W", l="" }, { id=2, c="27.0N, 29.0W", l=""}, { id=3, c="27.1N, 25.4W", l=""}, { id=4, m={x=292, y=70}, c="25.4N, 22.4W", l="" }, { id=5, m={x=297, y=60}, c="25.6N, 21.4W", l="" }, { id=6, c="23.1N, 27.9W", l=""}, { id=7, c="22.0N, 27.8W", l="" }, { id=8, c="20.2N, 26.4W", l="" }, { id=9, c="17.1N, 23.1W", l="" }, { id=10, c="14.6N, 23.5W", l="" }, { id=11, c="11.7N, 28.4W", l="" }, { id=12, c="20.2N, 31.7W", l="" }, { id=13, c="21.1N, 35.3W", l="" }, { id=14, c="15.5N, 34.8W", l="" }, { id=15, c="12.1N, 37.0W", l="" }, { id=16, c="19.0N, 38.4W", l="" }, { id=17, c="20.5N, 38.1W", l="" }, { id=18, c="23.7N, 43.9W", l="" }, { id=19, c="18.9N, 46.9W", l="" }, { id=20, c="14.0N, 50.1W", l="" }}, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}, {Rewards.TITLE, "Seeker of Dwarvish Treasures"}, {Rewards.REPUTATION, "Dwarves of Erebor", 700}}, tag="tag_vault.tga"},			
			{id=2321, name="Lost Lore of the North: Elves", target="Bark-paper Page", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=115, multipoi={{map="32.jpg", poi={{ id=6, c="20.8N, 36.9W", l="Page 6: near a statue at the entrance of Felegoth" }, { id=7, c="20.6N, 35.3W", l="Page 7: in Tham Aeldes" }, { id=9, c="31.7N, 28.0W", l="Page 9, follow the path to the secret entrance" }, { id=10, c="29.1N, 25.3W", l="Page 10" }, { id=11, c="20.0N, 36.7W", l="Page 11: Near Radagast" }, { id=12, c="16.2N, 32.8W", l="Page 12" }, { id=13, c="29.0N, 25.9W", l="Page 13" }, { id=14, c="27.2N, 26.4W", l="Page 14" }, { id=16, m={x=265, y=60}, c="25.1N, 25.0W", l="Page 16" }, { id=17, c="25.0N, 25.0W", l="Page 17" }}}, {map="46.jpg", mapName="Felegoth - The palace of the king of the elves", poi={{ id=1, c="48.2N, 127.1W", l="Page 1: in Felegoth, near the throne" }, { id=2, c="47.4N, 126.0W", l="Page 2: In Felegoth, in prisons" }, { id=3, c="48.0N, 125.4W", l="Page 3: in Felegoth, in the east prison" }, { id=4, c="48.3N, 125.4W", l="Page 4: in Felegoth, by the stream in the northern prison corridor" }, { id=5, c="47.8N, 126.3W", l="Page 5: in Felegoth, in the west prison" }}}, {map="45.jpg", mapName="Hall Under the Mountain", poi={{ id=8, m={x=181, y=48}, c="Hall Under the Mountain", l="Page 8, in the Hall under the Mountain, first floor, on the right, near the bridge" },{ id=15, m={x=116, y=143}, c="Hall Under the Mountain", l="Page 15: in the Hall Under the Mountain, at the top of the left staircase after the Vaults Keeper" }}}}, rewards={{Rewards.REPUTATION, "Elves of Felegoth", 700}, {Rewards.BOOK_SAVOIROUBLIE, "Elves of Felegoth"}, {Rewards.FELEGOTH_TOKEN, 3}}, tag="tag_page.tga"},		
			{id=2322, name="Lost Lore of the North: Men", target="Soggy Page", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=115, poi={ { id=1, c="26.2N, 26.4W", l="Page 1" }, { id=2, m={x=245, y=78}, c="25.2N, 25.7W", l="Page 2" }, { id=3, m={x=255, y=78}, c="24.8N, 25.6W", l="Page 3" }, { id=4, c="26.5N, 25.5W", l="Page 4" }, { id=5, m={x=265, y=78}, c="24.2N, 25.8W", l="Page 5" }, { id=6, c="23.1N, 26.1W", l="Page 6" }, { id=7, c="21.8N, 26.2W", m={x=265, y=100}, l="Page 7" }, { id=8, c="21.7N, 26.3W", l="Page 8" }, { id=9, m={x=249, y=137}, c="17.0N, 27.2W", l="Page 9, in the Lake-town barracks" }, { id=10, m={x=254, y=127}, c="17.2N, 27.0W", l="Page 10" }, { id=11, m={x=264, y=127}, c="17.3N, 26.8W", l="Page 11"}, { id=12, c="14.2N, 28.7W", l="Page 12" }, { id=13, m={x=295, y=78}, c="25.0N, 25.5W", l="Page 13" }, { id=14, m={x=275, y=78}, c="25.3N, 25.2W", l="Page 14" }, { id=15, m={x=285, y=78}, c="24.9N, 25.2W", l="Page 15" }}, rewards={{Rewards.REPUTATION, "Men of Dale", 700}, {Rewards.BOOK_SAVOIROUBLIE, "Men of Dale"}, {Rewards.FELEGOTH_TOKEN, 3}}, tag="tag_page.tga"},		
			{id=2323, name="Lost Lore of the North: Dwarves", target="Dusty Page", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=115, multipoi={{map="32.jpg", poi={ { id=1, m={x=265, y=50}, c="28.4N, 25.6W", l="Page 1" }, { id=2, m={x=260, y=30}, c="29.4N, 25.6W", l="Page 2" }, { id=3, m={x=270, y=30}, c="29.4N, 25.5W", l="Page 3" }, { id=4, c="27.9N, 30.2W", l="Page 4" }, { id=5, c="15.7N, 50.9W", l="Page 5" }, { id=6, c="31.0N, 27.8W", l="Page 6" }, { id=12, c="14.2N, 28.5W", l="Page 12" }, { id=13, m={x=260, y=40}, c="29.0N, 25.5W", l="Page 13" }, { id=14, m={x=270, y=40}, c="29.1N, 25.7W", l="Page 14" }, { id=15, m={x=265, y=59}, c="28.1N, 25.7W", l="Page 15" }}},{map="45.jpg", mapName="Hall Under the Mountain", poi={{ id=7, m={x=132, y=127}, c="Hall Under the Mountain", l="Page 7: in front of the Vaults Keeper" }, { id=8, m={x=184, y=134}, c="Hall Under the Mountain", l="Page 8, on the right staircase after the Vaults Keeper" }, { id=9, m={x=168, y=160}, c="Hall Under the Mountain", l="Page 9, behind the Vaults Keeper" }, { id=10, m={x=124, y=41}, c="Hall Under the Mountain", l="Page 10: Hall Under the Mountain, first floor, left" }, { id=11, m={x=144, y=21}, c="Hall Under the Mountain", l="Page 11: just before the throne of Thorin III" }, { id=16, m={x=128, y=158}, c="Hall Under the Mountain", l="Page 16: Hall Under the Mountain, the stairs leading down to the stream on the left" }, { id=17, m={x=171, y=23}, c="Hall Under the Mountain", l="Page 17: Hall Under the Mountain, east of the throne, after the great braziers" }}}}, rewards={{Rewards.REPUTATION, "Dwarves of Erebor", 700}, {Rewards.BOOK_SAVOIROUBLIE, "Dwarves of Erebor"}, {Rewards.FELEGOTH_TOKEN, 3}}, tag="tag_page.tga"},		
		}},	
	}},
	{name="The Plateau of Gorgoroth",  map="20.jpg", region=4, areas={
		-- {id=500, mapid=19, name="Master - Gorgoroth", showme=false},	
		{map="26.jpg", name="Ud\195\187n", rovingThreatData={loc={{c="40.9S, 3.9E", l=""},{c="45.6S, 0.7W", l="Between Mornaur and Durthang"},{c="45.6S, 3.7E", l="Udun: path east of Durthang"},{c="42.4S, 8.3E", l=""}}}, wads={		
			{id=1100, name="Thormurg the Slaughterer", subname="thormurgtheslaughterer", questname="thormurgtheslaughterer", loc="Randomly among:", size=6, level=115, difficulty=Difficulty.NEMESIS, moral="712K", race="Olog", adds={}, rewards={}, frame="gundash.tga", enemyType=2},
			{id=1101, name="Sharlag Man-breaker", subname="sharlagmanbreaker", questname="sharlagmanbreaker", loc="Randomly among:", size=6, level=115, difficulty=Difficulty.NEMESIS, moral="949K", race="Olog", adds={}, rewards={}, frame="gundash.tga", enemyType=2},
			{id=1110, name="Nuzdum, Scourge of Ud\195\187n", subname="nuzdum", questname="nuzdumscourgeudn", loc="Randomly among:", size=12, level=115, difficulty=Difficulty.NEMESIS, moral="1,353,000", power="36,781", race="Warg", adds={{4, "wargs 626K", Difficulty.ELITE}}, rewards={{Rewards.RELIQUE_ALLEGEANCE, 1}}, frame="voraut.tga", enemyType=2, rovingThreatData={loc={{c="39.6S, 6.8E", l=""},{c="40.9S, 3.9E", l=""},{c="45.6S, 7.3E", l=""}}}},
			{id=2300, name="Forge-works of Ud\195\187n", enemyType=3, ico="poi.jpg", frame="POI_Udun_Mach.tga", size=1, level=108, poi={ { id=1, c="42.4S, 0.5W", l="Across the poison water south of the road" }, { id=2, c="41.8S, 0.0W", l="" }, { id=3, c="40.8S, 0.1W", l="" }, { id=4, c="42.4S, 1.1E", l="at the top of the building" }, { id=5, c="41.7S, 2.4E", l="in a puddle of acid" }, { id=6, c="40.8S, 3.2E", l="" }, { id=7, c="44.0S, 2.5E", l="" }, { id=8, c="43.9S, 4.0E", l="" }, { id=9, c="43.1S, 7.0E", l="" }, { id=10, c="41.1S, 4.8E", l="" }, { id=11, m={x=173, y=79}, c="41.7S, 4.6E", l="" }, { id=12, m={x=185, y=79}, c="41.7S, 4.9E", l="" }, { id=13, m={x=185, y=85}, c="42.2S, 4.9E", l="" }, { id=14, m={x=173, y=85}, c="42.2S, 4.6E", l="" }, { id=15, m={x=185, y=101}, c="42.8S, 4.9E", l="" }, { id=16, m={x=173, y=101}, c="42.8S, 4.6E", l="" } }, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}, {Rewards.TITLE, "Gear-hunter"}}, tag="tag_flag.tga"},	
			{id=2301, name="Forge-fires of Ud\195\187n", enemyType=3, ico="poi.jpg",  frame="POI_forge.tga", size=1, level=108, poi={ { id=1, c="42.5S, 5.2E", l="Inside Maudhul Vor" }, { id=2, c="41.7S, 5.7E", l="Off the road in central Udun that curves northwest" }, { id=3, c="41.9S, 5.2E", l="" }, { id=4, m={x=161, y=74}, c="41.6S, 4.0E", l="" }, { id=5, m={x=157, y=70}, c="41.8S, 4.0E", l="" }, { id=6, c="42.1S, 3.3E", l="At the end of the road" }, { id=7, c="41.9S, 1.4E", l="" }, { id=8, c="41.9S, 3.8E", l="Near the treasure hiding place: jump from the top of the northern cliff" }, { id=9, c="42.1S, 0.1E", l="" }, { id=10, m={x=32, y=142}, c="44.8S, 1.1W", l="At the entrance of Mornaur" }, { id=11, m={x=32, y=138}, c="44.5S, 1.1W", l="Opposite the entrance to Mornaur" }, { id=12, m={x=18, y=138}, c="44.7S, 1.5W", l="West in Mornaur" }, { id=13, m={x=24, y=131}, c="44.3S, 1.4W", l="In Mornaur" }, { id=14, m={x=28, y=127}, c="44.3S, 1.3W", l="In Mornaur" }, { id=15, m={x=31, y=125}, c="44.2S, 1.1W", l="In Mornaur" }, { id=16, m={x=44, y=131}, c="44.2S, 0.7W", l="In Mornaur" } }, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}, {Rewards.TITLE, "Hand to the Flame"}}, tag="tag_flag.tga"},	
			{id=2302, name="Treasure of Ud\195\187n", target="TreasureCache", enemyType=3, frame="POI_Udun_coffre.tga", size=1, level=108, poi={ { id=1, c="40.8S, 0.2E", l="Atop a tower above the forgeworks. Walk around the forge from the slope to the east of it and climb to the roof from behind." }, { id=2, c="41.3S, 4.0E", l="Down the mountainside from the road to Anglach" }, { id=3, c="41.8S, 3.8E", l="From the Anglach road, jump off the cliff" }, { id=4, c="41.0S, 7.8E", l="Rogkalur, on the road east of Anglach" }, { id=5, c="43.4S, 1.8W", l="" }, { id=6, c="45.8S, 1.3W", l="" }, { id=7, c="44.5S, 0.1W", l="West in Mornaur" }, { id=8, c="43.8S, 2.0E", l="" }, { id=9, c="44.1S, 8.9E", l="behind a Mordor Captain's hut" }, { id=10, c="45.9S, 1.4E", l="North of Durtang promontory" }, { id=11, c="45.6S, 2.5E", l="" }, { id=12, c="45.5S, 6.1E", l="" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}}, tag="tag_vault.tga"},	
			{id=2303, name="Rare Gorgoroth Chests of Ud\195\187n", target="Rare Mordor Chest", enemyType=3, frame="POI_Udun_coffre.tga", size=1, level=115, poi={ { id=1, c="41.7S, 4.0E", l="In a Forgeworker camp next to an Enforcer of Ugrukhor" }, { id=2, c="43.6S, 8.9E", l="In Maudhul Tar Overlook" }, { id=3, c="43.9S, 0.7E", l="Mornaur, atop the road" }, { id=4, c="44.1S, 0.1E", l="Mornaur, atop the road, after the last point of the camp" }, { id=5, c="47.0S, 3.2E", l="Top of the tower in Durthang" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}}, tag="tag_vault.tga"},	
			{id=2304, name="Lost Lore of Gorgoroth: Ud\195\187n", target="Soot-Smudged", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=115, poi={ { id=1, c="42.6S, 2.0E", l="Page 1" }, { id=2, c="44.3S, 1.8E", l="Page 2" }, { id=3, c="42.9S, 3.1E", l="Page 3" }, { id=4, c="43.9S, 2.5E", l="Page 4" }, { id=5, c="41.3S, 3.3E", l="Page 5" }, { id=6, m={x=190, y=38}, c="39.4S, 5.7E", l="Page 6: in Anglach" }, { id=7, c="46.5S, 7.9E", l="Page 7" }, { id=8, c="41.8S, 5.8E", l="Page 8" }, { id=9, c="40.2S, 1.1W", l="Page 9" }, { id=10, m={x=94, y=166}, c="46.4S, 1.3E", l="Page 10: in front of the entrance of Durthang" }, { id=11, m={x=77, y=185}, c="46.2S, 1.4E", l="Page 11: in Durthang" }, { id=12, m={x=97, y=185}, c="46.2S, 1.4E", l="Page 12: in Durthang" }, { id=13, m={x=117, y=185}, c="47.0S, 3.2E", l="Page 13: in Durthang, at the top" }, { id=14, c="44.5S, 1.1W", l="Page 14" }, { id=15, m={x=210, y=38}, c="39.4S, 5.7E", l="Page 15: in Anglach" }, { id=16, c="41.0S, 7.6E", l="Page 16" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}, {Rewards.RELIQUE_ALLEGEANCE, 1}, {Rewards.BOOK_SAVOIROUBLIE, "Ud\195\187n"}, {Rewards.GORGOROTH_TOKEN, 3}}, tag="tag_page.tga"},		
		}},
		{map="27.jpg", name="Lhingris", rovingThreatData={loc={{c="51.3S, 4.1E", l="Before the lake"},{c="54.7S, 4.7E", l="In a corner of the road to Kala Murg"},{ c="58.5S, 7.6E", l="Lhingris"},{ c="62.5S, 9.7E", l="Lhingris"}}}, wads={
			{id=1104, name="Irongrasp", subname="irongrasp", questname="irongrasp", loc="Randomly among:", size=6, level=115, difficulty=Difficulty.NEMESIS, moral="870K", race="Grodbog", adds={}, rewards={}, frame=nil, enemyType=2},
			{id=1105, name="G\195\161ghoth the Taker", subname="gghoththetaker", questname="gghoththetaker", loc="Randomly among:", size=6, level=115, difficulty=Difficulty.NEMESIS, moral="564K", race="Uruk", adds={}, rewards={}, frame=nil, enemyType=2},
			{id=1113, name="Gristlebite, Scourge of Lhingris", subname="gristlebite", questname="gristlebitescourgeoflhingris", loc="Randomly among:", size=12, level=115, difficulty=Difficulty.NEMESIS, moral="1,567,000", race="Spider", adds={{6, "adds 412K", Difficulty.ELITE}}, rewards={{Rewards.RELIQUE_ALLEGEANCE, 1}}, frame=nil, enemyType=2, rovingThreatData={loc={{c="49.2S, 3.9E", l=""},{c="51.3S, 4.1E", l=""},{c="60.6S, 10.9E", l=""}}}},		
			{id=2305, name="Treasure of de Lhingris", target="TreasureCache", enemyType=3, frame="POI_Udun_coffre.tga", size=1, level=110, poi={ { id=1, c="47.3S, 5.6E", l="" }, { id=2, c="49.3S, 1.7E", l=" " }, { id=3, c="49.5S, 4.9E", l=" " }, { id=4, c="51.6S, 5.0E", l=" " }, { id=5, c="52.3S, 4.3E", l="" }, { id=6, c="53.3S, 7.2E", l="" }, { id=7, c="55.9S, 5.6E", l=" " }, { id=8, c="58.7S, 7.6E", l="" }, { id=9, c="65.4S, 12.7E", l="in Dath Nethryn" }, { id=10, c="61.0S, 10.6E", l=" " }, { id=11, c="55.7S, 6.5E", l="" }, { id=12, c="48.9S, 6.5E", l="" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}}, tag="tag_vault.tga"},	
			{id=2306, name="Rare Gorgoroth Chests of Lhingris", target="Rare Mordor Chest", enemyType=3, frame="POI_Udun_coffre.tga", size=1, level=115, poi={ { id=1, c="55.0S, 7.9E", l="Morgai" }, { id=2, c="58.2S, 4.6E", l="Nelegroth" }, { id=3, c="64.7S, 8.8E", l="Amon Ruth" }, { id=4, m={x=142, y=193}, c="18.7N, 33.5E", l="Inside Kam Lagurz, closest entrance is at [64.2S, 10.7E], then turn left and head a bit east and straight north" }, { id=5, c="56.4S, 6.1E", l="Ceber Duath" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}}, tag="tag_vault.tga"},	
			{id=2307, name="Lost Lore of Gorgoroth: Lhingris", target="WebcoveredPage", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=115, poi={ { id=1, c="48.8S, 4.5E", l="Page 1" }, { id=2, m={x=59, y=131}, c="58.0S, 4.6E", l="Page 2" }, { id=3, c="61.9S, 6.5E", l="Page 3" }, { id=4, m={x=106, y=153}, c="60.3S 8.2E", l="Page 4: in Cirith Ungol" }, { id=5, c="65.1S, 11.4E", l="Page 5" }, { id=6, m={x=165, y=190}, c="16.8N, 33.0E", l="Page 6: in Kam Lagurz" }, { id=7, m={x=190, y=173}, c="16.5N, 31.4E", l="Page 7: in Kam Lagurz" }, { id=8, c="56.4S, 5.1E", l="Page 8" }, { id=9, c="64.2S, 7.9E", l="Page 9" }, { id=10, c="61.8S, 11.6E", l="Page 10" }, { id=11, c="61.8S, 6.0E", l="Page 11" }, { id=12, c="53.7S, 7.5E", l="Page 12" }, { id=13, c="53.5S, 7.1E", l="Page 13" }, { id=14, c="53.8S, 5.1E", l="Page 14" }, { id=15, c="58.2S, 4.5E", l="Page 15" }, { id=16, m={x=45, y=153}, c="in Cirith Ungol", l="Page 16" }, { id=17, m={x=60, y=153}, c="in Cirith Ungol", l="Page 17" }, { id=18, m={x=75, y=153}, c="in Cirith Ungol", l="Page 18" }, { id=19, c="48.6S, 2.1E", l="Page 19" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}, {Rewards.RELIQUE_ALLEGEANCE, 1}, {Rewards.BOOK_SAVOIROUBLIE, "Lhingris"}, {Rewards.GORGOROTH_TOKEN, 3}}, tag="tag_page.tga"},	

		}},
		{map="28.jpg", name="Dor Amarth", rovingThreatData={loc={{c="47.2S, 20.5E", l="Near the northernmost crevasses"},{c="46.9S, 12.7E", l="Northwest of Blozronk"},{c="50.8S, 9.7E", l="In front of Fushaum Tum"},{c="44.3S, 18.0E", l="East of Lugash"}}}, wads={
			{id=1102, name="Grang\195\161th", subname="grangth",  questname="grangth", loc="Randomly among:", size=6, level=115, difficulty=Difficulty.NEMESIS, moral="837K", race="Shade", adds={}, rewards={}, frame="dukalon.tga", enemyType=2},
			{id=1103, name="Ulurgroth", subname="ulurgroth", questname="ulurgroth", loc="Randomly among:", size=6, level=115, difficulty=Difficulty.NEMESIS, moral="854K", race="Wraith", adds={}, rewards={}, frame="thorang.tga", enemyType=2},
			{id=1111, name="Rotwing, Scourge of Dor Amarth", subname="rotwing", questname="rotwingscourgeofdoramarth", loc="Randomly among:", size=12, level=115, difficulty=Difficulty.NEMESIS, moral="1,645,000", race="Fell Beast", adds={{4, "adds 712K", Difficulty.ELITE}}, rewards={{Rewards.RELIQUE_ALLEGEANCE, 1}}, frame=nil, enemyType=2, rovingThreatData={loc={{c="43.9S, 17.3E", l=""},{c="47.4S, 20.0E", l=""},{c="50.9S, 8.8E", l=""},{c="50.9S, 12.6E", l=""}}}},	
			{id=2308, name="Treasure of de Dor Amarth", target="TreasureCache", enemyType=3, frame="POI_Udun_coffre.tga", size=1, level=110, poi={ { id=1, c="51.6S, 11.7E", l="" }, { id=2, c="45.6S, 13.8E", l=" " }, { id=3, c="43.9S, 23.8E", l=" " }, { id=4, c="46.1S, 24.4E", l=" " }, { id=5, c="46.2S, 23.7E", l="" }, { id=6, c="51.5S, 13.5E", l="" }, { id=7, c="47.9S, 15.9E", l=" " }, { id=8, c="47.7S, 20.8E", l="" }, { id=9, c="50.9S, 8.4E", l="" }, { id=10, c="48.5S, 16.1E", l=" " }, { id=11, c="49.0S, 16.2E", l="" }, { id=12, c="48.3S, 20.1E", l="Across lava bridge at [47.3S, 19.9E] then south along narrow path just above the lava" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}}, tag="tag_vault.tga"},	
			{id=2309, name="Rare Gorgoroth Chests of Dor Amarth", target="Rare Mordor Chest", enemyType=3, frame="POI_Udun_coffre.tga", size=1, level=115, poi={ { id=1, c="46.3S, 12.9E", l="north-west of Blozronk" }, { id=2, c="51.3S, 11.5E", l="Fushaum Tum" }, { id=3, c="51.0S, 13.6E", l="" }, { id=4, c="47.4S, 18.9E", l="" }, { id=5, c="52.1S, 17.0E", l="west of Orodruin following the road from 48.3S, 16.4E" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}}, tag="tag_vault.tga"},	
			{id=2310, name="Lost Lore of Gorgoroth: Dor Amarth", target="Shadowed Page", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=115, poi={ { id=1, c="48.2S, 17.3E", l="Page 1" }, { id=2, c="50.3S, 17.8E", l="Page 2" }, { id=3, c="49.9S, 20.2E", l="Page 3" }, { id=4, c="44.1S, 16.1E", l="Page 4" }, { id=5, m={x=290, y=135}, c="In Barad-dur", l="Page 5" }, { id=6, m={x=290, y=150}, c="In Barad-dur", l="Page 6" }, { id=7, c="46.8S, 24.1E", l="Page 7" }, { id=8, c="47.2S, 26.0E", l="Page 8: In front of the Barad-Dur gate" }, { id=9, c="46.4S, 12.9E", l="Page 9" }, { id=10, c="43.7S, 18.5E", l="Page 10" }, { id=11, c="43.3S, 20.9E", l="Page 11" }, { id=12, c="43.6S, 23.1E", l="Page 12" }, { id=13, c="52.1S, 10.4E", l="Page 13" }, { id=14, c="48.2S, 7.7E", l="Page 14" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}, {Rewards.RELIQUE_ALLEGEANCE, 1}, {Rewards.BOOK_SAVOIROUBLIE, "Dor Amarth"}, {Rewards.GORGOROTH_TOKEN, 3}}, tag="tag_page.tga"},	
		}},
		{map="29.jpg", name="Talath \195\154rui", rovingThreatData={loc={{c="58.1S, 15.2E", l="Between Fushaum Bal and Thorzhaf"},{c="61.3S, 25.1E", l="Behind Magh Groth"},{c="58.3S, 17.9E", l="In the outpost, east of Thorzhaf"}}}, wads={
			{id=1106, name="Nakhts\195\187m the Scorcher", subname="nakhtsmthescorcher", questname="nakhtsmthescorcher", loc="Randomly among:", size=6, level=115, difficulty=Difficulty.NEMESIS, moral="854K", race="Grim", adds={}, rewards={}, frame=nil, enemyType=2},
			{id=1107, name="Z\195\161ghar Sh\195\162r, the Raging Blaze ", subname="zgharshrtheragingblaze ", questname="zgharshrtheragingblaze", loc="Randomly among:", size=6, level=115, difficulty=Difficulty.NEMESIS, moral="712K", race="Rogmul", adds={}, rewards={}, frame=nil, enemyType=2},
			{id=1112, name="Spitpyre, Scourge of Talath \195\154rui", subname="spitpyre", questname="spitpyrescourgeoftalathrui", loc="Randomly among:", size=12, level=115, difficulty=Difficulty.NEMESIS, moral="1,645,000", race="Drake", adds={{4, "adds 712K", Difficulty.ELITE}}, rewards={{Rewards.RELIQUE_ALLEGEANCE, 1}}, frame=nil, enemyType=2, rovingThreatData={loc={{c="52.9S, 14.4E", l=""},{c="57.0S, 15.9E", l=""},{c="62.5S, 25.5E", l=""},{c="60.8S, 26.3E", l=""},{c="61.7S, 15.8E", l=""}}}},		
			{id=1112, name="Uili\195\186r, the Ancient Evil", subname="uilirtheancientevil", questname="uilirtheancientevil", loc="Randomly among:", size=12, level=115, difficulty=Difficulty.NEMESIS, moral="1,645,000", race="Caerog", adds={}, rewards={{Rewards.RELIQUE_ALLEGEANCE, 1}}, frame=nil, enemyType=2, rovingThreatData={loc={{c="58.6S, 20.7E", l=""}}}, note="the quest will be unlocked only after killing the 5 others Ancient Evil of Gorgoroth"},		
			{id=2311, name="Treasure of de Talath \195\154rui", target="TreasureCache", enemyType=3, frame="POI_Udun_coffre.tga", size=1, level=110, poi={ { id=1, c="61.8S, 15.5E", l="" }, { id=2, c="64.0S, 21.2E", l=" " }, { id=3, c="58.5S, 23.4E", l=" " }, { id=4, c="55.6S, 16.1E", l=" " }, { id=5, c="58.8S, 20.6E", l="Jump on the islands from 58.3S, 18.8E" }, { id=6, c="61.7S, 22.7E", l="" }, { id=7, c="62.9S, 25.0E", l=" " }, { id=8, c="62.9S, 23.8E", l="" }, { id=9, c="57.7S, 25.2E", l="" }, { id=10, c="57.1S, 19.9E", l="Jump on the islands from 58.3S, 18.8E" }, { id=11, c="57.3S, 19.1E", l="Jump on the islands from 58.3S, 18.8E" }, { id=12, c="54.7S, 15.1E", l="" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}}, tag="tag_vault.tga"},	
			{id=2312, name="Rare Gorgoroth Chests of Talath \195\154rui", target="Rare Mordor Chest", enemyType=3, frame="POI_Udun_coffre.tga", size=1, level=115, poi={ { id=1, c="58.8S, 18.4E", l="Ghashgurm" }, { id=2, c="58.8S, 25.3E", l="Magh Nul" }, { id=3, c="53.8S, 10.1E", l="Dar Mauzur" }, { id=4, c="64.3S, 19.4E", l="Orodir, at the top of the south tower" }, { id=5, c="58.8S, 24.2E", l="West of Magh Nul" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}}, tag="tag_vault.tga"},	
			{id=2313, name="Lost Lore of Gorgoroth: Talath \195\154rui", target="Singed Page", enemyType=3, ico="poi.jpg", frame="page_mordor.tga", size=1, level=115, multipoi={{map="29.jpg", poi={ { id=1, c="58.8S, 12.1E", l="Page 1" }, { id=2, c="63.7S, 21.3E", l="Page 2" }, { id=3, m={x=143, y=171}, c="In Naerband", l="Page 3" }, { id=6, c="61.6S, 21.5E", l="Page 6" }, { id=7, m={x=158, y=171}, c="In Naerband", l="Page 7" }, { id=9, c="58.4S, 23.8E", l="Page 9" }, { id=10, c="63.8S, 18.5E", l="Page 10" }, { id=11, m={x=173, y=171}, c="In Naerband", l="Page 11" }, { id=13, c="61.7S, 21.1E", l="Page 13" }, { id=14, c="61.2S, 25.0E", l="Page 14" }, { id=15, c="58.8S, 25.3E", l="Page 15" }}}, {map="47.jpg", poi={{ id=4, m={x=27, y=106}, c="17.2N 12.5E", l="Page 4" }, { id=5, m={x=60, y=108}, c="17.2N, 13.0E", l="Page 5" }, { id=8, m={x=101, y=110}, c="17.1N, 13.6E", l="Page 8" }, { id=12, m={x=147, y=110}, c="17.1N, 14.3E", l="Page 12" }}}}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}, {Rewards.RELIQUE_ALLEGEANCE, 1}, {Rewards.BOOK_SAVOIROUBLIE, "Talath \195\154rui"}, {Rewards.GORGOROTH_TOKEN, 3}}, tag="tag_page.tga"},	
		}},
		{map="30.jpg", name="Agarnaith", rovingThreatData={loc={{c="55.2S, 26.9E"},{c="54.4S, 25.4E"},{c="49.1S, 32.7E", l="in front of the entrance to Seregost"}}}, wads={
			{id=1108, name="Drear-root", subname="drearroot", questname="drearroot", loc="Randomly among:", size=6, level=115, difficulty=Difficulty.NEMESIS, moral="863K", power="36,781", race="Huorn", adds={}, rewards={}, frame="coeurnoir.tga", enemyType=2},
			{id=1109, name="Agonakur Dusktooth", subname="agonakurdusktooth", questname="agonakurdusktooth", loc="Randomly among:", size=6, level=115, difficulty=Difficulty.NEMESIS, moral="712K", power="36,781", race="Morroval", adds={}, rewards={}, frame=nil, enemyType=2},
			{id=1114, name="Bolv\195\161g the Cursed, Scourge of Agarnaith", subname="bolvgthecursed", questname="bolvgthecursedscourgeofagarnaith", loc="Randomly among:", size=12, level=115, difficulty=Difficulty.NEMESIS, moral="1,567,000", race="Troll", adds={}, rewards={{Rewards.RELIQUE_ALLEGEANCE, 1}}, frame=nil, enemyType=2, rovingThreatData={loc={{c="47.0S, 33.5E", l=""},{c="52.5S, 25.5E", l=""},{c="56.1S, 24.7E", l=""}}}},		
			{id=2314, name="Treasure of Agarnaith", target="TreasureCache", enemyType=3, frame="POI_Udun_coffre.tga", size=1, level=110, poi={ { id=1, c="49.7S, 28.6E", l="" }, { id=2, c="48.8S, 30.3E", l=" " }, { id=3, c="49.1S, 33.0E", l=" " }, { id=4, c="51.2S, 32.7E", l=" " }, { id=5, c="54.5S, 25.0E", l="" }, { id=6, c="55.3S, 24.4E", l="" }, { id=7, c="48.9S, 31.3E", l="Inside Lair of the gloom-lord, boss room" }, { id=8, c="49.3S, 34.6E", l="" }, { id=9, c="46.5S, 36.7E", l="" }, { id=10, c="45.9S, 33.5E", l="" }, { id=11, c="47.4S, 33.4E", l="" }, { id=12, c="48.2S, 32.2E", l="" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}}, tag="tag_vault.tga"},	
			{id=2315, name="Rare Gorgoroth Chests of Agarnaith", target="Rare Mordor Chest", enemyType=3, frame="POI_Udun_coffre.tga", size=1, level=115, poi={ { id=1, c="53.8S, 25.1E", l="" }, { id=2, c="46.4S, 34.1E", l="Mokal Rukh" }, { id=3, c="48.3S, 32.9E", l="Seregost - Western courtyard" }, { id=4, c="48.3S, 34.1E", l="Seregost - Terrasse of Mokal Rukh" }, { id=5, c="49.0S, 33.0E", l="Seregost - Upper terrace" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}}, tag="tag_vault.tga"},	
			{id=2316, name="Lost Lore of Gorgoroth: Agarnaith", target="BloodstainedPage", ico="poi.jpg", enemyType=3, frame="page_mordor.tga", size=1, level=115, poi={ { id=1, m={x=235, y=88}, c="49.0S, 33.0E", l="Page 1: In Seregost" }, { id=2, c="51.3S, 26.5E", l="Page 2" }, { id=3, c="49.4S, 31.7E", l="Page 3" }, { id=4, m={x=250, y=88}, c="48.3S, 34.1E", l="Page 4: In Seregost" }, { id=5, m={x=265, y=88}, c="48.5S, 34.3E", l="Page 5: In Seregost" }, { id=6, c="52.4S, 26.9E", l="Page 6" }, { id=7, m={x=280, y=88}, c="48.5S 33.6E", l="Page 7: In Seregost" }, { id=8, m={x=211, y=81}, c="48.9S, 31.3E", l="Page 8: Inside Lair of the gloom-lord" }, { id=9, m={x=115, y=190}, c="56.5S, 26.8E", l="Page 9" }, { id=10, m={x=130, y=190}, c="56.5S, 27.0E", l="Page 10" }, { id=11, m={x=145, y=190}, c="56.4S, 27.0E", l="Page 11" }, { id=12, c="50.3S, 25.9E", l="Page 12" }, { id=13, c="50.6S, 26.2E", l="Page 13" }, { id=14, m={x=242, y=103}, c="49.2S, 33.9E", l="Page 14: In Seregost" }, { id=15, m={x=257, y=103}, c="49.9S, 33.4E", l="Page 15: In Seregost" }, { id=16, m={x=272, y=103}, c="48.5S, 33.4E", l="Page 16: In Seregost" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}, {Rewards.RELIQUE_ALLEGEANCE, 1}, {Rewards.BOOK_SAVOIROUBLIE, "Agarnaith"}, {Rewards.GORGOROTH_TOKEN, 3}}, tag="tag_page.tga"},	
		}},
		{id=55, map="31.jpg", name="Abyss of Mordath", wads={
			{ id=2317, name="Lost Lore: Abyss of Mordath", ico="poi.jpg", target="Forgotten page", enemyType=3, frame="page_mordor.tga", size=1, level=115, poi={ { id=1, m={x=224, y=37}, c="After the rope of Murpraush", l="Page 1" }, { id=2, m={x=58, y=66}, c="At the entrance", l="Page 2" }, { id=3, m={x=12, y=85}, c="Near Lithannon", l="Page 3" }, { id=4, m={x=146, y=84}, c="Near Durshnul", l="Page 4" }, { id=5, m={x=159, y=101}, c="Space on the left", l="Page 5" }, { id=6, m={x=202, y=32}, c="Before the rope of Tol Shikug", l="Page 6" }, { id=7, m={x=241, y=81}, c="Near Sagrog", l="Page 7" }, { id=8, m={x=186, y=117}, c="In the path near Sagrog", l="Page 8" }, { id=9, m={x=227, y=83}, c="Near Glurakul", l="Page 9" }, { id=10, m={x=262, y=161}, c="Near Glurnakh", l="Page 10" }, { id=11, m={x=275, y=181}, c="Near the chest of Fingar", l="Page 11" }}, rewards={{Rewards.REPUTATION, "Conquest of Gorgoroth", 700}, {Rewards.RELIQUE_ALLEGEANCE, 1}, {Rewards.BOOK_SAVOIROUBLIE, "Agarnaith"}, {Rewards.GORGOROTH_TOKEN, 3}}, tag="tag_page.tga"},		
		}},	
	}},
	{name="The Wastes",  map="19.jpg", region=4, areas={
		{id=48, name="The Wastes", showme=false, rovingThreatData={loc={{c="36.7S, 15.2W", l=""},{c="36.2S, 12.1W", l=""},{c="34.5S, 11.1W", l=""},{c="32.7S, 8.3W", l=""},{c="28.9S, 2.6W", l=""}}}, wads={
			{id=2201, name="Forgotten Caches", target="Ranger Cache", enemyType=3, frame="treasure.tga", size=1, level=105, poi={ { id=1,c="39.2S, 12.1W", l="The Noble's house ruins" }, { id=2, c="39.0S, 10.4W", l="The Inn ruins" }, { id=3, c="36.0S, 9.2W", l="The ruins outside of Haerondir" }, { id=4, c="34.8S, 7.3W", l="The guard tower ruins" }, { id=5, c="33.8S, 10.6W", l="Nuiharn" }, { id=6, c="30.2S, 7.3W", l="Ondoher's Folly (on the northern side)" }, { id=7, c="36.8S, 7.1W", l="North of Dm Boha (north of the first platform, just down)" }, { id=8, c="34.3S, 4.8W", l="North of the western Slag-hill" } }, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Host of the West", 500}, {Rewards.TITLE, "Seeker of the Lost"}}, tag="tag_vault.tga"},	
			{id=2202, name="Relics of the Last Alliance", target="Ancient Weapon", enemyType=3, frame="treasure.tga", size=1, level=105, poi={ { id=1, c="30.7S, 7.6W", l="Ondoher's Folly (west of the altars)" }, { id=2, c="37.0S, 9.2W", l="Ruins southeast of Haerondir" }, { id=3,c="33.7S, 10.9W", l="Rubble west of Nuiharn" }, { id=4, c="31.2S, 5.2W", l="In the middle of Dagorlad" }, { id=5, c="27.6S, 4.3W", l="In the marshes north of Dagorlad" }, { id=6, c="31.1S, 1.6W", l="In Dol Acharn (SE corner)" }, { id=7, c="35.1S, 15.2W", l="In the western marshes" }, { id=8, c="33.7S, 3.7W", l="North of the Slag-hills campfire" } }, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Host of the West", 500}, {Rewards.TITLE, "Relic Seeker of The Wastes"}}, tag="tag_flag.tga"},	
			{id=1041, name="Tumoz the Fume", subname="tumozlenrag", questname="tumozthefume", loc="Randomly among:", size=6, level=105, difficulty=Difficulty.NEMESIS, moral="1,742,487", race="Drake", adds={{5, "drakes 112K", Difficulty.ELITE}}, rewards={{Rewards.NITHILIEN_TOKEN, 3}, {Rewards.REPUTATION, "Host of the West", 900}, {Rewards.MARQUE_DONATEUR, 1}}, frame="rancevenin.tga", enemyType=2},
			{id=1042, name="Marzgur\195\186d", subname="marzgurd", questname="marzgurd", loc="Randomly among:", size=6, level=105, difficulty=Difficulty.NEMESIS, moral="1,742,487", race="Troll", adds={{6, "trolls 139K", Difficulty.ELITE}}, rewards={{Rewards.NITHILIEN_TOKEN, 3}, {Rewards.REPUTATION, "Host of the West", 900}, {Rewards.MARQUE_DONATEUR, 1}},  enemyType=2},
			{id=1043, name="Ephalz\195\180r", subname="ephalzr", questname="ephalzr", loc="Randomly among:", size=6, level=105, difficulty=Difficulty.NEMESIS, moral="1,742,487", race="Numenoreen", adds={{1, "Numenoreen 139K", Difficulty.ELITE}, {3, "Wardens 139K", Difficulty.ELITE}}, rewards={{Rewards.NITHILIEN_TOKEN, 3}, {Rewards.REPUTATION, "Host of the West", 900}, {Rewards.MARQUE_DONATEUR, 1}}, enemyType=2},
			{id=1044, name="Dorthan\195\173r", subname="dorthanr", questname="dorthanr", loc="Randomly among:", size=6, level=105, difficulty=Difficulty.NEMESIS, moral="1,742,487", race="Parjure", adds={{3, "undeads 139K", Difficulty.ELITE}}, rewards={{Rewards.NITHILIEN_TOKEN, 3}, {Rewards.REPUTATION, "Host of the West", 900}, {Rewards.MARQUE_DONATEUR, 1}}, enemyType=2},
			{id=1045, name="Gaergarch the Thirsty", subname="gaergarchthethirsty", questname="gaergarchthethirsty", loc="Randomly among:", size=6, level=105, difficulty=Difficulty.NEMESIS, moral="1,742,487", race="Spider", adds={{2, "spiders 316K", Difficulty.ELITE}, {4, "spiders 116K", Difficulty.ELITE}}, rewards={{Rewards.NITHILIEN_TOKEN, 3}, {Rewards.REPUTATION, "Host of the West", 900}, {Rewards.MARQUE_DONATEUR, 1}}, enemyType=2},
		}}
	}},
	{name="March of the King", map="17.jpg", region=3, areas={
		{name="North Ithilien", wads={
			{id=5018, name="Scrolls of Empowerment for Host of the West Silver Pieces (Daily)", enemyType=5, size=1, level=100, questname="ScrollsofEmpowermentforHostoftheWestSilverPiecesDaily", subname="ScrollsofEmpowermentforHostoftheWestSilverPiecesDaily", rewards={{Rewards.TRACERIES_RUNES, 1, 101}},quest={pnj="Quartermaster of Host of the West", loc="Camp of the Host (40.9S, 10.3W)"}, how="Trade for 50 [Host of the West Silver Pieces]", repeatable=5, tag="tag_parcho.tga"},
			{id=5019, name="Scrolls of Empowerment for Host of the West Silver Pieces (Weekly)", enemyType=5, size=1, level=100, questname="ScrollsofEmpowermentforHostoftheWestSilverPiecesWeekly", subname="ScrollsofEmpowermentforHostoftheWestSilverPiecesWeekly", rewards={{Rewards.TRACERIES_RUNES, 1, 101}},quest={pnj="Quartermaster of Host of the West", loc="Camp of the Host (40.9S, 10.3W)"}, how="Trade for 50 [Host of the West Silver Pieces]", repeatable=5, tag="tag_parcho.tga"},
			{id=99, name="Keeper Shomushuk, Cat-master of the Khundolar", subname="Shomushk", questname="keepershomushkcatmasterofthekhundolar", loc="42.3S, 12.8W", closedPOI="Torngroth", size=1, level=105, difficulty=Difficulty.SIGNATURE, moral="56,393", race="Easterling", adds={{6, "cats 38K", Difficulty.SIGNATURE}}, rewards={{Rewards.NITHILIEN_TOKEN, 3}, {Rewards.REPUTATION, "Host of the West", 700}}, frame="shomushk.tga", addlinked=false},
			{id=100, name="Ognir, Warrior of Minas Morgul", subname="ognir", questname="ognirwarriorofminasmorgul", loc="55.8S, 5.3W", closedPOI="Aelin Veren", size=3, level=105, difficulty=Difficulty.ELITE, moral="237,346", race="Troll", adds={}, rewards={{Rewards.NITHILIEN_TOKEN, 3}, {Rewards.REPUTATION, "Host of the West", 700}}, frame="ognir2.tga", addlinked=false},
			{id=101, name="Bittergall, the Weaver", subname="bittergall", questname="bittergaltheweaver", loc="57.7S, 7.8W", closedPOI="Bar Aroth", size=6, level=105, difficulty=Difficulty.NEMESIS, moral="569,631", race="Spider", adds={{6, "spiders 26K", Difficulty.NORMAL}}, rewards={{Rewards.NITHILIEN_TOKEN, 3}, {Rewards.REPUTATION, "Host of the West", 700}}, frame="morvenin.tga", addlinked=true},
			{id=2010, name="Treasure of North Ithilien", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=100, poi={ { id=1, c="56.4S, 5.0W", l="Along a water-side ledge in Thargelon" }, { id=2, c="53.1S, 7.6W", l="Behind the far wall of Aelin Veren" }, { id=3, c="59.5S, 6.1W", l="On top of the wall in Bar Aroth, jump from 59.6S, 5.9W" }, { id=4, c="56.4S, 8.1W", l="On the northern edge of a stream, next to a waterfall" }, { id=5, c="52.9S, 10.1W", l="	West of Aelin Veren, on the southern edge of a stream, on a cliff overlooking a waterfall" }, { id=6, c="51.3S, 8.2W", l="Northwest of Aelin Veren, in a forest glade, on a possible path to find Lokhu-Achi" }, { id=7, c="44.2S, 9.0W", l="East of Bar Tarnaher, at the base of the lone mountain" }, { id=8, c="46.4S, 10.6W", l="Southeast of Bar Tarnaher, at the base of a rock face" }, { id=9, c="56.7S, 7.3W", l="On the northern edge of a stream, between two waterfalls" }, { id=10, c="45.9S, 15.2W", l="Among reeds in the Anduin river" }, { id=11, c="52.2S, 11.3W", l="West of Aelin Veren, on the east edge of the Anduin river, in a patch of rocks"},{id=12, c="45.0S, 11.7W",l="Southeast of Bar Tarnaher, above and between the waterfalls"}},rewards={{Rewards.TURBINE, 5}, {Rewards.NITHILIEN_TOKEN, 12}, {Rewards.REPUTATION, "Host of the West", 900}, {Rewards.TITLE, "Treasure Seeker of North Ithilien"}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Host of the West", 900}}, tag="tag_vault.tga"},		
			{id=2200, name="Haradrim Remnants", target="Haradrim Supplies", enemyType=3, frame="treasure.tga", size=1, level=100, poi={ { id=1, c="58.3S, 13.1W", l="In the northwest corner of Parth Gladlo (After Battle)" }, { id=2, c="70.9S, 15.3W", l="In a Haradrim camp near the southeast section of the Rammas Echor" }, { id=3, c="63.8S, 8.8W", l="Near the docks, on the east side, near the second dock (Osgiliath (After Battle))" }, { id=4, c="64.4S, 9.9W", l="South of the docks, near the west watchtower on the Anduin (Osgiliath (After Battle))" }, { id=5, c="63.5S, 7.8W", l="Southwest of the Court of Isildur (Osgiliath (After Battle)" }, { id=6, c="61.2S, 10.4W", l="In the Cour de Meneldil, north shore (Osgiliath (After Battle))" } }, rewards={{Rewards.TURBINE, 5}, {Rewards.REPUTATION, "Host of the West", 900}, {Rewards.TITLE, "the Retriever"}, {Rewards.VERTUES, 2000}}, tag="tag_flag.tga"},
		}}
	}},
	{name="Minas Tirith",  map="16.jpg", region=3, areas={
		{name="Minas Tirith", showme=false, wads={
			{ id=2100, name="Guests of the White City", target="SUB", enemyType=3, ico="poi.jpg", frame="plaque.tga", size=1, level=90, poi={ 
				{ id=1, m={x=266, y=104}, c="65.6S, 16.9W - 1st cercle", l="The City Stables", t="City Stables"}, { id=2, m={x=275, y=86}, c="65.2S, 16.7W - 1st cercle", l="The Hall of Errands", t="Hall of Errands"}, { id=3, m={x=265, y=128}, c="66.3S, 17.1W - 1st cercle", l="Old Guesthouse", t="The Old Guesthouse"}, { id=4, m={x=249, y=135}, c="66.5S, 17.3W - 1st cercle", l="The South Guesthouse", t="South Guesthouse"}, { id=5, m={x=256, y=76}, c="64.8S, 17.1W - 1st cercle", l="The North Guesthouse", t="North Guesthouse" }, { id=6, m={x=220, y=147}, c="66.9S, 18.0W - 2nd cercle", l="The Guest Barracks", t="Guest Barracks"}, { id=7, m={x=196, y=147}, c="67.0S, 18.6W - 3rd cercle", l="The House of Rest",t="House of Rest"}, { id=8, m={x=155, y=139}, c="66.6S, 19.3W - 4th cercle", l="The High Guesthouse",t="High Guesthouse"}, { id=9, m={x=178, y=91}, c="65.3S, 18.8W - 6th cercle", l="The High Stables",t="High Stables"}, { id=10, m={x=169, y=111}, c="65.8S, 19.1W - 7th cercle", l="The Southern Great Guesthouse",t="Southern Great Guesthouse"} }, rewards={{Rewards.TURBINE, 5}, {Rewards.REPUTATION, "Defenders of Minas Tirith", 500}}, tag="tag_flag.tga"},
			{ id=2101, name="Taverns of the White City", target="SUB", enemyType=3, ico="poi.jpg", frame="plaque.tga", size=1, level=90, poi={ { id=1, m={x=168, y=24}, c="63.3S, 19.0W - 1st cercle", l="The Wheel and Cask",t="The Wheel and Cask"}, { id=2, m={x=187, y=181}, c="67.8S, 18.6W - 1st cercle", l="The Laughing Halfling",t="The Laughing Halfling"}, { id=3, m={x=171, y=167}, c="67.4S, 18.9W - 2nd cercle", l="The Splintered Shield",t="The Splintered Shield"}, { id=4, m={x=127, y=160}, c="67.3S, 19.9W - 2nd cercle", l="The Mmak and Keep",t="TheMmakandKeep"}, { id=5, m={x=170, y=42}, c="63.7S, 19.0W - 2nd cercle", l="The Wainrider's Head",t="TheWainridersHead"}, { id=6, m={x=181, y=53}, c="64.1S, 18.9W - 3rd cercle", l="The Hammer and Tongs",t="The Hammer and Tongs"}, { id=7, m={x=216, y=140}, c="66.6S, 18.2W - 3rd cercle", l="The Haven",t="The Haven"}, { id=8, m={x=137, y=149}, c="67.1S, 19.8W - 3rd cercle", l="The Merry Swan",t="The Merry Swan"}, { id=9, m={x=151, y=58}, c="64.2S, 19.4W - 3rd cercle", l="The Brick and Mortar",t="The Brick and Mortar"}, { id=10, m={x=189, y=75}, c="64.7S, 18.6W - 4th cercle", l="The Cresting Wave",t="The Cresting Wave"}, { id=11, m={x=183, y=136}, c="66.6S, 18.7W - 4th cercle", l="The Lone Beacon",t="The Lone Beacon"}, { id=12, m={x=148, y=124}, c="66.2S, 19.7W - 5th cercle", l="The Thirsty Seer",t="The Thirsty Seer"}, { id=13, m={x=153, y=81}, c="65.0S, 19.4W - 5th cercle", l="The Eagle and Sickle",t="The Eagle and Sickle"} }, rewards={{Rewards.TURBINE, 5}, {Rewards.REPUTATION, "Defenders of Minas Tirith", 500}}, tag="tag_flag.tga"},
			{ id=2102, name="Teachings of the White City", target="SUB", enemyType=3, ico="poi.jpg", frame="plaque.tga", size=1, level=90, poi={ { id=1, m={x=182, y=80}, c="64.9S, 18.8W - 5th cercle", l="House of the Heavens",t="House of the Heavens"}, { id=2, m={x=199, y=105}, c="65.7S, 18.4W - 5th cercle, under the central tunnel", l="Old Archives",t="Old Archives"}, { id=3, m={x=187, y=121}, c="66.1S, 18.7W - 5th cercle", l="Archives of Vorondil",t="Archives of Vorondil"}, { id=4, m={x=148, y=128}, c="66.4S, 19.5W - 5th cercle", l="Black House",t="Black House"}, { id=5, m={x=156, y=126}, c="66.3S, 19.5W - 5th cercle", l="Houses of Lore",t="Houses of Lore"} }, rewards={{Rewards.TURBINE, 5}, {Rewards.REPUTATION, "Defenders of Minas Tirith", 500}}, tag="tag_flag.tga"},	
			{ id=2103, name="Vaults of the White City", target="SUB", enemyType=3, ico="poi.jpg", frame="plaque.tga",  size=1, level=90, poi={ { id=1, m={x=278, y=110}, c="65.9S, 16.8W - 1st cercle", l="Keep of the Keys",t="Keep of the Keys"}, { id=2, m={x=260, y=85}, c="65.0S, 17.1W - 1st cercle", l="Lower Stores",t="Lower Stores"}, { id=3, m={x=223, y=87}, c="65.2S, 17.8W - 3rd cercle", l="Vaults of Rynd Mrath",t="Vaults of Rynd Mrath"}, { id=4, m={x=165, y=138}, c="67.0S, 19.3W - 3rd cercle", l="Middle Stores",t="Middle Stores"}, { id=5, m={x=189, y=82}, c="65.0S, 18.6W - 5th cercle", l="Upper Stores",t="Upper Stores"}, { id=6, m={x=161, y=111}, c="65.8S, 19.2W - 7th cercle", l="Coffer-House",t="CofferHouse"} }, rewards={{Rewards.TURBINE, 5}, {Rewards.REPUTATION, "Defenders of Minas Tirith", 500}}, tag="tag_flag.tga"},	
			{ id=2104, name="Workings of the White City", target="SUB", enemyType=3, ico="poi.jpg", frame="plaque.tga", size=1, level=90, poi={ { id=1, m={x=231, y=72}, c="64.6S, 17.7W - 2nd cercle", l="Hall of Laws",t="Hall of Laws"}, { id=2, m={x=136, y=41}, c="63.8S, 19.8W - 2nd cercle", l="City Gaol",t="City Gaol"}, { id=3, m={x=223, y=89}, c="65.2S, 17.8W - 3rd cercle", l="House of Clamour",t="House of Clamour"}, { id=4, m={x=168, y=89}, c="65.1S, 19.1W - 6th cercle", l="Chambers of the City",t="Chambers of the City"}, { id=5, m={x=182, y=94}, c="65.2S, 18.8W - 6th cercle", l="Dome of the Sun",t="Dome of the Sun"} }, rewards={{Rewards.TURBINE, 5}, {Rewards.REPUTATION, "Defenders of Minas Tirith", 500}}, tag="tag_flag.tga"},
			{ id=2105, name="The Line of Kings", target="SUB", enemyType=3, ico="poi.jpg", frame="plaque.tga",  size=1, level=90, poi={ 
				{ id=1, m={x=268, y=103}, c="65.5S, 16.9W - 1st cercle", l="High King Elendil",t="HighKingElendilSonofAmandilSA33203441"}, 
				{ id=2, m={x=268, y=111}, c="65.7S, 16.9W - 1st cercle", l="King Isildur",t="KingIsildurSonofElendilSA3341TA2"}, 
				{ id=3, m={x=268, y=95}, c="65.5S, 16.9W - 1st cercle", l="King Anarion",t="KingAnrionSonofElendilSA33203440"}, 
				{ id=4, m={x=190, y=86}, c="65.1S, 18.6W - 5th cercle", l="King Meneldil Teltarcil",t="KingMeneldilTeltarcilSonofAnrionTA2158"}, 
				{ id=5, m={x=168, y=121}, c="66.1S, 19.0W - 6th cercle", l="King Cemendur",t="KingCemendurSonofMeneldil158238"}, 
				{ id=6, m={x=173, y=116}, c="66.1S, 18.9W - 6th cercle", l="King Earendil",t="KingErendilSonofCemendur238324"}, 
				{ id=7, m={x=150, y=154}, c="67.2S, 19.5W - 3rd cercle", l="King Anardil",t="KingAnardilSonofErendil324411"}, 
				{ id=8, m={x=162, y=108}, c="65.7S, 19.2W - 1st cercle", l="King Ostoher",t="KingOstoherSonofAnardil411492"}, 
				{ id=9, m={x=190, y=96}, c="65.5S, 18.7W - 1st cercle", l="King Romendacil I Tarostar",t="KingRmendacilITarostarSonofOstoher492541"}, 
				{ id=10, m={x=200, y=96}, c="65.5S, 18.5W - 1st cercle", l="King Turambar Onotimo",t="KingTurambarOntimoSonofTarostar541667"}, 
				{ id=11, m={x=168, y=26}, c="63.4S, 18.8W - 1st cercle", l="King Atanatar I",t="KingAtanatarISonofTurambar667748"}, 
				{ id=12, m={x=149, y=183}, c="68.0S, 19.4W - 1st cercle", l="King Siriondil",t="KingSiriondilSonofAtanatar748830"}, 
				{ id=13, m={x=262, y=115}, c="66.0S, 16.9W - 1st cercle", l="King Tarannon Falastur",t="KingTarannonFalasturSonofSiriondil830913"}, 
				{ id=14, m={x=270, y=120}, c="66.0S, 17.0W - 1st cercle", l="King Earnil I Ciryatan",t="KingErnilICiryatanSonofTarciryan913936"}, 
				{ id=15, m={x=151, y=172}, c="67.8S, 19.4W - 1st cercle", l="King Ciryandil Umarth",t="KingCiryandilmarthfilsdErnil9361015"}, 
				{ id=16, m={x=190, y=109}, c="65.7S, 18.7W - 7th cercle", l="King Hyarmendacil I Ciryaher",t="KingHyarmendacilICiryaherSonofCiryandil10151149"}, 
				{ id=17, m={x=138, y=67}, c="64.5S, 19.7W - 4th cercle", l="King Atanatar II Alcanin",t="KingAtanatarIIAlcarinSonofCiryaher11491226"}, 
				{ id=18, m={x=131, y=69}, c="64.5S, 19.7W - 4th cercle", l="King Narmacil 1er",t="KingNarmacilISonofAtanatar12261294"}, 
				{ id=19, m={x=145, y=65}, c="64.5S, 19.7W - 4th cercle", l="King Calmacil",t="KingCalmacilSonofAtanatar12941304"}, 
				{ id=20, m={x=224, y=99}, c="65.5S, 17.9W - 7th cercle", l="King Romendacil II Minalcar",t="KingRmendacilIIMinalcarSonofCalmacil13041366"}, 
				{ id=21, m={x=184, y=27}, c="63.3S, 18.7W - 1st cercle", l="King Valacar Formendur",t="KingValacarFormendurSonofMinalcar13661432"}, 
				{ id=22, m={x=175, y=108}, c="65.6S, 18.7W - 7th cercle", l="King Eldacar Vinitharya",t="KingEldacarVinitharyaSonofValacar1432143714471490"}, 
				{ id=23, m={x=145, y=74}, c="64.6S, 19.6W - 4th cercle", l="King AldFriendr",t="KingAldFriendrSonofEldacar14901540"}, 
				{ id=24, m={x=198, y=110}, c="65.7S, 18.5W - 7th cercle", l="King Hyarmendacil II Vinyarion",t="KingHyarmendacilIIVinyarionSonofAldFriendr15401621"}, 
				{ id=25, m={x=135, y=79}, c="64.6S, 19.7W - 4th cercle", l="King Minardil Umanwa",t="KingMinardilmanwaSonofVinyarion16211634"}, 
				{ id=26, m={x=195, y=27}, c="63.3S, 18.6W - 1st cercle", l="King Telemnar Sintavarda",t="KingTelemnarSintavardaSonofMinardil16341636"}, 
				{ id=27, m={x=175, y=99}, c="65.6S, 18.7W - 7th cercle", l="King Tarondor Andovarda",t="KingTarondorAndovardaSonofMinastan16361798"}, 
				{ id=28, m={x=224, y=109}, c="65.7S, 17.9W - 7th cercle", l="King Telumehtar Umbardacil",t="KingTelumehtarUmbardacilSonofTarondor17981850"}, 
				{ id=29, m={x=167, y=145}, c="66.7S, 19.1W - 4th cercle", l="King Narmacil II Romenturun",t="KingNarmacilIIRomenturnSonofTelumehtar18501856"}, 
				{ id=30, m={x=166, y=137}, c="66.6S, 19.1W - 4th cercle", l="King Calimehtar Minastan",t="KingCalimehtarMinastanSonofNarmacil18561936"}, 
				{ id=31, m={x=137, y=176}, c="67.8S, 19.6W - 1st cercle", l="King Ondoher Manardil",t="KingOndoherManardilSonofCalimehtar19361944"}, 
				{ id=32, m={x=203, y=147}, c="66.9S, 18.4W - 3rd cercle", l="King Earnil II Malehta",t="KingErnilIIMelehtaSonofSiriondil19452043"}, 
				{ id=33, m={x=162, y=100}, c="65.5S, 19.2W - 7th cercle", l="King Earnur Teldil",t="KingErnurTeldilSonofErnil20432050"} 
			}, rewards={{Rewards.TURBINE, 5}, {Rewards.REPUTATION, "Defenders of Minas Tirith", 500}}, tag="tag_flag.tga"},
			{ id=2106, name="The Stewards of Gondor", target="SUB", enemyType=3, ico="poi.jpg", frame="plaque.tga", size=1, level=90, poi={
				{id=1, m={x=197, y=128}, c="66.3S, 18.4W - 4th cercle", l="Steward Mardil Voronwe",t="StewardMardilVoronwSonofVorondil20502080"},
				{id=2, m={x=205, y=130}, c="66.4S, 18.4W - 4th cercle", l="Steward Eradan",t="StewardEradanSonofMardil20802116"},
				{id=3, m={x=224, y=44}, c="63.9S, 17.8W - 1st cercle", l="Steward Herion",t="StewardHerionSonofEradan21162148"},
				{id=4, m={x=179, y=127}, c="66.3S, 18.8W - 5th cercle", l="Steward Belegorn",t="StewardBelegornSonofHerion21482204"},
				{id=5, m={x=264, y=93}, c="65.3S, 16.9W - 1st cercle", l="Steward Hurin I",t="StewardHrinISonofBelegorn22042244"},
				{id=6, m={x=276, y=89}, c="65.2S, 16.8W - 1st cercle", l="Steward Turin I",t="StewardTrinISonofHrin22442278"},
				{id=7, m={x=182, y=86}, c="65.1S, 18.7W - 5th cercle", l="Steward Hador Andin",t="StewardHadorSonofTrin22782395"},
				{id=8, m={x=164, y=64}, c="64.4S, 19.2W - 4th cercle", l="Steward Barahir",t="StewardBarahirSonofHador23952412"},
				{id=9, m={x=118, y=69}, c="64.4S, 20.3W - 3rd cercle", l="Steward Dior",t="StewardDiorSonofBarahir24122435"},
				{id=10, m={x=155, y=87}, c="65.1S, 19.4W - 6th cercle", l="Steward Denethor I",t="StewardDenethorISonofDior24352477"},
				{id=11, m={x=192, y=28}, c="63.5S, 18.5W - 1st cercle", l="Steward Boromir Harna",t="StewardBoromirCharnSonofDenethor24772489"},
				{id=12, m={x=156, y=28}, c="63.4S, 19.3W - 1st cercle", l="Steward Cirion Gwaedhir",t="StewardCirionGwaedhirSonofBoromir24892567"},
				{id=13, m={x=141, y=142}, c="66.6S, 19.7W - 4th cercle", l="Steward Hallas",t="StewardHallasSonofCirion25672605"},
				{id=14, m={x=145, y=148}, c="66.6S, 19.7W - 4th cercle", l="Steward Hurin II",t="StewardHrinIISonofHallas26052628"},
				{id=15, m={x=163, y=82}, c="64.9S, 19.2W - 5th cercle", l="Steward Belecthor I",t="StewardBelecthorISonofHrinII26282655"},
				{id=16, m={x=159, y=75}, c="64.8S, 19.4W - 5th cercle", l="Steward Orodreth",t="StewardOrodrethSonofBelecthor26552685"},
				{id=17, m={x=161, y=110}, c="65.7S, 19.2W - 7th cercle", l="Steward Ecthelion I Minastur",t="StewardEcthelionIMinasturSonofOrodreth26852698"},
				{id=18, m={x=116, y=61}, c="64.3S, 20.3W - 3rd cercle", l="Steward Egalmoth",t="StewardEgalmothSonofEgalreth26982743"},
				{id=19, m={x=161, y=98}, c="65.5S, 19.2W - 7th cercle", l="Steward Beren Istardil",t="StewardBerenIthrondilSonofEgalmoth27432763"},
				{id=20, m={x=138, y=166}, c="67.4S, 19.7W - 2nd cercle", l="Steward Beregond Belechest",t="StewardBeregondBelechestSonofBeren27632811"},
				{id=21, m={x=142, y=70}, c="64.6S, 19.6W - 4th cercle", l="Steward Belecthor II Orndil",t="StewardBelecthorIIOrndilSonofBeregond28112882"},
				{id=22, m={x=145, y=80}, c="64.9S, 19.6W - 5th cercle", l="Steward Thorondir",t="StewardThorondirSonofBelecthor28722882"},
				{id=23, m={x=235, y=136}, c="66.6S, 17.6W - 2nd cercle", l="Steward Turin II",t="StewardTrinIISonofThorondir28822914"},
				{id=24, m={x=177, y=95}, c="65.3S, 18.9W - 6th cercle", l="Steward Turgon",t="StewardTurgonSonofTrin29142953"},
				{id=25, m={x=187, y=93}, c="65.2S, 18.8W - 6th cercle", l="Steward Ecthelion II Turyarta",t="StewardEcthelionIIThandirSonofTurgon29532984"}}, 
				rewards={{Rewards.TURBINE, 5}, {Rewards.REPUTATION, "Defenders of Minas Tirith", 500}}, tag="tag_flag.tga"},	
		}}
	}},
	{name="Far Anorien",  map="15.jpg", region=3, areas={
		{id=450, name="Master - Lointain Anorien", showme=false, wads={
			{id=2009, name="Treasure of Far Anorien", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=90, poi={ { id=1, c="48.6S, 32.0W", l="The Beacon Hills, west side of the river near the waterfall" }, { id=2, c="48.5S, 33.9W", l="The Beacon Hills, atop a ridge by a rock" }, { id=3, c="46.6S, 32.6W", l="The Beacon Hills, behind a building in Erelas southeast of the beacon" }, { id=4, c="45.6S, 35.9W", l="The Beacon Hills, west of the road to Ost Rimmon, go up and through a cleft in the rocks" }, { id=5, c="47.9S, 39.5W", l="The Beacon Hills, base of a cliff on the east side of the river near Rimmon Quarry" }, { id=6, c="40.5S, 39.0W", l="The Beacon Hills, north of the Variag camp at Bar Nadhron next to a large rock" }, { id=7, c="45.4S, 41.6W", l="The Beacon Hills, at the base of a cliff south of Calenhad" }, { id=8, c="43.9S, 42.0W", l="The Beacon Hills, in a small stable near a building on road to Calenhad" }, { id=9, c="43.9S, 47.1W", l="The Beacon Hills, on the east river bank up the steep hillside and at the base of a cliff" }, { id=10, c="46.6S, 47.3W", l="The Beacon Hills, down the cliff southwest from Halifirien" }, { id=11, c="53.7S, 19.5W", l="Taur Druadan, in the Grey Wood on the north side of the river" }, { id=12, c="45.6S, 19.8W", l="Taur Druadan, among some trees north of the bridge to Talath Anor" }, { id=13, c="48.5S, 22.7W", l="Taur Druadan, take the road to Amon Din" }, { id=14, c="48.9S, 24.2W", l="Taur Druadan, go right from Amon Din entrance and follow along the outside wall" }, { id=15, c="48.9S, 30.1W", l="Taur Druadan, leave the road to Nardol at the southern curve and head south down the rocks" }, { id=16, c="44.2S, 29.0W", l="Taur Druadan, next to a rock north of the War-stead of the Rohirrim Stable-master" } }, rewards={{Rewards.TURBINE, 5}, {Rewards.REPUTATION, "Riders of Rohan", 900}, {Rewards.ROHAN_RIDER_REPUTATION_ITEM, 7}, {Rewards.ROHAN_RIDER_REPUTATION_ITEM2, 4}, {Rewards.TITLE, "Treasure Seeker of Far Anorien"}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Riders of Rohan", 900}}, tag="tag_vault.tga"},
			{id=94, name="Asl\195\162 Khimash", questname="aslkhimash", loc="46.2S, 19.9W", closedPOI="Amon Din", size=1, level=105, difficulty=Difficulty.SIGNATURE, moral="45,135", race="Mounted Haradrim", adds={{3, "Riders 22K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "Riders of Rohan", 900}}, frame="aslakhimash.tga", addlinked=false},
			{id=95, name="Kr\195\187ghu", questname="krghu", loc="55.9S, 18.0W", size=3, level=105, difficulty=Difficulty.ELITE, moral="101,468", race="Nameless", adds={{3, "Nameless 449K", Difficulty.SIGNATURE}}, rewards={{Rewards.ROHAN_RIDER_REPUTATION_ITEM, 5}}, frame="krughu.tga", addlinked=true},
			{id=96, name="Nauruk", questname="naurk", loc="43.0S, 36.1W", closedPOI="Min-Rimmon", size=1, level=105, difficulty=Difficulty.SIGNATURE, moral="52,797", race="Warg rider", adds={{1, "monted orc", Difficulty.SIGNATURE}}, rewards={{Rewards.ROHAN_RIDER_REPUTATION_ITEM, 4}}, frame="jouteur.tga", addlinked=true},
			{id=97, name="Ganglem\195\179d", questname="ganglemd", loc="50.5S, 24.7W", closedPOI="Luk Khakat", size=1, level=105, difficulty=Difficulty.SIGNATURE, moral="52,797", race="Spider", adds={}, rewards={{Rewards.REPUTATION, "Riders of Rohan", 900}}, frame="ganglemod.tga", addlinked=true},
			{id=98, name="Yarl Vrakya", questname="yarlvrakya", loc="41.6S, 42.9W", closedPOI="Calenhad", size=3, level=105, difficulty=Difficulty.ELITE, moral="123,083", race="Brigand", adds={{2, "archers 53K", Difficulty.SIGNATURE},{1, "soldier 53K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "Riders of Rohan", 1200}}, frame="vrakya.tga", addlinked=true}		
		}},			
	}},
	{name="Old Anorien", map="14.jpg", region=3, areas={
		{name="Pelennor", wads={
			{id=89, name="Sharsh\195\187g", questname="sharshg", loc="67.7S, 13.4W", closedPOI="Pelennor", size=3, level=103, difficulty=Difficulty.GRAND_ELITE, moral="281,257", race="Troll", adds={{3, "adds 45K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "Defenders of Minas Tirith", 900}}, frame="sharshug.tga", addlinked=true},
			{id=90, name="K\195\187r-anchi", questname="kranchi", loc="66.2S, 12.6W", closedPOI="Pelennor", size=6, level=103, difficulty=Difficulty.GRAND_ELITE, moral="417,791", race="Oliphant", adds={{3, "haradrims 94K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "Defenders of Minas Tirith", 1200}},frame="kuranchi.tga", addlinked=true},
			{id=110, name="Okursa", questname="okursa", loc="69.7S, 15.8W", closedPOI="Pelennor", size=6, level=103, difficulty=Difficulty.GRAND_ELITE, moral="417,791", race="Haradrim", adds={{2, "half-Trolls 168K", Difficulty.ELITE},{3, "Haradrims 94K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "Defenders of Minas Tirith", 1200}}, frame="okursa.tga", addlinked=true}
		}},
		{name="Talath Anor", wads={
			{id=91, name="Mauz\195\186r", questname="mauzr", loc="47.5S, 17.8W", closedPOI="Parth Lisc", size=3, level=103, difficulty=Difficulty.ELITE, moral="92,488", race="Warg", adds={{3, "adds 45K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "Defenders of Minas Tirith", 900}}, frame=nil, mapPos={x=119, y=21}, addlinked=true},
			{id=92, name="Fen-skulk", questname="fenskulk", loc="60.5S, 12.0W", closedPOI="Jal Varsha", size=3, level=103, difficulty=Difficulty.ELITE, moral="111,676",  race="Rodemarais", adds={}, rewards={{Rewards.REPUTATION, "Defenders of Minas Tirith", 900}}, frame=nil, addlinked=false},
			{id=93, name="Tup\195\187rta", questname="tuprta", loc="58.2S, 11.8W", closedPOI="Parth Gladlo", size=3, level=103, difficulty=Difficulty.GRAND_ELITE, moral="417,791", race="Warg", adds={{3, "marauders 45K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "Defenders of Minas Tirith", 1200}}, frame=nil, addlinked=true}	
		}},
	}},
	{name="Eastern Gondor", map="7.jpg", region=3, areas={
		{name="Upper Lebennin", wads={
			{id=86, name="Kasota",  questname="kasota", loc="82.4S, 28.8W", closedPOI="Glianath", size=3, level=103, difficulty=Difficulty.GRAND_ELITE, moral="198,185", race="Haradrim", adds={{3, "Riders 36K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "Rangers of Ithilien", 700}, {Rewards.EGONDOR_TOKEN, 3}}, frame=nil, addlinked=true},		
		}},
		{name="South Ithilien", wads={
			{id=87, name="Gundr\195\161g", questname="gundrg", loc="64.0S, 4.4W", size=6, level=103, difficulty=Difficulty.GRAND_ELITE, moral="266,836", race="Troll", adds={{2, "Trolls 119K", Difficulty.ELITE},{3, "Goblins 39K", Difficulty.SIGNATURE}}, rewards={ {Rewards.REPUTATION, "Rangers of Ithilien", 900}, {Rewards.EGONDOR_TOKEN, 4}}, frame=nil, addlinked=true},
			{id=88, name="Thangol-ya", questname="thangolya", loc="70.4S, 8.5W", closedPOI="Bar Hurin", size=12, level=103, difficulty=Difficulty.GRAND_ELITE, moral="2,531,815", race="Mammoth", adds={{5, "Haradrims 50K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "Rangers of Ithilien", 900}, {Rewards.EGONDOR_TOKEN, 5}}, frame=nil, addlinked=true},
		}},
		{name="Master - Est Gondor", showme=false, rovingThreatData={loc={{c="76.7S, 12.3W"},{c="76.3S, 16.6W"},{c="75.9S, 14.4W"},{c="71.9S, 8.1W"},{c="70.0S, 10.2W"},{c="68.9S, 9.8W"},{c="66.3S, 8.8W"},{c="64.8S, 3.9W"},{c="62.6S, 6.4W"},{c="63.0S, 10.8W"},{c="63.0S, 8.8W"}}},wads={		
			{id=1028, name="Morgrish, the Beast from Harad", subname="morgrish", questname="morgrishthebeastfromharad", loc="Randomly among:", size=3, level=104, difficulty=Difficulty.NEMESIS, moral="835,582", power="36,781", race="Half-troll", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame=nil, enemyType=2, pnj="Walnoth (Bar Hurin)"},
			{id=1029, name="Shardr\195\161gh, the Morgul Siege-beast", subname="shardrgh", questname="shardrghthemorgulsiegebeast", loc="Randomly among:", size=6, level=104, difficulty=Difficulty.NEMESIS, moral="1,148,926", power="53,802", race="Troll", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 3}}, frame="shardragh.tga", enemyType=2, pnj="Walnoth (Bar Hurin)"},
			{id=1030, name="Kethat-sai the Destroyer", subname="kethatsai", questname="kethatsaithedestroyer", loc="Randomly among:", size=12, level=104, difficulty=Difficulty.NEMESIS, moral="1,263,819", power="36,781", race="Mammoth", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 5}}, frame="kethatsai.tga", enemyType=2, pnj="Walnoth (Bar Hurin)"},
			{id=2008, name="Treasure of Eastern Gondor", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=90, poi={ { id=1, c="78.4S, 32.3W", l="Upper Lebennin, top of the cliff" }, { id=2, c="82.8S, 28.6W", l="Upper Lebennin" }, { id=3, c="81.4S, 25.5W", l="Upper Lebennin" }, { id=4, c="81.2S, 24.3W", l="Lossarnach: at the edge of a peninsula in the Erui Delta" }, { id=5, c="76.0S, 21.0W", l="Lossarnach: outside the southern wall of Ost Norhr" }, { id=6, c="78.5S, 22.3W", l="Lossarnach: down a hillside south of the east exit from Aegollant" }, { id=7, c="75.0S, 25.0W", l="Lossarnach: in the trees north of Minlos" }, { id=8, c="71.8S, 21.3W", l="Lossarnach: at the base of the cliff northwest of Harlond" }, { id=9, c="78.8S, 18.8W", l="South Ithilien: atop the cliff above the boat dock from Lossarnach" }, { id=10, c="75.8S, 10.9W", l="South Ithilien: outside the northeast wall of Harlanc" }, { id=11, c="74.4S, 9.9W", l="South Ithilien: above the falls east of Bar Hurin" }, { id=12, c="73.1S, 14.3W", l="South Ithilien: on a ledge below the north end of the bridge to Bar Hurin, near Langarch" }, { id=13, c="70.7S, 4.1W", l="South Ithilien: Contre la montagne de l'est" }, { id=14, c="65.6S, 8.8W", l="South Ithilien: on a forested hill south of Osgiliath" }, { id=15, c="63.8S, 10.3W", l="Osgiliath: on a ledge south of the Armoury near Morgul Raiders" }, { id=16, c="64.6S, 9.1W", l="Osgiliath: by the river south of a pillar near Haradrim" }, { id=17, c="62.7S, 10.0W", l="Osgiliath, down near the river inside a metal hut" }, { id=18, c="61.1S, 8.7W", l="Osgiliath: atop a high wall" } }, rewards={{Rewards.TURBINE, 10}, {Rewards.EGONDOR_TOKEN, 18}, {Rewards.TITLE, "Treasure Seeker of Eastern Gondor"}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Rangers of Ithilien", 900}}, tag="tag_vault.tga"},
		}}
	}},
	{name="Central Gondor", map="6.jpg", region=3, areas={
		{name="Ringl\195\179 Vale", rovingThreatData={loc={{c="70.3S, 47.6W"},{c="71.7S, 52.0W"},{c="72.0S, 48.6W"},{c="73.7S, 49.2W"},{c="76.3S, 50.4W"},{c="72.3S, 48.6W"},{c="70.3S, 47.4W"}}}, wads={
			{id=79, name="Skorneval", questname="skorneval", loc="71.4S, 52.4W", closedPOI="Ethring", size=3, level=102, difficulty=Difficulty.GRAND_ELITE, moral="203,493", race="Shade", adds={{3, "wariors 91K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "Men of Ringlo Vale", 700}, {Rewards.CGONDOR_TOKEN, 3}}, frame="skorneval.tga", addlinked=true},		
			{id=1019, name="Scythe-jaw, the Dread Spider", subname="scythejaw", questname="scythejawthedreadspider", loc="Randomly among:", size=3, level=103, difficulty=Difficulty.NEMESIS, moral="534,733", race="Spider", adds={}, rewards={{Rewards.CGONDOR_TOKEN, 5}, {Rewards.RINGLOVALE_REPUTATION_ITEM, 1}}, frame="fauchecroc.tga", enemyType=2, note="Reputation needed: Ringlo Vale - Acquaintance\nNeed completion of the quest: A Ruthless End", pnj="Candur (Ethring)"},
			{id=1020, name="Gundash, the White Mountain Menace", subname="gundash", questname="gundashthewhitemountainmenace", loc="Randomly among:", size=3, level=103, difficulty=Difficulty.NEMESIS, moral="534,733", race="Troll", adds={}, rewards={{Rewards.CGONDOR_TOKEN, 5}, {Rewards.RINGLOVALE_REPUTATION_ITEM, 1}}, frame="gundash.tga", enemyType=2, note="Reputation needed: Ringlo Vale - Friend\nNeed completion of the quest: A Ruthless End", pnj="Laerind (Ethring)"},
			{id=1021, name="Du-kalon, the Pitiless Dead", subname="dukalon", questname="dukalonthepitilessdead", loc="Randomly among:", size=6, level=103, difficulty=Difficulty.NEMESIS, moral="2,005,398", race="Shade", adds={}, rewards={{Rewards.CGONDOR_TOKEN, 5}, {Rewards.RINGLOVALE_REPUTATION_ITEM, 1}}, frame="dukalon.tga", enemyType=2, note="Reputation needed: Ringlo Vale - Ally\nNeed completion of the quest: A Ruthless End", pnj="Arvaethor (Ethring)"},
		}},
		{name="Dor-en-Ernil", rovingThreatData={loc={{c="77.7S, 50.2W"},{c="78.3S, 49.0W"},{c="79.4S, 48.0W"},{c="81.3S, 47.1W"},{c="81.4S, 48.0W"},{c="83.0S, 50.8W"},{c="83.1S, 49.3W"}}}, wads={
			{id=80, name="Hamarsun", questname="hamarsun", loc="79.1S, 51.5W", size=3, level=102, difficulty=Difficulty.ELITE, moral="109,889", race="Humain", adds={{3, "corsairs 244K", Difficulty.GRAND_ELITE}}, rewards={{Rewards.REPUTATION, "Men of Dor-en-Ernil", 700}, {Rewards.CGONDOR_TOKEN, 3}}, frame="hamarsun.tga", addlinked=true},
			{id=81, name="Shat\195\186pash",questname="shatpash", loc="82.4S, 51.3W", size=6, level=102, difficulty=Difficulty.NEMESIS, moral="506,363", race="half-troll", adds={{4, "half-trolls 113K", Difficulty.ELITE},{3, "archers 41K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "Men of Dor-en-Ernil", 700}, {Rewards.CGONDOR_TOKEN, 4}}, frame="shatupash.tga", addlinked=true},
			{id=82, name="Hokhir", questname="hokhir", loc="84.4S, 51.7W", size=6, level=102, difficulty=Difficulty.NEMESIS, moral="463,126", race="Homme", adds={{7, "Haradrims 104K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "Men of Dor-en-Ernil", 700}, {Rewards.CGONDOR_TOKEN, 4}}, frame="hokhir.tga", addlinked=true},	
			{id=1022, name="Anb\195\186rz, Wielder of Men", subname="anbrz", questname="anburzwielderofmen", loc="Randomly among:", size=3, level=103, difficulty=Difficulty.NEMESIS, moral="534,733", race="half-troll", adds={}, rewards={{Rewards.CGONDOR_TOKEN, 5}, {Rewards.DORENERNIL_REPUTATION_ITEM, 1}}, frame="anburz.tga", enemyType=2, note="Reputation needed: Dor-en-Ernil - Acquaintance\nNeed completion of the quest: Blood for blood", pnj="Erchar (Linhir)"},
			{id=1024, name="Keterang, Master of Spirits", subname="keterang", questname="keterangmasterofspirits", loc="Randomly among:", size=3, level=103, difficulty=Difficulty.NEMESIS, moral="668,466", race="Hill-man", adds={}, rewards={{Rewards.CGONDOR_TOKEN, 5}, {Rewards.DORENERNIL_REPUTATION_ITEM, 1}}, frame="keterang.tga", enemyType=2, note="Reputation needed: Dor-en-Ernil - Ally\nNeed completion of the quest: Blood for blood", pnj="Erchar (Linhir)"},				
			{id=1023, name="Ripper, Bane of the Prince's Lands", subname="ripper", questname="ripperbaneoftheprinceslands", loc="Randomly among:", size=6, level=103, difficulty=Difficulty.NEMESIS, moral="2,506,747", race="Drake", adds={}, rewards={{Rewards.CGONDOR_TOKEN, 5}, {Rewards.DORENERNIL_REPUTATION_ITEM, 1}}, frame="percegriffe.tga", enemyType=2, note="Reputation needed: Dor-en-Ernil - Friend\nNeed completion of the quest: Blood for blood", pnj="Herion (Linhir)"},
		}},
		{name="Lebennin", rovingThreatData={loc={{c="84.1S, 41.7W"},{c="79.0S, 33.6W"},{c="78.5S, 35.5W"},{c="85.6S, 44.8W"},{c="84.6S, 43.9W"},{c="80.8S, 40.8W"},{c="83.5S, 44.2W"}}}, wads={
			{id=83, name="Darik", questname="darik", loc="82.9S, 43.4W", closedPOI="Linhir", size=1, level=102, difficulty=Difficulty.ELITE, moral="109,886", race="Man", adds={}, rewards={{Rewards.REPUTATION, "Men of Lebennin", 700}, {Rewards.CGONDOR_TOKEN, 2}}, frame="darik.tga"},
			{id=84, name="Shataz", questname="shataz", loc="83.0S, 36.0W", closedPOI="Pelargir", size=3, level=102, difficulty=Difficulty.GRAND_ELITE, moral="226,081", race="Half-troll", adds={{4, "half-trolls 102K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "Men of Lebennin", 700}, {Rewards.CGONDOR_TOKEN, 3}}, frame="shataz.tga", addlinked=true},	
			{id=85, name="Vilosh", questname="vilosh", loc="83.0S, 36.0W", closedPOI="Pelargir", size=6, level=102, difficulty=Difficulty.GRAND_ELITE, moral="417,971",  race="Mounted human", adds={{4, "Mounted Haradrims 94K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "Men of Lebennin", 700}, {Rewards.CGONDOR_TOKEN, 4}}, frame="vilosh.tga", addlinked=true},
			{id=1025, name="Luruyak, Terror of Harad", subname="luruyak", questname="luruyakterrorofharad", loc="Randomly among:", size=3, level=103, difficulty=Difficulty.NEMESIS, moral="668,466",  race="Haradrim", adds={}, rewards={{Rewards.CGONDOR_TOKEN, 5}, {Rewards.LEBENNIN_REPUTATION_ITEM, 1}},frame="luruyak.tga", enemyType=2, note="Reputation needed:\nLebennin - Acquaintance", pnj="Nimithil (Ost Anglebed)"},
			{id=1026, name="Abrakh\195\180r, Chosen of the Scourge", subname="abrakhr", questname="abrakhrchosenofthescourge", loc="Randomly among:", size=6, level=103, difficulty=Difficulty.NEMESIS, moral="2,005,398", race="Angmarin", adds={}, rewards={{Rewards.CGONDOR_TOKEN, 5}, {Rewards.LEBENNIN_REPUTATION_ITEM, 1}}, frame="abrakhor.tga", enemyType=2, note="Reputation needed:\nLebennin - Friend", pnj="Milonnen (Ost Anglebed)"},
			{id=1027, name="Render, Shadow of the White Mountains", subname="render", questname="rendershadowofthewhitemountains", loc="Randomly among:", size=6, level=103, difficulty=Difficulty.NEMESIS, moral="2,005,398",  race="Drake", adds={}, rewards={{Rewards.CGONDOR_TOKEN, 5}, {Rewards.LEBENNIN_REPUTATION_ITEM, 1}}, frame="laceradon.tga", enemyType=2, note="Reputation needed:\nLebennin - Ally", pnj="Milonnen (Ost Anglebed)"},
		}},
		--{id=32, name="Pelargir"}, -- TBC
		{id=290, name="Master - Central Gondor", showme=false, wads={
			{id=2007, name="Treasure of Central Gondor", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=90, poi={ { id=1, c="71.4S, 53.5W", l="Ringlo Vale" }, { id=2, c="74.1S, 51.4W", l="Ringlo Vale" }, { id=3, c="76.3S, 49.6W", l="Ringlo Vale" }, { id=4, c="71.3S, 47.4W", l="Ringlo Vale" }, { id=5, c="78.9S, 47.3W", l="Dor-en-Ernil" }, { id=6, c="77.8S, 45.9W", l="Dor-en-Ernil" }, { id=7, c="86.7S, 50.1W", l="Dor-en-Ernil" }, { id=8, c="81.3S, 53.0W", l="Dor-en-Ernil" }, { id=9, c="84.4S, 52.2W", l="Dor-en-Ernil" }, { id=10, c="79.7S, 42.7W", l="Lebennin" }, { id=11, c="76.6S, 44.0W", l="Lebennin" }, { id=12, c="75.7S, 41.4W", l="Lebennin" }, { id=13, c="77.5S, 36.4W", l="Lebennin" }, { id=14, c="78.4S, 33.0W", l="Lebennin" }, { id=15, c="85.6S, 43.2W", l="Lebennin" }, { id=16, c="85.7S, 40.1W", l="Lebennin" }, { id=17, c="84.3S, 34.9W", l="Pelargir: on a small platform on the water" }, { id=18, c="83.0S, 33.8W", l="Pelargir: Between two columns" }, { id=19, c="84.5S, 33.8W", l="Pelargir: In the southwest corner of the central island" }, { id=20, m={x=255, y=151}, c="83.7S, 31.1", l="Pelargir: In the abandoned district" } }, rewards={{Rewards.TURBINE, 10}, {Rewards.CGONDOR_TOKEN, 18}, {Rewards.TITLE, "	Treasure Seeker of Central Gondor"}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Pelargir", 900}}, tag="tag_vault.tga"}
		}},	
	}},
	{name="Western Gondor", map="4.jpg", region=3, areas={
		{name="Blackroot Vale", wads={
			{id=70, name="Hemokh", questname="hemokh", loc="59.1S, 65.7W", closedPOI="Hill of Erech", size=6, level=96, difficulty=Difficulty.ELITE, moral="355,747", race="Shade", adds={{3 , "warriors 80K", Difficulty.ELITE},{2 , "archers 80K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "Dol Amroth", 700}, {Rewards.AMROTH_TOKEN, 4}}, frame="hemokh.tga"},
			{id=71, name="Old Br\195\180g", questname="oldbrg", loc="59.6S, 66.7W", closedPOI="Hill of Erech", size=3, level=96, difficulty=Difficulty.ELITE, moral="77,860", race="Bear", adds={{2 , "bears 35K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "Dol Amroth", 700}, {Rewards.AMROTH_TOKEN, 3}}, frame="oldbrog.tga"}
		}},
		{name="Lamedon", wads={
			{id=72, name="Corugwen the Cunning", questname="corugwenthecunning", loc="61.8S, 57.7W", closedPOI="Tathrendalf", size=6, level=98, difficulty=Difficulty.GRAND_ELITE, moral="182,815", race="Human", adds={{2 , "bandits 36K", Difficulty.SIGNATURE},{3 , "ruffians 18K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "Dol Amroth", 500}, {Rewards.AMROTH_TOKEN, 4}}, frame="corugwen.tga"},	
			{id=73, name="Old Snapper", questname="oldsnapper", loc="64.8S, 55.3W", closedPOI="Calembel", size=3, level=98, difficulty=Difficulty.ELITE, moral="83,089", race="Dread Turtle", adds={}, rewards={{Rewards.REPUTATION, "Dol Amroth", 500}, {Rewards.AMROTH_TOKEN, 3}}, frame="snapper.tga"},
			{id=74, name="The Great Bull", questname="thegreatbull", loc="66.7S, 57.7W", closedPOI="Calembel", size=3, level=98, difficulty=Difficulty.ELITE, moral="80,844", race="Bull", adds={{2 , "bulls 34K", Difficulty.SIGNATURE},{2 , "bulls 8K", Difficulty.FAIBLE}}, rewards={{Rewards.REPUTATION, "Dol Amroth", 500}, {Rewards.AMROTH_TOKEN, 3}}, frame="grandtaureau.tga"}	
		}},
		{name="Havens of Belfalas", wads={
			{id=75, name="Skulkmire", questname="skulkmire", loc="73.5S, 59.9W", closedPOI="Tadrent", size=3, level=98, difficulty=Difficulty.ELITE, moral="99,707", race="Worm", adds={{3 , "worms 18K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "Dol Amroth", 700}, {Rewards.AMROTH_TOKEN, 3}},  frame="skulkmire.tga"},
			{id=76, name="Ad\195\174rjan the Brute", questname="adrjanthebrute", loc="77.4S, 72.1W", closedPOI="Dol Amroth", size=1, level=99, difficulty=Difficulty.ELITE, moral="101,437", race="Human", adds={}, rewards={{Rewards.REPUTATION, "Dol Amroth", 500}, {Rewards.AMROTH_TOKEN, 2}}, frame="adirjan.tga"}
		}},
		{name="The Dead Marshes", map="5.jpg", wads={
			{id=77, name="Sorz\195\187r the Lone Hunter", questname="thelonehunter", loc="27.5S, 11.4W", size=1, level=100, difficulty=Difficulty.SIGNATURE, moral="19,104", race="Orc", adds={}, rewards={{Rewards.AMROTH_TOKEN, 2}}, frame="sorzur.tga"},
			{id=78, name="B\195\187rgoth The Taskmaster", questname="thetaskmaster", loc="27.7S, 17.8W", size=3, level=100, difficulty=Difficulty.NORMAL, moral="23,388", race="Orc", adds={{4, "orcs 19K", Difficulty.NORMAL}}, rewards={{Rewards.AMROTH_TOKEN, 3}}, frame="burgoth.tga"},	
		}},		
		{mapid=4, name="Master - Western Gondor", showme=false, pnj="Aelnir (Dol Amroth)", rovingThreatData={pnj="Aelnir (Dol Amroth)", loc={{c="59.9S, 70.8W", l="Blackroot Vale"},{c="60.2S, 64.3W", l="Blackroot Vale"},{c="62.7S, 61.0W", l="Lamedon"},{c="62.2S, 55.8W", l="Lamedon"},{c="65.7S, 53.7W", l="Lamedon"},{c="71.2S, 60.7W", l="Lamedon"},{c="71.2S, 64.6W", l="Havens of Belfalas"},{c="77.0S, 68.7W", l="Havens of Belfalas"},{c="78.7S, 69.0W", l="Havens of Belfalas"},{c="76.9S, 73.1W", l="Havens of Belfalas"}}}, wads={
			{id=1016, name="Haldalona, the Vile Darkwater", subname="haldalona",  questname="haldalonatheviledarkwater", loc="Randomly among:", size=3, level=102, difficulty=Difficulty.NEMESIS, moral="771,877", race="Darkwater", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="haldalona.tga", enemyType=2},
			{id=1018, name="Skorkaz, the Callous Dead", subname="skorkaz", questname="skorkazthecallousdead", loc="Randomly among:", size=3, level=102, difficulty=Difficulty.NEMESIS, moral="771,877", race="Shade", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}},  frame=nil, enemyType=2},
			{id=1014, name="Amorchant, the Winged Death", subname="amorchant",  questname="amorchantthewingeddeath", loc="Randomly among:", size=6, level=102, difficulty=Difficulty.NEMESIS, moral="1,119,212", race="Drake", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 3}}, frame="amorchant.tga", enemyType=2},
			{id=1015, name="Gundlag the Death Troll", subname="gundlag",  questname="gundlagthedeathtroll", loc="Randomly among:", size=6, level=102, difficulty=Difficulty.NEMESIS, moral="1,119,212", race="Troll", adds={}, rewards={ {Rewards.MARQUE_DONATEUR, 3}}, frame="gundlag.tga", enemyType=2},
			{id=1017, name="Mota, the Umbarrim Scourge", subname="mota", questname="motatheumbarrimscourge", loc="Randomly among:", size=6, level=102, difficulty=Difficulty.NEMESIS, moral="1,119,212", race="Angmarim", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 3}}, frame=nil, enemyType=2},
			{id=2006, name="Gondorian Treasure Cache", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=90, poi={ { id=1, c="61.8S, 69.5W", l="Blackroot Vale" }, { id=2, c="59.2S, 68.5W", l="Blackroot Vale" }, { id=3, c="60.6S, 66.1W", l="Blackroot Vale" }, { id=4, c="60.1S, 66.9W", l="Blackroot Vale" }, { id=5, c="60.6S, 64.1W", l="Blackroot Vale" }, { id=6, c="57.2S, 62.5W", l="Blackroot Vale" }, { id=7, c="62.5S, 60.6W", l="Lamedon" }, { id=8, c="65.2S, 61.0W", l="Lamedon" }, { id=9, c="65.6S, 59.4W", l="Lamedon" }, { id=10, c="67.4S, 54.5W", l="Lamedon" }, { id=11, c="72.9S, 57.5W", l="Lamedon" }, { id=12,  c="60.5S, 57.7W", l="Lamedon" }, { id=13, c="75.4S, 59.4W", l="Havens of Belfalas" }, { id=14, c="76.5S, 62.8W", l="Havens of Belfalas" }, { id=15, c="73.6S, 64.8W", l="Havens of Belfalas" }, { id=16, c="77.2S, 69.4W", l="Havens of Belfalas" }, { id=17, c="78.9S, 69.4W", l="Havens of Belfalas" }, { id=18, c="76.5S, 73.6W", l="Havens of Belfalas" } }, rewards={{Rewards.TURBINE, 10}, {Rewards.AMROTH_TOKEN, 18}, {Rewards.TITLE, "Treasure Seeker of West Gondor"}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Dol Amroth", 900}}, tag="tag_vault.tga"}
		}}
	}},
	{name="West Rohan", map="3.jpg", region=2, areas = {
		{name="Westfold", wads={
			{id=50, name="Bethan, Priestess of Isengard", questname="bethanpriestessofisengard", loc="57.1S, 88.6W", size=12, level=95, difficulty=Difficulty.NEMESIS_SUPREME, moral="977,175",race="Human", adds={{4, "mounted orcs 111K", Difficulty.GRAND_ELITE}, {2, "spiders 72K", Difficulty.ELITE}, {3, "spiders 16K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "The Helmingas", 900}, {Rewards.WESTMNET_TOKEN, 2}},frame="priestessbethan.tga", addlinked=true},
			{id=51, name="Bosnauk", questname="bosnaukandtherovingtrolls", loc="57.5S, 82.3W", size=12, level=95, difficulty=Difficulty.ELITE, moral="73,288", race="Troll", adds={{5, "Trolls 32K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "The Helmingas", 900}, {Rewards.WESTMNET_TOKEN, 2}}, frame="bosnauk.tga"},
			{id=52, name="Kr\195\187p\195\187 and the Roving Orcs", questname="krpandtherovingorcs", loc="59.1S, 78.2W", size=6, level=95, difficulty=Difficulty.GRAND_ELITE, moral="161,250", race="Orc", adds={{"3", "orcs 32K", Difficulty.SIGNATURE}, {"3", "orcs 16K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "The Helmingas", 900},{Rewards.WESTMNET_TOKEN, 2}},  frame="krupu.tga"},
			{id=53, name="Patarshan", questname="patarshan", loc="63.0S, 78.5W", size=3, level=95, difficulty=Difficulty.ELITE, moral="73,288", race="Uruk", adds={{5, "slaves 16K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "The Helmingas", 700}, {Rewards.WESTMNET_TOKEN, 2}},frame="patarshan.tga"},
			{id=54, name="Voraut", questname="voraut", loc="54.3S, 88.0W", size=1, level=95, difficulty=Difficulty.SIGNATURE, moral="32,250", race="Warg", adds={{2, "wargs 16K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "The Helmingas", 500}, {Rewards.WESTMNET_TOKEN, 2}}, frame="voraut.tga"}		
		}},
		{name="Stonedeans", wads={
			{id=55, name="Inras", questname="inras", loc="56.0S, 78.5W", closedPOI="Madh-Fushaum", size=1, level=92, difficulty=Difficulty.SIGNATURE, moral="29,543", race="Wolf", adds={{3, "wolf 14K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "The Helmingas", 700}, {Rewards.WESTMNET_TOKEN, 2}}, frame="inras.tga", spawnShared="Rog-Votak"},
			{id=56, name="Geralht", questname="geralht", loc="53.7S, 76.2W", closedPOI="Madh-Fushaum", size=1, level=92, difficulty=Difficulty.ELITE, moral="66,471", race="Human", adds={{4, "archers 7K", Difficulty.FAIBLE}}, rewards={{Rewards.REPUTATION, "The Helmingas", 700}, {Rewards.WESTMNET_TOKEN, 2}}, frame="geralht.tga", spawnShared="Macsen"},
			{id=57, name="Macsen", questname="macsen", loc="53.7S, 76.2W", closedPOI="Madh-Fushaum", size=12, level=92, difficulty=Difficulty.NEMESIS_SUPREME, moral="886,275",race="Humain", adds={{3, "archers 292K", Difficulty.NEMESIS}, {4, "wariors 146K", Difficulty.GRAND_ELITE}}, rewards={{Rewards.REPUTATION, "The Helmingas", 1200}, {Rewards.WESTMNET_TOKEN, 2}}, frame="macsen.tga", spawnShared="Geralht"},
			{id=58, name="Neivion", questname="neivion", loc="49.7S, 76.8W", closedPOI="Brockbridge", size=6, level=92, difficulty=Difficulty.NEMESIS, moral="295,425", race="Humain", adds={{3, "archers 146", Difficulty.GRAND_ELITE}, {2, "wariors 65K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "The Helmingas", 900}, {Rewards.WESTMNET_TOKEN, 2}}, frame="neivion.tga", spawnShared="Ognir"},
			{id=59, name="Ognir", questname="ognir", loc="49.7S, 76.8W", closedPOI="Brockbridge", size=1, level=92, difficulty=Difficulty.ELITE, moral="66,471", race="Troll", adds={}, rewards={{Rewards.REPUTATION, "The Helmingas", 700}, {Rewards.WESTMNET_TOKEN, 2}}, frame="ognir.tga", spawnShared="Neivion"},
			{id=60, name="Rog-Votak", questname="rogvotak", loc="56.0S, 78.5W", closedPOI="Madh-Fushaum", size=6, level=92, difficulty=Difficulty.NEMESIS, moral="295,425", race="Uruk", adds={{2, "uruks 146K", Difficulty.GRAND_ELITE}, {4, "archers 28K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "The Helmingas", 900}, {Rewards.WESTMNET_TOKEN, 2}}, frame="rogvotak.tga", spawnShared="Inras"},	
		}},
		{name="Broadacres", wads={
			{id=61, name="Cledwun - Dunlending War-leader", questname="cledwundunlendingwarleader", loc="48.1S, 72.3W", closedPOI="Stoke", size=6, level=90, difficulty=Difficulty.GRAND_ELITE, moral="206,419", race="Mounted human", adds={{2 , "Mounted berserkers 26K", Difficulty.SIGNATURE}, {2 , "Mounted warriors 13K", Difficulty.ELITE}, {2 , "Mounted archers 13K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "The Eorlingas", 900}, {Rewards.WESTMNET_TOKEN, 2}}, frame="cledwun.tga"},
		}},
		{name="Kingstead", wads={
			{id=62, name="Glendower", questname="glendower", loc="58.7S, 72.2W", size=6, level=87, difficulty=Difficulty.GRAND_ELITE, moral="122,463", race="mounted human", adds={{2 , "mounted warriors 54K", Difficulty.ELITE}, {2 , "mounted archers 54K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "The Eorlingas", 700}, {Rewards.WESTMNET_TOKEN, 2}}, frame="glendower.tga"},
			{id=63, name="Ora", questname="ora", loc="61.5S, 65.2W", size=3, level=87, difficulty=Difficulty.GRAND_ELITE, moral="122,463", race="Troll", adds={{3 , "half-orcs 24K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "The Eorlingas", 700}, {Rewards.WESTMNET_TOKEN, 2}}, frame="ora.tga"},	
			{id=64, name="N\195\187d\195\174t", questname="ndt", loc="54.3S, 66.2W", size=6, level=86, difficulty=Difficulty.GRAND_ELITE, moral="117,413", race="Mounted Uruk", adds={{2 , "mounted bersekers 52K", Difficulty.ELITE}, {2 , "Mounted defiler 24K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "The Eorlingas", 700}, {Rewards.WESTMNET_TOKEN, 2}}, frame="nudit.tga"}
		}},
		{name="Eastfold", wads={
			{id=65, name="Darkheart", questname="darkheart", loc="68.7S, 52.6W", size=1, level=88, difficulty=Difficulty.SIGNATURE, moral="25,503", race="Huorn", adds={{2 , "huorns 13K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "The Eorlingas", 700}, {Rewards.WESTMNET_TOKEN, 2}}, frame="coeurnoir.tga"},	
			{id=66, name="B\195\187rzash", questname="brzash", loc="66.0S, 58.3W", closedPOI="Fenmarch", size=6, level=88, difficulty=Difficulty.ELITE, moral="56,813", race="Orc", adds={{3 , "archers 12K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "The Eorlingas", 700}, {Rewards.WESTMNET_TOKEN, 2}}, frame="burzash.tga"},		
			{id=67, name="Snapfang", questname="snapfang", loc="64.2S, 62.2W", size=1, level=88, difficulty=Difficulty.SIGNATURE, moral="24,998", race="Barghest", adds={{2 , "barghest 12K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "The Eorlingas", 700}, {Rewards.WESTMNET_TOKEN, 2}}, frame="claquecroc.tga"},		
			{id=68, name="Scion of the Great Boar", questname="scionofthegreatboar", loc="70.4S, 60.3W", size=12, level=88, difficulty=Difficulty.NEMESIS, moral="262,500", race="Boar", adds={{5 , "boars 262K", Difficulty.FAIBLE}}, rewards={{Rewards.REPUTATION, "The Eorlingas", 700}, {Rewards.WESTMNET_TOKEN, 2}}, frame="rejetondugrandsanglier.tga"},			
			{id=69, name="Felljaw", questname="felljaw", loc="69.6S, 62.5W", closedPOI="Aldburg", size=6, level=88, difficulty=Difficulty.ELITE, moral="56,813", race="Bear", adds={{3 , "bears 12K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "The Eorlingas", 700}, {Rewards.WESTMNET_TOKEN, 2}}, frame="vilegueule.tga"},	
		}}
	}},	
	{name="Wildermore", map="2.jpg", region=2, areas = {
		{name="Writhendowns", wads={
			{id=18, name="Foulwing",  questname="foulwing", loc="36.3S, 58.1W", closedPOI="Scylfig", size=1, level=85, difficulty=Difficulty.SIGNATURE, moral="22,028", race="Hendroval", adds={{4, "Hendroval 5K", Difficulty.FAIBLE}}, rewards={{Rewards.REPUTATION, "People of Wildermore", 500},  {Rewards.WILDERMORE_TOKEN, 3}}, frame="ailevile.tga"},
			{id=24, name="Balcharan", questname="balcharan", loc="35.0S, 60.9W", closedPOI="Scylfig", size=3, level=85, difficulty=Difficulty.ELITE, moral="50,063", race="Shade", adds={{3, "Daeguls 5K", Difficulty.FAIBLE}}, rewards={{Rewards.REPUTATION, "People of Wildermore", 500}, {Rewards.WILDERMORE_TOKEN, 3}}, frame="balcharan.tga"},
			{id=27, name="Voz", questname="voz", loc="38.0S, 58.3W", closedPOI="Fushaum-dor\195\161m", size=6, level=85, difficulty=Difficulty.NEMESIS, moral="224,725", race="Mounted Ork", adds={{2, "Mounted archers 50K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "People of Wildermore", 700}, {Rewards.WILDERMORE_TOKEN, 3}}, frame="voz.tga"}	
		}},
		{name="High Knolls", wads={
			{id=20, name="Karkas", questname="karkas", loc="30.9S, 63.0W", closedPOI="Grimnesberg", size=1, level=85, difficulty=Difficulty.SIGNATURE, moral="24,720", race="Troll", adds={}, rewards={{Rewards.REPUTATION, "People of Wildermore", 500}, {Rewards.WILDERMORE_TOKEN, 3}}, frame="karkas.tga"},
			{id=22, name="High Knolls Blizzard", questname="highknollsblizzard", loc="34.4S, 67.3W", size=1, level=85, difficulty=Difficulty.SIGNATURE, moral="24,475", race="Grim", adds={{3, "Grims 5K", Difficulty.FAIBLE}}, rewards={{Rewards.REPUTATION, "People of Wildermore", 500}, {Rewards.WILDERMORE_TOKEN, 3}}, frame="blizzard.tga"},
		}},
		{name="Fallows", wads={
			{id=21, name="Shum", questname="shum", loc="42.9S, 57.4W", closedPOI="Farm of G\195\161rferth", size=1, level=85, difficulty=Difficulty.SIGNATURE, moral="22,250", race="Warg", adds={{2, "wargs 5K", Difficulty.FAIBLE}}, rewards={{Rewards.REPUTATION, "People of Wildermore", 500}, {Rewards.WILDERMORE_TOKEN, 3}}, frame="shum.tga"},
			{id=23, name="Arataus", questname="arataus", loc="41.8S, 54.5W", closedPOI="Farm of G\195\161rsig", size=3, level=85, difficulty=Difficulty.GRAND_ELITE, moral="123,375", race="Warg rider", adds={{4, "warg-riders 11K", }}, rewards={{Rewards.REPUTATION, "People of Wildermore", 500}, {Rewards.WILDERMORE_TOKEN, 3}}, frame="arataus.tga", spawnShared="Shaguk"},
			{id=28, name="Zovarr", questname="zovarr", loc="43.0S, 61.1W", closedPOI="Farm of G\195\161rnoth", size=6, level=85, difficulty=Difficulty.NEMESIS, moral="224,725", race="Uruk", adds={{5, "archers 11K", Difficulty.NORMAL},{1, "uruk 50K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "People of Wildermore", 700}, {Rewards.WILDERMORE_TOKEN, 3}}, frame="zovarr.tga"},
			{id=30, name="Shaguk", questname="shaguk", loc="41.9S, 56.2W", closedPOI="Farm of G\195\161rsig", size=12, level=85, difficulty=Difficulty.NEMESIS_SUPREME, moral="674,175", race="Mounted Uruk", adds={{4, "riders 111K", Difficulty.GRAND_ELITE}}, rewards={{Rewards.REPUTATION, "People of Wildermore", 900}, {Rewards.WILDERMORE_TOKEN, 3}}, frame="shaguk.tga", spawnShared="Arataus", addlinked=true},	
		}},
		{name="Whitshaws", wads={
			{id=19, name="G\195\174mtog", questname="gmtog", loc="37.2S, 63.0W", closedPOI="Eastern edge of the Whitshaws", size=1, level=85, difficulty=Difficulty.SIGNATURE, moral="22,473",race="Wolf", adds={{3, "wolfs 11K", Difficulty.NORMAL}}, rewards={{Rewards.REPUTATION, "People of Wildermore", 500}, {Rewards.WILDERMORE_TOKEN, 3}},frame="gimtog.tga"},
			{id=29, name="Conog", questname="conog", loc="41.0S, 63.7W", closedPOI="Southern edge of the Whitshaws", size=12, level=85, difficulty=Difficulty.NEMESIS_SUPREME, moral="674,175",race="Mounted Orc", adds={{2, "Mounted Orc 12K", Difficulty.NORMAL},{3, "archers 24K", Difficulty.SIGNATURE}}, rewards={{Rewards.REPUTATION, "People of Wildermore", 900}, {Rewards.WILDERMORE_TOKEN, 3}}, frame="conog.tga", addlinked=true},	
		}},
		{name="Balewood", wads={
			{id=25, name="Varg", questname="varg", loc="34.3S, 69.8W", size=3, level=85, difficulty=Difficulty.GRAND_ELITE, moral="140,895", race="Uruk", adds={{3, "Archers 18K",Difficulty.SIGNATURE},{2, "protectors 54K", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "People of Wildermore", 500}, {Rewards.WILDERMORE_TOKEN, 3}}, frame="varg.tga"},
			{id=26, name="Rottenheart",questname="rottenheart", loc="34.7S, 71.6W", size=6, level=85, difficulty=Difficulty.NEMESIS, moral="422,685", race=ToUTF8("Huorn"), adds={{3, "wood-trolls (90K)", Difficulty.GRAND_ELITE},{2, "ancient wood-trolls (52K)", Difficulty.ELITE}}, rewards={{Rewards.REPUTATION, "People of Wildermore", 900}, {Rewards.WILDERMORE_TOKEN, 3}}, frame="coeurmalsain.tga"},
		}}
	}},
	{name="East Rohan", map="1.jpg", region=2, areas = {
		{name="The Wold", wads={
			{id=1, name="Cinder", questname="cinder", loc="39.3S, 54.1W", closedPOI="Venomtongue,", size=1, level=77, difficulty=Difficulty.SIGNATURE, moral="19,558", race="Salamander - Dragon", adds={{2, "salamander 5K", Difficulty.FAIBLE}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="cendre.tga"},
			{id=2, name="Hanrun", questname="hanrun", loc="44.1S, 50.3W", closedPOI="South of Feldburg", size=1, level=77, difficulty=Difficulty.SIGNATURE, moral="19,558", race="Warg", adds={{2, "wargs 4K", Difficulty.FAIBLE}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="hanrun.tga"},
			{id=3, name="Urush", questname="urush", loc="40.9S, 47.4W", closedPOI="Cracabor", size=1, level=77, difficulty=Difficulty.SIGNATURE, moral="19,558", race="Mounted Easterling", adds={{2, "Riders 9K", Difficulty.NORMAL}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="urush.tga"},
			{id=4, name="Bughrakh", questname="bughrakh", loc="44.1S, 48.2W", closedPOI="The woods east of Floodwend", size=3, level=77, difficulty=Difficulty.GRAND_ELITE, moral="97,792", race="Orc", adds={{4, "Archers 4K", Difficulty.FAIBLE}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="bughrakh.tga"},
			
		}},
		{name="Norcrofts", wads={
			{id=5, name="Dah\195\161mab", questname="dahamab", loc="45.2S, 57.5W", closedPOI="Cliving", size=1, level=79, difficulty=Difficulty.SIGNATURE, moral="20,700", race="Mounted Uruk", adds={{3, "Mounted Uruks 10K",Difficulty.NORMAL}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="dahamab.tga"},
			{id=6, name="Sk\195\186tog", questname="sktog", loc="50.1S, 55.5W", closedPOI="Domaine printanier", size=1, level=79, difficulty=Difficulty.ELITE, moral="47,041", race="Warg-riders", adds={{4, "Mounted uruks 10K",Difficulty.NORMAL}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="skutog.tga"},
			{id=7, name="Swertripeur", questname="swertrper", loc="53.6S, 54.2W", closedPOI="South of Elthengels", size=1, level=79, difficulty=Difficulty.ELITE, moral="37,633", race="Lathbear", adds={{2, "Lathbear 10K", Difficulty.NORMAL}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="swertriper.tga"},
			{id=8, name="Haglob", questname="haglob", loc="45.9S, 45.3W", closedPOI="Northwest of Elthengels", size=3, level=79, difficulty=Difficulty.GRAND_ELITE, moral="126,684", race="Troll",adds={}, rewards={{Rewards.ROHAN_TOKEN, 3}},  frame="haglob.tga"},	
		}},	
		{name="Entwash Vale", wads ={
			{id=9, name="Besengan", questname="besengan", loc="50.2S, 61.7W", closedPOI="Maustarz", size=1, level=80, difficulty=Difficulty.NORMAL, moral="9,216", race="Dragon", adds={{2, "Draks 5K", Difficulty.FAIBLE}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="besengan.tga", spawnShared="D\195\162l, Fearrhorn and Urgai"},
			{id=10, name="M\195\162thum", questname="mthum", loc="43.7S, 64.9W", closedPOI="North of Eaworth", size=1, level=80, difficulty=Difficulty.SIGNATURE, moral="13,326", race="Warg-rider", adds={{3, "warg-riders 5K", Difficulty.FAIBLE}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="mathum.tga", spawnShared="Mirz"},
			{id=11, name="D\195\162l", questname="dl", loc="50.6S, 61.3W", closedPOI="Maustarz", size=3, level=80, difficulty=Difficulty.GRAND_ELITE, moral="111,581", race="Mounted uruks", adds={{1, "Mounted archers 49K", Difficulty.ELITE},{2, "Mounted uruks 40K", Difficulty.ELITE}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="dal.tga", spawnShared="Besengan, Fearrhorn and Urgai"},
			{id=12, name="Fearrhorn", questname="fearrhorn", loc="50.5S, 62.0W", closedPOI="Maustarz", size=3, level=80, difficulty=Difficulty.GRAND_ELITE, moral="129,623", race="Auroch", adds={{4, "Aurochs 10K", Difficulty.NORMAL},{3, "Auroch 5K", Difficulty.FAIBLE}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="corneterrible.tga", spawnShared="Besengan, D\195\162l and Urgai"},
			{id=13, name="Mirz", questname="mirz", loc="44.8S, 63.0W", closedPOI="Southeast of Thornhope", size=3, level=81, difficulty=Difficulty.ELITE, moral="51,849", race="Half-orc", adds={{2, "wargs 22K", Difficulty.SIGNATURE},{2, "Archers 11K", Difficulty.NORMAL},{2, "Mounted half-orcs", Difficulty.NORMAL}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="mirz.tga"},
			{id=14, name="Urgai", questname="urgai", loc="50.6S, 62.2W", closedPOI="Maustazg", size=6, level=81, difficulty=Difficulty.NEMESIS, moral="223,161", race="Black Uruk of Mordor", adds={{1, "Mounted uruk 41K", Difficulty.ELITE},{1, "Mounted archers 41K", Difficulty.ELITE}}, addlinked=true, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="urgai.tga", spawnShared="Besengan, D\195\162l and Fearrhorn"},
		}},
		{name="Sutcrofts", wads={
			{id=15, name="Gundul", questname="crabanmastergundul", loc="56.6S, 60.6W", closedPOI="Southeast of Garsfeld", size=3, level=85, difficulty=Difficulty.GRAND_ELITE, moral="121,516", race="Half-orc", adds={{8, "Crows 12K", Difficulty.NORMAL}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="gundul.tga", },
			{id=16, name="Kramp", questname="kramp", loc="60.3S, 60.1W", closedPOI="Fields of the Sutcrofts", size=6, level=85, difficulty=Difficulty.GRAND_ELITE, moral="124,100", race="Warg-rider", adds={{4, "Warg-riders 25K", Difficulty.SIGNATURE}}, rewards={{Rewards.ROHAN_TOKEN, 3}}, frame="kramp.tga", },
			{id=17, name="Bugud", questname="warmasterbugud", loc="59.8S, 57.8W", closedPOI="Fields of the Sutcrofts", size=12, level=85, difficulty=Difficulty.NEMESIS_SUPREME, moral="783,383",race="Mounted orc", adds={{3, "Mounted orcs 25K", Difficulty.SIGNATURE},{2, "wargs 31K", Difficulty.ELITE}}, rewards={{Rewards.ROHAN_TOKEN, 3},{Rewards.SILVER_SUTCROFTS_PRESENT, 1}}, frame="bugud.tga", addlinked=true},
		}}
	}},
	{name="Southern Mirkwood", map="11.jpg", region=2, areas={
		{name="Southern Mirkwood", showme=false, rovingThreatData={loc={{c="13.4S, 59.0W"},{c="19.3S, 46.7W"},{c="18.2S, 48.7W"},{c="12.8S, 43.7W"},{c="16.1S, 53.5W"}}, pnj="GellFriendel (Ost Galadh)"},wads={ 
			{id=1032, name="Helchurth, the Eternal Shadow", subname="helchurth", questname="helchurththeeternalshadow", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="849,065", race="Wraith", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="helchurth.tga", enemyType=2},
			{id=1033, name="Thorang, the Spirit Armour", subname="thorang", questname="thorangthespiritarmour", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="849,065", race="Shade", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="thorang.tga", enemyType=2},	
			{id=1031, name="Ghamgur, the Giant Dread", subname="ghmgur",questname="ghmgurthegiantdread", loc="Randomly among:", size=6, level=100, difficulty=Difficulty.NEMESIS, moral="1,528,317", race="Troll", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 3}}, frame="ghamgur.tga", enemyType=2},
			{id=1034, name="Woe-weaver, the Silent Fear", subname="woeweaver", questname="woeweaverthesilentfear", loc="Randomly among:", size=6, level=100, difficulty=Difficulty.NEMESIS, moral="1,528,317", race="Spider", adds={{10, "spiders 20K", Difficulty.NORMAL}}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="tisseuse.tga", enemyType=2},
			{id=2001, name="Treasure of Southern Mirkwood", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=90, poi={ { id=1, c="17.3S, 61.7W", l="At the ruined tower of Tirnhirion" }, { id=2, c="15.9S, 59.3W", l="Amongst The Wind Stones" }, { id=3, c="19.1S, 57.9W", l="Behind carved stones" }, { id=4, c="11.2S, 56.2W", l="In a ditch between the Dourstocks and Dannenglor" }, { id=5, c="12.4S, 54.6W", l="On a balcony in Dannenglor" }, { id=6, c="13.4S, 52.6W", l="Amongst the trees northwest of Ost Galadh" }, { id=7, c="8.7S, 51.8W", l="On a ledge in Gorogrod jutting out over the big hole" }, { id=8, c="12.2S, 45.4W", l="Atop a siege tower in Kufuzg" }, { id=9, c="14.8S, 41.7W", l="Left of the staircase at the entrance to the Dungeons of Dol Guldur" }, { id=10, c="16.4S, 42.5W", l="Behind a rock on the secret path to Dol Guldur" }, { id=11, c="19.3S, 43.6W", l="On a ledge east of the island in the Bleakmere" }, { id=12, c="19.5S, 48.5W", l="South of Sad Morangol" } }, rewards={{Rewards.TURBINE, 10}, {Rewards.MARQUE_DONATEUR, 5}, {Rewards.TITLE, "Treasure Seeker of Southern Mirkwood"}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Malledhrim", 900}}, tag="tag_vault.tga"}
		}}
	}},
	{name="Angmar", map="9.jpg", region=1, areas={
		{name="Angmar", showme=false, rovingThreatData={loc={{c="0.6N, 36.3W"},{c="4.8N, 34.5W"},{c="2.4N, 32.0W"},{c="0.8N, 28.7W"},{c="0.8N, 27.2W"},{c="0.6N, 20.8W"},{c="3.1N, 24.1W"},{c="5.8N, 23.4W"},{c="7.1N, 20.1W"},{c="8.6N, 28.5W"},{c="11.3N, 27.1W"}}, pnj="Cannakh (Aughaire)"},wads={ 
			{id=1004, name="Ashthrok, the Fire Seeker", subname="ashthrok", questname="ashthrokthefireseeker", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="771,877", race="Troll", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="ashthrok.tga", enemyType=2},
			{id=1005, name="Khruthakh, the Untiring", subname="khruthakh", questname="khruthakhtheuntiring", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="771,877", race="Shade", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}},  frame="khruthakh.tga", enemyType=2},
			{id=1006, name="Shakatrog, the Dreaded", subname="shakatrog", questname="shakatrogthedreaded", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="771,877", race="Troll", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="shakatrog.tga", enemyType=2},	
			{id=1007, name="Ulkharn, the Commander", subname="ulkharn", questname="ulkharnthecommander", loc="Randomly among:", size=6, level=100, difficulty=Difficulty.NEMESIS, moral="1,061,331", race="Nameless", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 3}}, frame="ulkharn.tga", enemyType=2},	
			{id=1008, name="V\195\169lnas, the Seer", subname="vlnas", questname="vlnastheseer", loc="Randomly among:", size=6, level=100, difficulty=Difficulty.NEMESIS, moral="1,061,331", race="Nameless", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 3}},  frame="velnas.tga", enemyType=2},	
			{id=1009, name="Epilogue: Amardam, the Ancient Evil", subname="amardam", questname="epilogueamardamtheancientevil", loc="Middle of lake Duvuinen", size=6, level=100, difficulty=Difficulty.NEMESIS, moral="1,061,331", race="Nameless", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 3}}, frame="amardam.tga", enemyType=2, note="You must have completed all 5 previous RT quests in order to do this Epilogue.", rovingThreatData={loc={{c="0.2N, 27.4W"}}}},
			{id=2005, name="Treasure of Angmar", target="TreasureCache", enemyType=3, frame="treasure.tga", questname="", size=1, level=90, poi={ { id=1, c="0.7S, 36.5W", l="At the far end of the Blade Beak canyon" }, { id=2, c="3.9N, 39.8W", l="Right behind Bloodwing in the Drake area" }, { id=3, c="6.3N, 37.9W", l="	At the top of Dun Covad by War-master Ranghash" }, { id=4, c="12.2N, 29.5W", l="Near the iron gate of Carn Dum" }, { id=5, c="12.1N, 27.3W", l="In Himbar, in a little alcove" }, { id=6, c="13.0N, 25.4W", l="In Bogbereth's nest" }, { id=7, c="9.6N, 22.9W", l="On the road to Minas Caul, in a ridge" }, { id=8, c="10.3N, 14.3W", l="After the Nurz Ghashu fault" }, { id=9, c="4.5N, 21.1W", l="In a corner at the end of the road" }, { id=10, c="1.6S, 23.2W", l="On a ridge above Krusle Lannan" }, { id=11, c="4.7N, 29.2W", l="Against a wall by Imlad Balchorth" }, { id=12, c="7.2N, 30.4W", l="On an island of Anglanthir, surrounded by deadly water" } }, rewards={{Rewards.TURBINE, 10}, {Rewards.MARQUE_DONATEUR, 5}, {Rewards.TITLE, "Treasure Seeker of Angmar"}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Council of the North", 900}}, tag="tag_vault.tga"},

		}}
	}},
	{name="Misty Mountains",  map="8.jpg", region=1, areas={
		{name="Misty Mountains", showme=false, rovingThreatData={loc={{c="25.4S, 0.1E"},{c="23.1S, 1.2E"},{c="31.1S, 3.3E"},{c="21.9S, 4.4E"},{c="22.1S, 7.6E"},{c="22.5S, 4.1E"},{c="23.6S, 7.2E"},{c="27.8S, 8.2E"}}, pnj="Ostas\195\164nt (S\195\187ri-Kyla)"},wads={ 
			{id=1001, name="Hrimdyr, the Beast King", subname="hrimdyr", questname="hrimdyrthebeastking", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="771,477", race="Snowbeast", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="hrimdyr.tga", enemyType=2},
			{id=1002, name="Krabakam, the Master Hunter", subname="krabakam", questname="krabakamthemasterhunter", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="771,477", race="Gauradan", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame=nil, enemyType=2},	
			{id=1000, name="Gr\195\180thurs, the Stone Giant", subname="grthurs", questname="grthursthestonegiant", loc="Randomly among:", size=6, level=100, difficulty=Difficulty.NEMESIS, moral="1,061,331", race="Giant", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 3}}, frame="grothurs.tga", enemyType=2},
			{id=1003, name="Sutmoth, the Ice Giant", subname="stmoth", questname="stmoththeicegiant", loc="Randomly among:", size=6, level=100, difficulty=Difficulty.NEMESIS, moral="1,061,331", race="Giant", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 3}}, frame="sutmoth.tga", enemyType=2},
			{id=2003, name="Treasure of the Misty Mountains", target="TreasureCache", enemyType=3, frame="treasure.tga", questname="", size=1, level=90, poi={ { id=1, c="23.9S, 7.4E", l="North East of Hrimbarg" }, { id=2, c="21.8S, 8.7E", l="Behind a wall in Domstoll" }, { id=3, c="20.8S, 5.1E", l="Near the Black Crack (requires a jump)" }, { id=4, c="23.0S, 2.6E", l="North of Gurzmat, in a mountain hollow" }, { id=5, c="20.5S, 3.4W", l="On a small hill" }, { id=6, c="23.4S, 4.3W", l="At the source of the frozen river" }, { id=7, c="23.7S, 2.3W", l="In a corner of the mountain" }, { id=8, c="25.1S, 0.6W", l="At the end of the road" }, { id=9, c="31.4S, 0.4E", l="Behind a rock, in the troll area" }, { id=10, c="28.5S, 4.1E", l="Following the path, against a giant's house" }, { id=11, c="28.3S, 6.7E", l="Towards a small alcove" }, { id=12, c="26.1S, 9.6E", l="In the Ruinuan cellar" } }, rewards={{Rewards.TURBINE, 10}, {Rewards.MARQUE_DONATEUR, 5}, {Rewards.TITLE, "Treasure Seeker of The Misty Mountains"}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Thorin's Hall", 900}}, tag="tag_vault.tga"}
		}}
	}},		
	{name="Forochel", map="10.jpg", region=1, areas={
		{name="Forochel", showme=false, rovingThreatData={loc={{c="16.8N, 86.2W", l="Talvi-Muri"},{c="18.8N, 85.4W", l="Talvi-Muri"},{c="12.7N, 80.3W", l="Talvi-Muri"},{c="10.8N, 79.5W", l="Talvi-Muri"},{c="7.9N, 77.1W", l="Lansi-ma"},{c="8.1N, 76.7W", l="Lansi-ma"},{c="5.5N, 74.5W", l="Lansi-ma"},{c="14.2N, 74.4W", l="Talvi-Muri"},{c="10.5N, 73.0W", l="Ita-ma"},{c="20.6N, 69.4W", l="Suri-kyla"},{c="17.6N, 67.2W", l="Ja-rannit"},{c="12.2N, 66.7W", l="Ja-rannit"}}, pnj="Authi (camp de Glo\195\175n)"},wads={ 
			{id=1010, name="Krevchal, the Brutal Chieftain", subname="krevchal", questname="krevchalthebrutalchieftain", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="771,877", power="36,781", race="Gauradan", adds={{1, "wolf 87K", Difficulty.ELITE}, {2, "wolfs 39K", Difficulty.SIGNATURE}}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="krevchal.tga", enemyType=2},
			{id=1011, name="Mustarka, the Treacherous Wight", subname="mustarka", questname="mustarkathetreacherouswight", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="771,877", race="Wight", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="mustarka.tga", enemyType=2},
			{id=1012, name="Gronkerna, The Juggernaut Slave", subname="gronkerna", questname="gronkernathejuggernautslave", loc="Randomly among:", size=6, level=100, difficulty=Difficulty.NEMESIS, moral="1,061,331", race="Mammoth", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 3}}, frame="gronkerna.tga", enemyType=2},
			{id=1013, name="Ukko Surma, the Undying Giant", subname="ukko", questname="ukkosurmatheundyinggiant", loc="Randomly among:", size=6, level=100, difficulty=Difficulty.NEMESIS, moral="1,061,331", race="Wight", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 3}}, frame="ukkosurma.tga", enemyType=2},
			{id=2004, name="Treasure of Forochel", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=90, poi={ { id=1, c="20.2N, 74.1W", l="On the shore northwest of the boat to Sari-surma" }, { id=2, c="15.7N, 68.1W", l="On an isle in the bay (approach from the east to avoid one-shot areas in the bay)" }, { id=3, c="10.4N, 65.7W", l="Behind large rocks across a snowfield at Ita-ma" }, { id=4, c="12.6N, 69.7W", l="On a bluff near the water north of Pynti-peldot" }, { id=5, c="13.9N, 75.4W", l="Behind the far west ruin in the Lonesome Stones" }, { id=6, c="9.0N, 70.8W", l="Behind a tent in Pynti-leiri" }, { id=7, c="4.9N, 77.3W", l="In a corner near the waterfall" }, { id=8, c="6.2N, 79.6W", l="At the northwestern tip of Kissa-sari" }, { id=9, c="8.0N, 78.9W", l="Under a tent in Norsu-leiri" }, { id=10, c="9.2N, 82.2W", l="In the Winter-worm area northwest of Zigilgund, on the southwestern bank of the channel near the falls" }, { id=11, c="15.6N, 88.2W", l="Along the mountain wall north of Jotunstath" }, { id=12, c="20.1N, 85.2W", l="Atop the west wall at the entrance to Kibilzahar" } }, rewards={{Rewards.TURBINE, 10}, {Rewards.MARQUE_DONATEUR, 5}, {Rewards.TITLE, "Treasure Seeker of Forochel"}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Lossoth of Forochel", 900}}, tag="tag_vault.tga"}
		}}
	}},	
	{name="Evendim", map="12.jpg", region=1, areas={
		{name="Evendim", showme=false, rovingThreatData={loc={{c="6.1S, 73.9W"},{c="16.1S, 75.2W"},{c="18.6S, 70.2W", l="Annuminas"},{c="5.8S, 61.4W", l="Tyrn Fornech"},{c="15.3S, 64.4W", l="Barandalf"},{c="9.0S, 74.1W", l="Emyn Vial"},{c="16.7S, 64.1W", l="Barandalf"},{c="5.0S, 68.4W", l="Tham Habad"}}, pnj="Brangil (Tinnudir)"},wads={ 
			{id=1035, name="Droghus, the Chieftain", subname="droghus", questname="droghusthechieftain", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="849,065", race="Gauradan", adds={{1, "Gauradan 85K", Difficulty.ELITE},{2, "wolfs 31K", Difficulty.SIGNATURE}}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="droghus.tga", enemyType=2},
			{id=1036, name="S\195\187nath, the Treacherous", subname="snath", questname="snaththetreacherous", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="849,065", race="Angmarim", adds={{2, "archers 93K", Difficulty.ELITE}}, rewards={{Rewards.MARQUE_DONATEUR, 1}},  frame="sunath.tga", enemyType=2},
			{id=1037, name="T\195\162rlug, the Servant", subname="trlug", questname="trlugtheservant", loc="Randomly among:", size=6, level=100, difficulty=Difficulty.NEMESIS, moral="1,528,317", race="Troll", adds={{2, "angmarims 112K", Difficulty.ELITE}}, rewards={{Rewards.MARQUE_DONATEUR, 3}},  frame="tarlug.tga", enemyType=2},
			{id=2002, name="Treasure of Evendim", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=90, poi={ { id=1, c="13.8S, 73.6W", l="On a small island southwest of Tyl Ruinen" }, { id=2, c="11.9S, 72.3W", l="In the middle of Tyl Ruinen" }, { id=3, c="8.1S, 75.3W", l="	At the top of Amon Moth" }, { id=4, c="7.5S, 68.3W", l="On the shore just east of Rantost" }, { id=5, c="8.7S, 67.0W", l="Outside the west wall of Tham Ornen" }, { id=6, c="4.2S, 65.6W", l="In some bushes at Tum Fuin" }, { id=7, c="7.9S, 61.8W", l="At the top of the mountain at Nan Orngon" }, { id=8, c="9.4S, 63.0W", l="	Behind the totem at Tham Andalath" }, { id=9, c="15.8S, 69.9W", l="To the left around the edge from the Titan of Tyl Annun" }, { id=10, c="20.2S, 60.7W", l="On the eastern shore of Barandalf" }, { id=11, c="19.7S, 64.6W", l="On a hill behind the Whitshards" }, { id=12, c="17.2S, 65.6W", l="In a small camp behind Haudh Tarcil in Men Erain" } }, rewards={{Rewards.TURBINE, 10}, {Rewards.MARQUE_DONATEUR, 5}, {Rewards.TITLE, "Treasure Seeker of Evendim"}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "The Wardens of Annminas", 900}}, tag="tag_vault.tga"}
		}}
	}},		
	{name="The North Downs", map="13.jpg", region=1, areas={
		{name="The North Downs", showme=false, rovingThreatData={loc={{c="7.0S, 53.6W"},{c="13.8S, 53.1W"},{c="9.7S, 56.2W"},{c="9.6S, 52.3W"},{c="11.0S, 47.3W"},{c="11.4S, 58.4W"},{c="12.2S, 57.9W"},{c="8.7S, 36.2W"},{c="8.2S, 37.4W"},{c="8.2S, 33.0W"}}, pnj="Othwen (Esteldin)"},wads={ 
			{id=1038, name="D\195\187rlum, the Disturbed", subname="drlum", questname="drlumthedisturbed", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="849,065", race="Shade", adds={}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="durlum.tga", enemyType=2},	
			{id=1039, name="Valikas, the Misguided", subname="valikas", questname="valikaslgar", loc="Randomly among:", size=3, level=100, difficulty=Difficulty.NEMESIS, moral="849,065", race="Ogre", adds={{2, "adds 234K", Difficulty.ELITE}}, rewards={{Rewards.MARQUE_DONATEUR, 1}}, frame="valikas.tga", enemyType=2},	
			{id=1040, name="Rotspittle, the Corrupted", subname="rotspittle", questname="rotspittlethecorrupted", loc="Randomly among:", size=6, level=100, difficulty=Difficulty.NEMESIS, moral="1,528,317", race="Drake", adds={}, frame=nil, enemyType=2},	
			{id=2000, name="Treasure of The North Downs", target="TreasureCache", enemyType=3, frame="treasure.tga", size=1, level=90, poi={ { id=1, c="9.9S, 58.4W"}, { id=2, c="6.7S, 53.3W"}, { id=3, c="16.4S, 53.8W", l="Below the bridge" }, { id=4, c="13.7S, 51.6W", l="On a small island" }, { id=5, c="6.9S, 47.9W", l="At the waterfall" }, { id=6, c="19.1S, 46.3W", l="Behind Drukordh's tent" }, { id=7, c="6.0S, 43.5W", l="On a hill in Kamskut" }, { id=8, c="8.6S, 40.1W", l="On a hill north of Rusfold" }, { id=9,  c="16.6S, 37.5W", l="In Zaukil's tent" }, { id=10, c="16.3S, 41.0W", l="Southeast of Taur Gonwaith" }, { id=11, c="15.4S, 36.2W", l="On top of a hill"},{id=12, c="11.2S, 33.7W",l="In a Kar Lak tent"}},rewards={{Rewards.TURBINE, 10}, {Rewards.MARQUE_DONATEUR, 5}, {Rewards.TITLE, "Treasure Seeker of North Downs"}, {Rewards.VERTUES, 2000}, {Rewards.REPUTATION, "Rangers of Esteldin", 900}}, tag="tag_vault.tga"}
		}}
	}},	
	{name="Bree-Lands", region=1, areas={
		{name="Wildwood", map="48.jpg",wads={ 
			{ id=2362, name="Flowers of the Wildwood", target="SUB", enemyType=3, ico="poi.jpg", frame="deed.tga", size=1, level=45, poi={{ id=1, c="22.6S, 58.1W", l="Eyebright", t="Eyebright"}, { id=2, c="23.6S, 63.5W", l="Ragged Robin", t="Ragged Robin"}, { id=3, c="21.8S, 60.1W", l="Teasel", t="Teasel"}, { id=4, c="21.4S, 56.2W", l="Speedwell", t="Speedwell"}, { id=5, c="18.7S, 57.6W", l="Shepherd's Purse", t="ShepherdsPurse" }, { id=6, c="17.2S, 55.4W", l="Wood Spurge", t="Wood Spurge"}, { id=7, c="18.0S, 60.1W", l="Yellow-rattle",t="Yellow-rattle"}, { id=8, c="15.9S, 58.7W", l="Knotted Thistle",t="Knotted Thistle"}}, rewards={{Rewards.TURBINE, 5}, {Rewards.TITLE, "Smeller of Flowers"}, {Rewards.VERTUES, 2000}}, tag="tag_flag.tga"},
			{ id=2363, name="Hidden Threats of the Wildwood", target="SUB", enemyType=3, ico="poiEnnemy.tga", frame="deed.tga", size=1, level=45, poi={{ id=1, c="18.3S, 60.0W", l="Master of the Wildwood", t="MasteroftheWildwood"}, { id=2, c="24.6S, 60.6W", l="Lord of the Stone-den", t="LordoftheStoneden"}, { id=3, c="24.0S, 63.2W", l="Grand Old Wild-tusk", t="GrandOldWildtusk"}, { id=4, c="18.2S, 58.4W", l="Hull the Wolf-hearted", t="HulltheWolfhearted"}, { id=5, c="21.5S, 56.3W", l="Azdag", t="Azdg"}, { id=6, c="17.9S, 59.9W", l="Lagshal Bone-cracker", t="LagshalBonecracker"}, { id=7, c="17.5S, 59.3W", l="Thraumak",t="Thraumak"}, { id=8, m={x=60, y=192}, c="Delf : in the spider area", l="Broghosh",t="Broghosh"},{ id=9, c="16.8S, 58.5W", l="Dulglok",t="Dulglok"},{ id=10, c="23.2S, 62.3W", l="Druhuk",t="Drhuk"}}, rewards={{Rewards.TURBINE, 5}, {Rewards.VERTUES, 2000}}, tag="tag_flag.tga"},			
		}}
	}},	
};

MapsData = {
	["1.jpg"] = {map="1.jpg", name="East Rohan", c={n=35.6, w=-76.5, s=63.0, e=-40.6}},
	["2.jpg"] = {map="2.jpg", name="Wildermore", c={n=28.7, w=-74.8, s=44.3, e=-55.2}},
	["3.jpg"] = {map="3.jpg", name="West Rohan", c={n=43.3, w=-94.0, s=74.4, e=-53.3}},
	["4.jpg"] = {map="4.jpg", name="Western Gondor", c={n=52.2, w=-86.4, s=79.6, e=-50.5}},
	["5.jpg"] = {map="5.jpg", name="The Dead Marshes", c={n=25.5, w=-19.3, s=32.0, e=-10.9}},
	["6.jpg"] = {map="6.jpg", name="Central Gondor", c={n=67.9, w=-55.6, s=88.8, e=-28.8}},
	["7.jpg"] = {map="7.jpg", name="Eastern Gondor", c={n=60.2, w=-32.8, s=85.8, e=-4.4}},
	["8.jpg"] = {map="8.jpg", name="Misty Mountains", c={n=15.6, w=-9.8, s=31.4, e=10.7}},
	["9.jpg"] = {map="9.jpg", name="Angmar", c={n=-13.5, w=-41.0, s=6.9, e=-15.3}},
	["10.jpg"] = {map="10.jpg", name="Forochel", c={n=-23.3, w=-90.9, s=5.2, e=-54.0}},
	["11.jpg"] = {map="11.jpg", name="Southern Mirkwood", c={n=6.0, w=-61.9, s=20.8, e=-42.7}},
	["12.jpg"] = {map="12.jpg", name="Evendim", c={n=1.7, w=-82.6, s=24.3, e=-52.3}},
	["13.jpg"] = {map="13.jpg", name="North Downs", c={n=1.3, w=-60.4, s=22.4, e=-32.2}},
	["14.jpg"] = {map="14.jpg", name="Old Anorien", c={n=44.6, w=-33.9, s=73.7, e=5.0}},
	["15.jpg"] = {map="15.jpg", name="Far Anorien", c={n=33.8, w=-46.7, s=57.8, e=-18.9}},
	["16.jpg"] = {map="16.jpg", name="Minas Tirith", c={n=62.5, w=-22.8, s=68.4, e=-16.3}},
	["17.jpg"] = {map="17.jpg", name="March of the King", c={n=42.3, w=-31.1, s=71.0, e=1.8}},
	["19.jpg"] = {map="19.jpg", name="The Wastes", c={n=26.6, w=-15.2, s=41.2, e=1.4}},
	["21.jpg"] = {map="21.jpg", name="Ered Mithrin", chat="Dwarf-holds", c={n=-45.3, w=-55.0, s=-28.5, e=-35.0}},
	["23.jpg"] = {map="23.jpg", name="Iron hills", chat="Dwarf-holds", c={n=-32.0, w=-19.0, s=-19.4, e=-3.2}},
	["24.jpg"] = {map="24.jpg", name="Vals of Anduin", c={n=-16.7, w=-77.0, s=11.5, e=-47.7}},
	["26.jpg"] = {map="26.jpg", name="Ud\195\187n", c={n=37.3, w=-2.1, s=48.0, e=9.7}},
	["27.jpg"] = {map="27.jpg", name="Lhingris", c={n=46.1, w=1.0, s=64.5, e=21.7}},
	["28.jpg"] = {map="28.jpg", name="Dor Amarth", c={n=38.2, w=7.2, s=52.9, e=26.5}},
	["29.jpg"] = {map="29.jpg", name="Talath \195\154rui", c={n=49.1, w=8.0, s=64.3, e=27.1}},
	["30.jpg"] = {map="30.jpg", name="Agarnaith", c={n=43.1, w=19.6, s=56.6, e=36.1}},
	["32.jpg"] = {map="32.jpg", name="Eryn Lasgalen and the Dale-lands", chat="Northern Mirkwood", c={n=-34.7, w=-52.1, s=-7.8, e=-21.8}},
	["37.jpg"] = {map="37.jpg", name="Mordor Besieged", c={n=89.7, w=-132.2, s=103.0, e=-113.6}},
	["38.jpg"] = {map="38.jpg", name="Cirith Ungol", c={n=-35.7, w=9.6, s=-30.6, e=15.3}},
	["39.jpg"] = {map="39.jpg", name="Minas Morgul", c={n=65.5, w=-0.5, s=69.1, e=3.6}},
	["40.jpg"] = {map="40.jpg", name="Cirith Ungol", c={n=57.5, w=-2.1, s=64.8, e=7.4}},
	["41.jpg"] = {map="41.jpg", name="Rath Duath", c={n=60.5, w=-2.7, s=69.5, e=8.0}},
	["42.jpg"] = {map="42.jpg", name="Thuringwath",c={n=68.5, w=3.4, s=76.7, e=13.}},
	["43.jpg"] = {map="43.jpg", name="Wells of Langflood", c={n=-32.1, w=-67.9, s=-16.8, e=-51.0}},
	["44.jpg"] = {map="44.jpg", name="Elderslade - The gates of Gundabad", c={n=-45.8, w=-73.3, s=-32.5, e=-55.3}},
	["46.jpg"] = {map="46.jpg", name="Felegoth - The palace of the king of the elves", c={n=-49.8, w=-128.6, s=-46.1, e=-124.3}},
	["48.jpg"] = {map="48.jpg", name="Wildwood", c={n=15.1, w=-63.0, s=24.4, e=-53.3}},
	["49.jpg"] = {map="49.jpg", name="Azanulbizar", c={n=-71.5, w=-140.7, s=-62.1, e=-130.7}},
	["50.jpg"] = {map="50.jpg", name="Welkin-lofts", c={n=-50.5, w=-78.9, s=-41.5, e=-69.3}},
	["51.jpg"] = {map="51.jpg", name="C\195\162r Bronach", c={n=-58.1, w=-75.6, s=-45.1, e=-59.0}},
	["52.jpg"] = {map="52.jpg", name="Clovengap", c={n=33.4, w=-127.8, s=43.2, e=-117.7}},
	["53.jpg"] = {map="53.jpg", name="Gloomingtarn", c={n=43.3, w=-125.9, s=50.6, e=-118.0}},
	["54.jpg"] = {map="54.jpg", name="Pit of Stonejaws", c={n=38.0, w=-116.8, s=44.5, e=-109.2}},
	["55.jpg"] = {map="55.jpg", name="Deepscrave", c={n=46.6, w=-120.5, s=52.6, e=-114.4}},
	["56.jpg"] = {map="56.jpg", name="Mttugard", c={n=44.4, w=-116.3, s=51.5, e=-109.7}}	
};